{ͻ
                      M.R.E (MOS RESOURCE EDITOR) v2.4                      
 ͹
               OBTENTION ET CREATION DE SOURCES POUR MOS v2.4               
 ͹
  Coded by Zuul as BouFFtou as Cheveau Frdric.                            
  Programm  Toulouse COG (Gendarmerie) sur Turbo Pascal v7.00.            
  Contact us on 36.15 RTEL1 - Bal "BouFFtou" or Bal "ICF".                  
 ͼ}

{$M 64000,0,655300}                      {*Stack And Heap*}
Program MRE;                             {*Nom du Programme*}

Uses Crt,Dos,Graph,
     MOS_ASM,                            {*Gestion des Instructions ASM*}
     MOS_BAS,
     MOS_MSE,                            {*Gestion de la Souris*}
     MOS_TOO,                            {*Gestion des Tools et Box*}
     MOS_GAD,                            {*Gestion des Gadgets*}
     MOS_REQ,                            {*Gestion des Requesters*}
     MOS_MEN,                            {*Gestion des Menus*}
     MOS_WIN,                            {*Gestion des Fentres*}
     MOS_DIR,                            {*Gestion du Directory*}
     MOS_SYS,                            {*Gestion du Systme*}
     MOS_SB,                             {*Gestion des Sons*}
     MRE_ITEMS,                          {*Gestion des Outils de MOS*}
     MRE_ACTS,                           {*Gestion Action des Boutons*}
     MRE_MENU,                           {*Gestion Cration des Menus*}
     MOS_SWAP;                           {*Gestion Lancement Programmes*}

{ͻ
                        PROCEDURE INIT_TABLEAUX_MENU                        
 ͼ}

Procedure INIT_TABLEAUX_MENU;
Var A:Integer;
Begin
Clear_Menu(M);                           {*Clear Tableaux*}
For A:=1 to 15  do M.TbMen[1,A]:=Loc(399+A);
For A:=1 to 8   do M.TbMen[2,A]:=Loc(414+A);
For A:=1 to 12  do M.TbMen[3,A]:=Loc(422+A);
For A:=13 to 15 do M.TbMen[3,A]:=Loc(736+A);
For A:=1 to 8   do M.TbMen[4,A]:=Loc(434+A);
For A:=1 to 4   do M.TbMen[5,A]:=Loc(442+A);
For A:=1 to 11  do M.TbMen[6,A]:=Loc(446+A);

M.TbMen[7,1]:=Loc(458);
INIT_MENU(M);                           {*Initialise les Structures Menus*}
End;

{ͻ
                     INITIALISE MRE ET LOAD MRE CONFIG                      
 ͼ}

Procedure INIT_MRE;                     {*Initialise MRE Constants*}
Var A:Integer;
Begin
Name_Prog:='TEST_NUMERO_1';             {*Dnominations de Bases*}
Name_Proc:='REQUESTER_001';
Gen_Prog:=On;                           {*Gnration Programme Entier*}
Gen_Rem:=On;                            {*Gnration Remarques*}
Gen_Menu:=Off;                          {*Gnration Menu*}
Opt_Source:=True;                       {*Optimize Source*}
Show_Report:=True;                      {*Show Report when save Source*}
Full_Simul:=True;                       {*Full Simulation when Message*}
Item:=14;                               {*Gadget 14 = Window Tested Now*}
Has_Changed:=No;                        {*Pas de Changements de Base*}
Win_Exist:=Yes;                         {*Fentre Affiche de Base*}
Gad_Exist:=Yes;                         {*Gadgets Affichs de Base*}
Disp_Beep:=No;                          {*No Display Beep on Messages*}
Show_MCoo:=Yes;                         {*Display Mouse Position*}
Grid:=False;                            {*Pas de Grille Gnrale*}
My_Grid:=True;                          {*Grille Personnelle On*}
Pt_Grid:=False;                         {*Grille Pointeur Souris Off*}
Grid_X:=10; Grid_Y:=5;                  {*Offsets Grid*}
NUndo:=1;                               {*Numro de l'Undo*}

Proc_Name:='PROC_001;';                 {*Name of the Procdure to Call*}

QTT_TO_0;                               {*Quantit de Chaque Outils*}
POS_TO_0;                               {*Positions de Chaque Outils*}

For A:=1 to Max_Menu-3 do               {*Nombre de Menus et Labels ds Menu*}
   Qtt_MenuP[A]:=1;
Qtt_Menu:=1;
Clear_Menu(Menu);                       {*Nettoie le menu de Test*}
End;

{ͻ
                        SUPRESSION DU FICHIER UNDO                          
 ͼ}

Procedure KILL_UNDO;
Var Fil:Text;                           {*Fichier UNDO*}
Begin
Assign(Fil,'MRE.U00');
If TEST_FILE_EXIST('MRE.U00') Then Erase(Fil);   {*Vire File UNDO*}
End;

{ͻ
                      GENERATION DE LA SOURCE POUR TP7                      
 ͼ}

Procedure GENERATE_SOURCE;
Var DirSel,FilSel:String;
    Size         :Longint;
    F,F1         :Text;
    S1,S2,S3,S4,                        {*Pour String Gestion*}
    S5,S6,S7,S8,
    S9,SA,SB,SC  :String;
    NUM,A,B      :Integer;
    Offset       :String[10];           {*Pour Completter Ligne*}
    InRem        :Boolean;              {*On est  l'Interieur d'un Rem*}
    X1,Y1,X2,Y2  :String[16];           {*Pour Rajouter W.X1, etc*}
    Ind          :String[16];           {*Pour Rajouter Indentation if Win Exist*}
    VarDef       :Word;                 {*Bits Variables Dfinis*}
    DF           :DirStr;               {*Pour FSplit Generate PROG.INI*}
    NF           :NameStr;
    EF           :ExtStr;

{********************** WRITE GADGET COMMAND DEFINITION *********************}

Procedure WRITE_GADGET_COMMAND(Pos:Integer);
Begin
Writeln(F,'Command(',X1,TCO[Pos].X1 Div LaF,'+',TCO[Pos].X1 Mod LaF,
                 ',',Y1,(TCO[Pos].Y1-HaF1) Div HaF,'+',(TCO[Pos].Y1-HaF1) Mod HaF,
                 ',LaF*',TCO[Pos].T.Siz Div LaF,'+',TCO[Pos].T.Siz Mod LaF,
                 ',',TCO[Pos].T.Len,',',TCO[Pos].T.CoB,',',TCO[Pos].T.Co2,',',TCO[Pos].T.Sty,',$26,Com',Pos,',Cin',Pos,');');
If TCO[Pos].Freeze=On Then Writeln(F,'Freeze_Command(On,Com',Pos,');');
End;

{***************** OBTENTION DU STRING DE TEST DU BOUTON ********************}

Procedure GET_BUTTON_ACTION(Pos:Integer);
Var Up:String;
Begin
Case TBU[Pos].Action of                      {*What Action to do ?*}
     0 : S1:=';';
     1 : S1:='Exit_Flg:=True;';
     2 : S1:=Proc_Name;
     3 : Begin
         If REzV.BCenter=On Then Up:='#0' Else Up:='';
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then Begin',Chr(13),
         '      EZ_RequestG(''',REzV.Title,''',''',Up+REzV.Phrase,''',''',REzV.Gadget,''',Num);');
         If REzV.TestRes=On Then Writeln(F,'      If Num=1 Then Else;');
         Writeln(F,'      End;');
         End;
     4 : Begin
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then ',Chr(13),
         '      Font_RequestG(',RFntV.X1,',',RFntV.Y1,',''',RFntV.Name,''',FontT,FontS);');
         End;
     5 : Begin
         If RStV.BCenter=On Then Up:='#0' Else Up:='';
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then Begin',Chr(13),
         '      String_RequestG(''',RStV.Name,''',''',Up+RStV.Txt,''',''',
                RStV.Gad,''',',RStV.NbChar,',',RStV.Size,',Str1,Num);');
         If RStV.TestRes=True Then Writeln(F,'      If Num=1 Then Else;');
         Writeln(F,'      End;');
         End;
     6 : Begin
         If RVaV.BCenter=On Then Up:='#0' Else Up:='';
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then Begin',Chr(13),
         '      Value_RequestG(''',RVaV.Name,''',''',Up+RVaV.Txt,''',''',
                RVaV.Gad,''',',RVaV.BMin,',',RVaV.BMax,',Val1,Num);');
         If RVaV.TestRes=True Then Writeln(F,'      If Num=1 Then Else;');
         Writeln(F,'      End;');
         End;
     7 : Begin
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then ',Chr(13),
         '      Palette_RequestG(',RPalV.X1,',',RPalV.Y1,',''',RPalV.Name,''',0,Num);');
         End;
     8 : Begin
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then ',Chr(13),
         '      Memory_RequestG(',RMemV.X1,',',RMemV.Y1,',''',RMemV.Name,''');');
         End;
     9 : Begin
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then ',Chr(13),
         '      Hardware_RequestG(',RHardV.X1,',',RHardV.Y1,',''',RHardV.Name,''');');
         End;
     10: Begin
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then Begin');
         Writeln(F,'      CountP:=0;');
         Writeln(F,'      Repeat');
         Writeln(F,'      Main_Task; Str(CountP,CountS);');
         Writeln(F,'      Progress_RequestG(''',RProV.Name,''',''',RProV.Explain,' ''+CountS,CountP,',RProV.Cob,',Pro1);');
         Writeln(F,'      Delay(15); Inc(CountP);');
         Writeln(F,'      Until (Pro1.Abort=True) Or (CountP>100);');
         Writeln(F,'      End;');
         End;

     11: Begin
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then Begin',Chr(13),
         '      DirSel:=''''; FilSel:='''';',Chr(13),'      Get_FileDir(',
         RFileV.X1,',',RFileV.Y1,',',RFileV.Sv,',''',RFileV.Name,''',''',RFileV.OkBut,
         ''',''',RFileV.Mask,''',',RFileV.Style,',DirSel,FilSel,Size);');

         If RFileV.SendToCom=True Then Begin {*Send Results to Commands*}
            If (RFileV.FPath=RFileV.FName) And (RFileV.FName>0) Then Begin
               Write(F,'      Cin',RFileV.FPath,':=DirSel+FilSel; ');
               WRITE_GADGET_COMMAND(RFileV.FPath);
               End Else
               Begin
               If RFileV.FPath>0 Then Begin
                  Write(F,'      Cin',RFileV.FPath,':=DirSel; ');
                  WRITE_GADGET_COMMAND(RFileV.FPath); End;
               If RFileV.FName>0 Then Begin
                  Write(F,'      Cin',RFileV.FName,':=FilSel; ');
                  WRITE_GADGET_COMMAND(RFileV.FName); End;
               If RFileV.FSize>0 Then Begin
                  Write(F,'      Str(Size,Cin',RFileV.FSize,'); ');
                  WRITE_GADGET_COMMAND(RFileV.FSize); End;
               End;
            End;
         Writeln(F,'      End;');
         End;
     12: Begin
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then '+Chr(13)+
         '      Get_Attrib_Bits(',RAttrV.X1,',',RAttrV.Y1,',''',RAttrV.Name,''');');
         End;
     13: Begin
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then '+Chr(13)+
         '      System_RequestG(',RSysV.X1,',',RSysV.Y1,',''',RSysV.Name,''');');
         End;
     14: Begin
         Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then '+Chr(13)+
         '      Register_RequestG;');
         End;
   End;

If TBU[Pos].Action<3                         {*Write Button Test*}
   Then Writeln(F,Ind,'If GetMsg_Button(But',Pos,',1) Then '+S1);
End;

{***************************** CODE PRINCIPAL *******************************}

Begin
DirSel:='';                             {*Directory Courrant*}
FilSel:=Copy(Save_FileName,1,Length(Save_FileName)-3)+'PAS';
Get_FileDir(50,32,282,Loc(459),Loc(460),'*.PAS',0,DirSel,FilSel,Size);

If Test_File_Exist(DirSel+FilSel) Then Begin
   EZ_RequestG(Loc(461),Loc(462),Loc(463),Num);
   If Num<>1 Then Exit;                 {*Fichier dja Existant !!!*}
   End;

If FilSel<>'' Then Begin
   Assign(F,DirSel+FilSel);
   {$I-}
   Rewrite(F);                          {*Crate File*}
   {$I+}
   If IOResult=0 Then Begin             {*No Errors ? => Ok !*}
      Set_Pointer(P_Busy);              {*Pointeur Occup*}
      FSplit(DirSel+FilSel,DF,NF,EF);   {*Gnrate .INI*}
      If Gen_Prog Then Save_Config(NF+'.INI');

      {==== WRITE PROG ENTETE ====}

      If Win_Exist Then Begin X1:=' LaF*'; Y1:=' HaF*'; X2:=' LaF*'; Y2:=' HaF*'; Ind:='   '; End
                   Else Begin X1:=''; Y1:='';X2:='';Y2:=''; Ind:=''; End;

{      If Win_Exist Then Begin X1:=' W1.X1+LaF*'; Y1:=' W1.Y1+HaF1+HaF*';X2:=' W1.X2+LaF*';Y2:=' W1.Y2+HaF*'; Ind:='   '; End
                   Else Begin X1:=''; Y1:='';X2:='';Y2:=''; Ind:=''; End;}

      If Gen_Prog=True Then Begin
      If Odd(Length(Name_Prog))=False Then Offset:=' ' Else Offset:='';
      Writeln(F,'{ͻ');
      Writeln(F,' ',Copy(Esp,1,36-Length(Name_Prog) Div 2),Name_Prog,Copy(Esp,1,38-Length(Name_Prog) Div 2),Offset,'');
      Writeln(F,' ͹');
      Writeln(F,'                GENERATED BY M.R.E (MOS RESOURCE EDITOR) v2.4               ');
      Writeln(F,' ͹');
      Writeln(F,'  Coded by Zuul as BouFFtou as Cheveau Frdric.                            ');
      Writeln(F,'  Source Turbo Pascal v7.00 gnre par MRE (MOS Resource Editor) v2.4.     ');
      Writeln(F,'  Contactez moi sur le 36.15 RTEL1 - Bal "BouFFtou" ou Bal "Sybaris".       ');
      Writeln(F,' ͼ}');
      Writeln(F);
      Writeln(F,'{$M 64000,0,365520}                     {*Stack And Heap*}');
      Writeln(F);
      Writeln(F,'Program ',Name_Prog,';',Copy(Esp,1,31-Length(Name_Prog)),'{*Nom du Programme*}');
      Writeln(F);
      Write  (F,'Uses');
      Offset:='';
      If Qtt_TXT>0 Then Begin Writeln(F,' Graph,                             {*Unit BP7 Graphique*}');
         Offset:='    '; End;

      For A:=1 to Qtt_TBU do
         If (VarDef And $800<>$800) And (TBU[A].Action=10) Then Begin
            Writeln(F,'     Crt,                               {*Unit BP7 Crt*}');
            VarDef:=VarDef Or $800;
            End;

      Writeln(F,Offset,' MOS_BAS,                           {*Gestion des Initialisations*}');
      Writeln(F,'     MOS_ASM,                           {*Gestion Assembleur*}');
      Writeln(F,'     MOS_MSE,                           {*Gestion de la Souris*}');
      Writeln(F,'     MOS_TOO,                           {*Gestion des Outils Graphiques*}');
      If (Qtt_TBB>0) Or (Qtt_TSB>0) Then
      Writeln(F,'     MOS_GAD,                           {*Gestion des Gadgets*}');
      Writeln(F,'     MOS_WIN,                           {*Gestion des Fentres*}');
      Writeln(F,'     MOS_SB,                            {*Gestion de la Sound Blaster*}');
      If Gen_Menu Then Writeln(F,'     MOS_MEN,                           {*Gestion du Menu*}');
      VarDef:=0;                                         {*Affichage Sp TPU*}
      For A:=1 to Qtt_TBU do Begin
         If (VarDef And $800<>$800) And ((TBU[A].Action=11) Or
            (TBU[A].Action=12) Or (TBU[A].Action=13)) Then Begin
            Writeln(F,'     MOS_DIR,                           {*Gestion des Fichiers*}');
            VarDef:=VarDef Or $800;
            End;
         If (VarDef And $1000<>$1000) And (TBU[A].Action=13) Then Begin
            Writeln(F,'     MOS_SYS,                           {*Gestion du Systme*}');
            VarDef:=VarDef Or $1000;
            End;
         End;
      Writeln(F,'     MOS_REQ;                           {*Gestion des Requesters*}');
      Writeln(F);
      End;

      {==== WRITE PROCEDURE ====}

      If Odd(Length(Name_Proc))=False Then Offset:=' ' Else Offset:='';
      Writeln(F,'{ͻ');
      Writeln(F,' ',Copy(Esp,1,36-(Length(Name_Proc)+10) Div 2),'PROCEDURE ',Name_Proc,
                     Copy(Esp,1,38-(Length(Name_Proc)+10) Div 2),Offset,'');
      Writeln(F,' ͼ}');
      Writeln(F);
      Writeln(F,'Procedure ',Name_Proc,';');
      If Win_Exist Then Writeln(F,'Var W1            :Win;                 {*Structure Fentre*}');
      If Win_Exist Then Writeln(F,'    Even          :Byte;                {*Rception Evnements Fentre*}');
      If Win_Exist Then Writeln(F,'    Exit_Flg      :Boolean;             {*Flag de Sortie*}')
                   Else Writeln(F,'Var Exit_Flg      :Boolean;             {*Flag de Sortie*}');
      If Gen_Menu=TRUE Then Writeln(F,'    Menu          :TMenu;               {*Variable Menu*}');
      If Qtt_TBU>0 Then Write(F,'    ');                 {*Write Buttons Var*}

      For A:=1 to Qtt_TBU do Begin
         Write(F,'But',A); If A<Qtt_TBU Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_TBU) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_TBU>0 Then Begin
         If Qtt_TBU Mod 3=0 Then S1:='' Else
                                 S1:=Copy(ESP,1,5*(3-Qtt_TBU Mod 3));
         Writeln(F,S1,':ButG;                {*Structure Boutons*}');
         End;

      If Qtt_TCY>0 Then Write(F,'    ');                 {*Write Cyclers Var*}
      For A:=1 to Qtt_TCY do Begin
         Write(F,'Cyc',A); If A<Qtt_TCY Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_TCY) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_TCY>0 Then Begin
         If Qtt_TCY Mod 3=0 Then S1:='' Else
                                 S1:=Copy(ESP,1,5*(3-Qtt_TCY Mod 3));
         Writeln(F,S1,':ButG;                {*Structure Cyclers*}');
         End;

      If Qtt_TRB>0 Then Write(F,'    ');                 {*Write Radios Var*}
      For A:=1 to Qtt_TRB do Begin
         Write(F,'Rad',A); If A<Qtt_TRB Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_TRB) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_TRB>0 Then Begin
         If Qtt_TRB Mod 3=0 Then S1:='' Else
                                 S1:=Copy(ESP,1,5*(3-Qtt_TRB Mod 3));
         Writeln(F,S1,':Rad;                 {*Structure Radios*}');
         End;

      If Qtt_TSL>0 Then Write(F,'    ');                 {*Write Sliders Var*}
      For A:=1 to Qtt_TSL do Begin
         Write(F,'Sld',A); If A<Qtt_TSL Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_TSL) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_TSL>0 Then Begin
         If Qtt_TSL Mod 3=0 Then S1:='' Else
                                 S1:=Copy(ESP,1,5*(3-Qtt_TSL Mod 3));
         Writeln(F,S1,':Slide;               {*Structure Sliders*}');
         End;

      If Qtt_TCO>0 Then Write(F,'    ');                 {*Write Commands Var*}
      For A:=1 to Qtt_TCO do Begin
         Write(F,'Com',A); If A<Qtt_TCO Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_TCO) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_TCO>0 Then Begin
         If Qtt_TCO Mod 3=0 Then S1:='' Else
                                 S1:=Copy(ESP,1,5*(3-Qtt_TCO Mod 3));
         Writeln(F,S1,':TCoReq;              {*Structure Commands*}');
         End;

      If Qtt_TCO>0 Then Write(F,'    ');                 {*Write Commands Strings*}
      For A:=1 to Qtt_TCO do Begin
         Write(F,'Cin',A); If A<Qtt_TCO Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_TCO) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_TCO>0 Then Begin
         If Qtt_TCO Mod 3=0 Then S1:='' Else
                                 S1:=Copy(ESP,1,5*(3-Qtt_TCO Mod 3));
         Writeln(F,S1,':String;              {*Strings pour Commands*}');
         End;

      {==== WRITE VAR REQUESTERS SPE ====}

      VarDef:=0;
      For A:=1 to Qtt_TBU do Begin    {*Dfinition Var Req Called par Button*}
      If (TBU[A].Action=11) And (VarDef And $800<>$800) Then Begin
         Writeln(F,'    DirSel,FilSel :String;              {*Gestion du Directory*}');
         Writeln(F,'    Size          :Longint;');
         VarDef:=VarDef Or $800; End;
      If ((TBU[A].Action=3) Or (TBU[A].Action=5) Or (TBU[A].Action=7))
         And (VarDef And $80<>$80) Then Begin
         Writeln(F,'    Num           :Integer;             {*Gestion Rponses Requesters*}');
         VarDef:=VarDef Or $80; End;
      If (TBU[A].Action=4) And (VarDef And $100<>$100) Then Begin
         Writeln(F,'    FontT,FontS   :Integer;             {*Gestion Requester de Fontes*}');
         VarDef:=VarDef Or $100; End;
      If (TBU[A].Action=5) Then
         Writeln(F,'    Str1          :String;              {*Gestion du Requester de Strings*}');
      If (TBU[A].Action=6) Then
         Writeln(F,'    Val1          :Longint;             {*Gestion du Requester de Valeurs*}');
      If (TBU[A].Action=10) Then Begin
         Writeln(F,'    Pro1          :TProgress;           {*Gestion du Requester Progress*}');
         Writeln(F,'    CountP        :Byte;');
         Writeln(F,'    CountS        :String[10];');
         End;
      End;
      If Gen_Menu Then
         Writeln(F,'    MS,PS,SS      :Byte;                {*Gestion du Menu*}');

      If Gen_Menu Then Begin                    {*Genration de l'initialisation des Menus*}
      Writeln(F);
      Writeln(F,'{*************************** GENERATION DU MENU *****************************}');
      Writeln(F);
      Writeln(F,'Procedure DECLARE_MENU;');
      Writeln(F,'Begin');
      Writeln(F,'Clear_Menu(Menu);                       {*Prparation tableau Menus*}');
      Writeln(F,'');
      For A:=1 to Qtt_Menu do
         For B:=1 to Qtt_MenuP[A]+1 do
            Writeln(F,'Menu.TbMen[',A,',',B,']:=''',Menu.TbMen[A,B],''';');
      Writeln(F,'');
      Writeln(F,'Init_Menu(Menu);                        {*Initialisation des Menus*}');
      Writeln(F,'End;');
      End;

      Writeln(F);
      Writeln(F,'{************************* AFFICHE CONTENU FENETRE **************************}');
      Writeln(F);
      Writeln(F,'Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}');
      Writeln(F,'Begin');
      Writeln(F,'Clip_Window(On,W1);                     {*Clipping de la Fentre*}');
      For A:=1 to Qtt_TSB do Begin                       {*Write String Boxes*}
         If TSB[A].Cave=True Then S7:='True' Else S7:='False';
         Writeln(F,'String_Box(',X1,TSB[A].X1 Div LaF,'+',TSB[A].X1 Mod LaF,
                             ',',Y1,(TSB[A].Y1-HaF1) Div HaF,'+',(TSB[A].Y1-HaF1) Mod HaF,
                             ',',X1,TSB[A].X2 Div LaF,'+',TSB[A].X2 Mod LaF,
                             ',',Y1,(TSB[A].Y2-HaF1) Div HaF,'+',(TSB[A].Y2-HaF1) Mod HaF,
                             ',',TSB[A].Style,',',TSB[A].Co,',',S7,');');
         End;
      For A:=1 to Qtt_TBB do Begin                       {*Write Bevel Boxes*}
         If TBB[A].Cave=True Then S7:='True' Else S7:='False';
         If TBB[A].Fill=True Then S8:='True' Else S8:='False';
         Writeln(F,'Bevel(',X1,TBB[A].X1 Div LaF,'+',TBB[A].X1 Mod LaF,
                        ',',Y1,(TBB[A].Y1-HaF1) Div HaF,'+',(TBB[A].Y1-HaF1) Mod HaF,
                        ',',X1,TBB[A].X2 Div LaF,'+',TBB[A].X2 Mod LaF,
                        ',',Y1,(TBB[A].Y2-HaF1) Div HaF,'+',(TBB[A].Y2-HaF1) Mod HaF,
                        ',',TBB[A].Style,',',TBB[A].Co,',',S7,',',S8,');');
         End;
      For A:=1 to Qtt_TXT do Begin                       {*Write Texts*}
         Writeln(F,'SetColor(',TXT[A].CP,'); ');
         Writeln(F,'DispG(',X1,TXT[A].X1 Div LaF,'+',TXT[A].X1 Mod LaF,
                        ',',Y1,(TXT[A].Y1-HaF1) Div HaF,'+',(TXT[A].Y1-HaF1) Mod HaF,
                        ',',TXT[A].CB,',''',TXT[A].Cin,''');');
         End;
      Writeln(F);                                        {*Saut de Ligne*}

      For A:=1 to Qtt_TBU do Begin                       {*Write Buttons*}
         Str(TBU[A].SY-4,S1); If TBU[A].SY<>HaF+4 Then Write(F,'HaF:=',S1,'; ');
         If TBU[A].B.Lock=True Then S6:='True' Else S6:='False';
         S7:=TBU[A].B.TCT[1];
         If TBU[A].VanillaKey<>0 Then Insert('_',S7,TBU[A].VanillaKey);
         Write(F,'Button(',X1,TBU[A].X1 Div LaF,'+',TBU[A].X1 Mod LaF,
                       ',',Y1,(TBU[A].Y1-HaF1) Div HaF,'+',(TBU[A].Y1-HaF1) Mod HaF,
                      ',LaF*',TBU[A].SX Div LaF,'+',TBU[A].SX Mod LaF,
                      ',',TBU[A].B.CoP,',',TBU[A].B.CoB,',',S6,',But',A,',''',S7,''');');
         If TBU[A].SY<>HaF+4 Then Writeln(F,' HaF:=10;') Else Writeln(F);
         If TBU[A].Freeze=On Then Writeln(F,'Freeze_Button(On,But',A,');');
         End;
      For A:=1 to Qtt_TCY do Begin                       {*Write Cyclers*}
         If TCY[A].B.Lock=True Then S8:='True' Else S8:='False';
         Writeln(F,'Cycler(',X1,TCY[A].X1 Div LaF,'+',TCY[A].X1 Mod LaF,
                         ',',Y1,(TCY[A].Y1-HaF1) Div HaF,'+',(TCY[A].Y1-HaF1) Mod HaF,
                        ',LaF*',TCY[A].SX Div LaF,'+',TCY[A].SX Mod LaF,
                        ',Cyc',A,'.CyclVal,',TCY[A].B.CoP,',',TCY[A].B.CoB,',Cyc',A,',''',TCY[A].Cin,''');');
         If TCY[A].Freeze=On Then Writeln(F,'Freeze_Cycler(On,Cyc',A,');');
         End;
      For A:=1 to Qtt_TRB do Begin                       {*Write Radios*}
         Writeln(F,'Radio_Box(',X1,TRB[A].X1 Div LaF,'+',TRB[A].X1 Mod LaF,
                            ',',Y1,(TRB[A].Y1-HaF1) Div HaF,'+',(TRB[A].Y1-HaF1) Mod HaF,
                            ',',TRB[A].R.Style,',','Rad',A,'.Status,Rad',A,');');
         If TRB[A].Freeze=On Then Writeln(F,'Freeze_Radio(On,Rad',A,');');
         End;
      For A:=1 to Qtt_TSL do Begin                       {*Write Sliders*}
         If TSL[A].S.GDep=True Then S8:='True' Else S8:='False';
         Writeln(F,'Slider(',X1,TSL[A].X1 Div LaF,'+',TSL[A].X1 Mod LaF,
                         ',',Y1,(TSL[A].Y1-HaF1) Div HaF,'+',(TSL[A].Y1-HaF1) Mod HaF,
                         ',',X1,TSL[A].X2 Div LaF,'+',TSL[A].X2 Mod LaF,
                         ',',Y1,(TSL[A].Y2-HaF1) Div HaF,'+',(TSL[A].Y2-HaF1) Mod HaF,
                         ',',TSL[A].S.Qtt,',',TSL[A].S.Aff,',',TSL[A].S.Typ,',',S8,',Sld',A,',Sld',A,'.Psl);');
         End;
      For A:=1 to Qtt_TCO do WRITE_GADGET_COMMAND(A);    {*Write Commands*}

      Writeln(F,'Clip_Window(Off,W1);                    {*Restore le Clipping Normal*}');
      Writeln(F,'End;');                                 {*Fin Procdure Init*}
      Writeln(F);

      Writeln(F,'{************************** PROCEDURE PRINCIPALE ****************************}');
      Writeln(F);
      Writeln(F,'Begin');
      If Win_Exist Then Begin                       {*Init Window if Exist*}
         S5:='$'+Word_To_String(W.IDCMP);
         Writeln(F,'Init_Window(',W.X1,',',W.Y1,',',W.X1,'+LaF*',(W.X2-W.X1) Div LaF,'+',
                   (W.X2-W.X1) Mod LaF,',',W.Y1,'+HaF1+HaF*',(W.Y2-W.Y1-HaF1) Div HaF,'+',
                   (W.Y2-W.Y1-HaF1) Mod HaF,',',S5,',',Chr(39),W.Name,Chr(39),',W1);');
         SB:='$'+Word_To_String(W.IDRES);
         Writeln(F,'Sup_Window(',W.Xu,',',W.Yu,',',W.Xv,',',W.Yv,',',
                 W.XMin,',',W.YMin,',',W.XMax,',',W.YMax,',',W.BarSld,',',W.Coul,',',SB,',W1);{*Supplment*}');
         Writeln(F,'If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}');
         Writeln(F,'Draw_Window(W1);                        {*Affiche la Fentre*}');
         Writeln(F);
         End;

      VarDef:=0;
      For A:=1 to Qtt_TBU do Begin                  {*Init String Requester*}
         If (TBU[A].Action=5) And (VarDef And $100<>$100) Then Begin
            Writeln(F,'Str1:=''',RStV.Str,''';');
            VarDef:=VarDef Or $100; End;            {*Init Value Requester*}
         If (TBU[A].Action=6) And (VarDef And $200<>$200) Then Begin
            Writeln(F,'Val1:=',RVaV.Vai,';');
            VarDef:=VarDef Or $200; End;
         End;
      For A:=1 to Qtt_TCY do                        {*Init Cyclers Positions*}
         Writeln(F,'Cyc',A,'.CyclVal:=',TCY[A].B.CyclVal,';');
      For A:=1 to Qtt_TRB do                        {*Init Radios Positions*}
         Writeln(F,'Rad',A,'.Status:=',TRB[A].R.Status,';');
      For A:=1 to Qtt_TSL do                        {*Init Sliders Positions*}
         Writeln(F,'Sld',A,'.Psl:=',TSL[A].S.Psl,';');
      For A:=1 to Qtt_TCO do                        {*Init Commands Labels*}
         Writeln(F,'Cin',A,':=''',TCO[A].T.Cin,''';');
      If (Qtt_TCY>0) Or (Qtt_TRB>0) Or (Qtt_TSL>0) Or (Qtt_TCO>0) Then Writeln(F);{*Saute Ligne*}

      If Gen_Menu Then Writeln(F,'DECLARE_MENU;                           {*Dfinit le Menu*}');{*Pour Initialiser le Menu*}
      Writeln(F,'REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}');
      Writeln(F,'Exit_Flg:=False;                        {*Init Flag de Sortie*}');
      Writeln(F);
      Writeln(F,'Repeat;');
      Writeln(F,'Main_Task;                              {*Gre Systme*}');
      If Win_Exist Then Begin
         Writeln(F,'If Window_Ready(W1) Then                {*Teste si Fentre Prte*}');
         Writeln(F,'   Begin                                {*Test des Gadgets Personnels*}');
         Writeln(F,'   Clip_Window(On,W1);                  {*Clipping de la Fentre*}');
         End;
      For A:=1 to Qtt_TBU do GET_BUTTON_ACTION(A);  {*Write Button Test*}

      For A:=1 to Qtt_TCY do                        {*Write Cycler Test*}
         Writeln(F,Ind,'GetMsg_Button(Cyc',A,',1);');
      For A:=1 to Qtt_TRB do                        {*Write Radio Test*}
         Writeln(F,Ind,'GetMsg_Radio(Rad',A,',1);');
      For A:=1 to Qtt_TCO do                        {*Write Command Test*}
         Writeln(F,Ind,'GetMsg_Command(Com',A,',Cin',A,');');
      For A:=1 to Qtt_TSL do Begin                  {*Write Slider Test*}
         If TSL[A].S.Psl=0 Then Writeln(F,Ind,'GetMsg_Slider(Sld',A,',1);')
            Else Begin
            Writeln(F,Ind,'If GetMsg_Slider(Sld',A,',1)=Yes Then Begin');
            Write(F,Ind,'   Str(Sld',A,'.Psl,Cin',RSldV[A].ComNum,'); ');
            WRITE_GADGET_COMMAND(RSldV[A].ComNum);  {*Reinit Command*}
            Writeln(F,Ind,'   End;');
            End;
         End;
      If Win_Exist Then Begin                       {*Gre Window if Exist*}
         Writeln(F,'   Clip_Window(Off,W1);                 {*Restore le Clipping Normal*}');
         Writeln(F,'   End;');                      {*Fin Test if Win Exist*}

      If Gen_Menu Then Begin                        {*Gneration code test Menu*}
         Writeln(F);
         Writeln(F,'Test_Menu(Menu,Col[1],Col[15],MS,PS,SS);{*Test du Menu*}');
         Writeln(F,'Case MS of');
         For A:=1 to Qtt_Menu do Begin
         Writeln(F,'   ',A,': Case PS of                        {*Test des points du menu ',A,'*}');
            For B:=1 to Qtt_MenuP[A] do Begin
               Writeln(F,'      ',B,': ;');
               End;
            Writeln(F,'      End;');
            End;
         Writeln(F,'   End;');
         End;

         Writeln(F);
         Writeln(F,'Even:=Active_Window(W1);');
         Writeln(F,'If Even=1 Then Exit_Flg:=True;          {*Fentre Ferme => Exit*}');
         If W.IDCMP And $2=$2 Then Writeln(F,'If Even=3 Then REDRAW_FRAME;'+
                    '            {*Fentre Extend => Rafficher Contenu*}');
         If W.IDCMP And $4=$4 Then Writeln(F,'If Even=4 Then REDRAW_FRAME;'+
                    '            {*Fentre Resize => Rafficher Contenu*}');
         Writeln(F,'If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}');
{*         Writeln(F,'If Even=10 Then REDRAW_FRAME;           {*Fonte Modifie => Rafficher Contenu');*}
         End;
      Writeln(F,'Until Exit_Flg=True;                    {*Flag de Sortie*}');
      Writeln(F);
      If Win_Exist Then Writeln(F,'Kill_Window(W1);                        {*Supprime Fentre*}');
      Writeln(F,'End;');
      Writeln(F);

      {==== WRITE PROG PRINCIPAL ====}

      If Gen_Prog=True Then Begin
      Writeln(F,'{ͻ');
      Writeln(F,'                     PROGRAMME PRINCIPAL (INITIALISATIONS)                  ');
      Writeln(F,' ͼ}');
      Writeln(F);
      Writeln(F,'Begin');
      Writeln(F,'INIT_ASM;                               {*Initialise Bases Hardware*}');
      Writeln(F,'INIT_SOUND;                             {*Initialise Sons*}');
      Writeln(F,'INIT_MOUSE;                             {*Initialise Souris*}');
      Writeln(F,'INIT_SCREEN;                            {*Initialise Ecran*}');
      Writeln(F);
      Writeln(F,'Oldexit:=ExitProc;                      {*Dtourne les erreurs*}');
      Writeln(F,'SetJump(MyAddr);');
      Writeln(F,'ExitProc:=@ENTRY_INT24;');
      Writeln(F);
      Writeln(F,Name_Proc,';',Copy(Esp,1,39-Length(Name_Proc)),'{*Appel Procdure Principale*}');
      Writeln(F,'Main_Task;                              {*Erreurs Rsiduelles ?*}');
      Writeln(F);
      Writeln(F,'DONE_SCREEN;                            {*Restaure Ecran*}');
      Writeln(F,'DONE_MOUSE;                             {*Restaure Souris*}');
      Writeln(F,'DONE_SOUND;                             {*Restaure Sons*}');
      Writeln(F,'DONE_ASM;                               {*Restaure Bases Hardware*}');
      Writeln(F,'End.');
      End;
      Close(F);                         {*Ferme le Fichier*}

      {==== DELETE COMMENTS IF NEEDS ====}

      If Gen_Rem=Off Then Begin         {*Sucre Comments ?*}
         InRem:=Off;                    {*Init Bool Interieur d'un Rem*}
         Assign(F,DirSel+FilSel);
         Assign(F1,DirSel+'MRE.TMP');
         {$I-}
         Reset(F);                      {*Rouvre le Fichier*}
         Rewrite(F1);                   {*Crer Fichier Temporaire*}
         {$I+}
         If IOResult=0 Then             {*No Errors ? => Ok !*}
            Begin
            While Not Eof(F) do Begin
               Readln(F,S1); A:=Pos('{',S1);{*Search Begin Comments*}
               If Copy(S1,A,2)='{$' Then A:=0;{*Ce n'est pas un Comment*}
               If A>0 Then Begin InRem:=On;{*Write First Line With Rem*}
                  If A-1>0 Then Writeln(F1,Copy(S1,1,A-1));
                  End;
               If InRem=Off Then Writeln(F1,S1);
               A:=Pos('}',S1);          {*Search End Comments*}
               If A>0 Then InRem:=Off;  {*Fin des Commentaires*}
               End;
            Close(F);                   {*Ferme Fichier Source - Lecture*}
            Close(F1);                  {*Ferme Fichier Temporaire*}
            Erase(F);                   {*Sucre Old File With Comments*}
            Rename(F1,DirSel+FilSel);   {*Rename New File*}
            End;
         End;

      {==== OPTIMIZE SOURCE IF NEEDS ====}

      If Opt_Source=On Then Begin       {*Optimize Source ?*}
         Assign(F,DirSel+FilSel);
         Assign(F1,DirSel+'MRE.TMP');
         {$I-}
         Reset(F); S3:='';              {*Rouvre le Fichier*}
         Rewrite(F1);                   {*Crer Fichier Temporaire*}
         {$I+}
         If IOResult=0 Then             {*No Errors ? => Ok !*}
            Begin
            While Not Eof(F) do Begin
               Readln(F,S1);
               A:=Pos('+0',S1); If A>0 Then Delete(S1,A,2);{*Sucre "+0"*}
               A:=Pos('+0',S1); If A>0 Then Delete(S1,A,2);{*Sucre "+0" en plus*}
               A:=Pos('+0',S1); If A>0 Then Delete(S1,A,2);{*Sucre "+0" en plus*}
               A:=Pos('SetColor(',S1); B:=Pos(');',S1);
               If A>0 Then Begin
                  S2:=S3; A:=0;
                  If S2=Copy(S1,A+10,2) Then Begin  {*Sucre SetColor Useless*}
                     S3:=Copy(S1,A+10,2); Delete(S1,A,B-A+3); A:=1;
                     End Else S3:=Copy(S1,A+10,2);  {*Lecture Num Couleur*}
                  End;
               If A=0 Then Writeln(F1,S1);          {*Write New Line Epured*}
               End;
            Close(F);                   {*Ferme Fichier Source - Lecture*}
            Close(F1);                  {*Ferme Fichier Temporaire*}
            Erase(F);                   {*Sucre Old File*}
            Rename(F1,DirSel+FilSel);   {*Rename New File*}
            End;
         End;

      {==== SHO REPORTS IF NEEDS ====}

      If Show_Report=On Then Begin       {*Show Report ?*}
         S1:=''; S2:=''; S3:='';
         If Opt_Source Then S1:=Loc(464);
         If Gen_Rem=On Then S2:=Loc(465);
         If Gen_Prog   Then S3:=Loc(466);
         EZ_REQUESTG(LOc(461),Loc(467)+S2+S1+S3,Loc(24),NUM);
         End;

      Set_Pointer(P_Current);           {*Normal Pointer*}
      End
      Else EZ_REQUESTG(Loc(461),Loc(468),Loc(469),NUM);
   End;
End;

{ͻ
                         CHARGEMENT PROJET EN DATAS                         
  MODE....: 0 = Normal (Demande de nom), 1 = Load Undo.                     
 ͼ}

Procedure LOAD_PROJECT(Mode:Byte);
Var DirSel,FilSel:String;
    Size         :Longint;
    F            :Text;
    St           :String;               {*Pour Lecture*}
    NUM,A,B,Code :Integer;
    DelY         :Word;                 {*Taille Y Fonte en Pixels*}

Begin
If (Has_Changed=True) And (Mode=0) Then Begin
   EZ_REQUESTG(Loc(461),Loc(470)+Loc(471),Loc(472),NUM);
   If NUM=3 Then Exit;
   If NUM=1 Then SAVE_PROJECT(0);       {*Sauvegarde Project Before*}
   End;

DirSel:='';
If Mode=0 Then Begin
   FilSel:='';                          {*Directory Courant*}
   Get_FileDir(50,32,282,Loc(473),Loc(474),'*.MRE',0,DirSel,FilSel,Size);
   End Else FilSel:=Nom_Undo;           {*Load Undo = Nom du Fichier pour Undo*}
If FilSel<>'' Then Begin
   Assign(F,DirSel+FilSel);
   {$I-}
   Reset(F);                            {*Open File*}
   {$I+}
   If IOResult=0 Then Begin             {*No Errors ? => Ok !*}
{      KILL_UNDO;                        {*Vire Fichier UNDO*}
      Save_FileName:=FilSel;            {*Keep Save FileName*}
      Readln(F,St);
      If (Pos('MRE v2.4',St)>0) And (Pos('data file.',St)>0) Then Begin
         Kill_Window(W);                {*Sucre Fentre Prcdente*}
         Set_Pointer(P_Busy);
         Readln(F); Readln(F); Readln(F);
         Show_Screen;                   {*Raffiche le fond de l'cran*}
         Gad_Exist:=True;               {*Gadgets Existent*}
         M.TbMen[7,1]:='Project: '''+FilSel+'''';

         QTT_TO_0;                      {*Rinit Quantit de Chaque Outils*}

         Readln(F,Name_Prog);           {*Lecture Source Prefs*}
         Readln(F,Name_Proc);
         Readln(F,St); If Upper(St)='TRUE' Then Gen_Prog:=On Else Gen_Prog:=Off;
         Readln(F,St); If Upper(St)='TRUE' Then Gen_Rem:=On Else Gen_Rem:=Off;
         Readln(F,St); If Upper(St)='TRUE' Then Opt_Source:=On Else Opt_Source:=Off;
         Readln(F,St); If Upper(St)='TRUE' Then Show_Report:=On Else Show_Report:=Off;
         Readln(F,St); If Upper(St)='TRUE' Then Full_Simul:=On Else Full_Simul:=Off;
         Readln(F,DelY);
         Readln(F);

         DelY:=HaF1-DelY;               {*Calcule Delta Y pour Pos Y Gadgets*}

         Readln(F,St);                  {*Read Window Parameters*}
         If St='1' Then Begin
            Readln(F,W.X1);
            Readln(F,W.Y1);
            Readln(F,W.X2);
            Readln(F,W.Y2); Inc(W.Y2,DelY);
            Readln(F,W.IDCMP);
            Readln(F,W.Name);
            Init_Window(W.X1,W.Y1,W.X2,W.Y2,W.IDCMP,W.Name,W);
            Readln(F,W.Xu);
            Readln(F,W.Yu);
            Readln(F,W.Xv);
            Readln(F,W.Yv);
            Readln(F,W.XMin);
            Readln(F,W.YMin);
            Readln(F,W.XMax);
            Readln(F,W.YMax);
            Readln(F,W.BarSld);
            Readln(F,W.Coul);
            Readln(F,W.IDRES);
            Readln(F,St);
            Readln(F);
            Sup_Window(W.Xu,W.Yu,W.Xv,W.Yv,W.Xmin,W.YMin,W.XMax,W.YMax,W.BarSld,W.Coul,W.IDRES,W);
            Win_Exist:=True;
            Set_ID_Menu(M,4,1,$00);     {*Active Options Menu Window Exist*}
            Set_ID_Menu(M,4,2,$00);
            Set_ID_Menu(M,4,3,$00);
            Set_ID_Menu(M,4,5,$00);
            Set_ID_Menu(M,4,6,$01);
            Set_ID_Menu(M,4,7,$10);
            End
            Else Begin For A:=1 to 19 do Readln(F);{*Skip Window*}
            Win_Exist:=False;
            Set_ID_Menu(M,4,1,$01);     {*Active Options Menu No Window*}
            Set_ID_Menu(M,4,2,$01);
            Set_ID_Menu(M,4,3,$01);
            Set_ID_Menu(M,4,5,$01);
            Set_ID_Menu(M,4,6,$00);
            Set_ID_Menu(M,4,7,$11);
            End;

         Readln(F,St); Val(St,Qtt_TBB,Code);
         For A:=1 to Qtt_TBB do Begin   {*Read Bevel Boxes Parameters*}
         Readln(F,TBB[A].X1);
         Readln(F,TBB[A].Y1); Inc(TBB[A].Y1,DelY);
         Readln(F,TBB[A].X2);
         Readln(F,TBB[A].Y2); Inc(TBB[A].Y2,DelY);
         Readln(F,TBB[A].Style);
         Readln(F,TBB[A].Co);
         Readln(F,St); If Upper(St)='TRUE' Then TBB[A].Cave:=True Else TBB[A].Cave:=False;
         Readln(F,St); If Upper(St)='TRUE' Then TBB[A].Fill:=True Else TBB[A].Fill:=False;
         End;
         Readln(F);

         Readln(F,St); Val(St,Qtt_TSB,Code);
         For A:=1 to Qtt_TSB do Begin   {*Read String Boxes Parameters*}
         Readln(F,TSB[A].X1);
         Readln(F,TSB[A].Y1); Inc(TSB[A].Y1,DelY);
         Readln(F,TSB[A].X2);
         Readln(F,TSB[A].Y2); Inc(TSB[A].Y2,DelY);
         Readln(F,TSB[A].Style);
         Readln(F,TSB[A].Co);
         Readln(F,St); If Upper(St)='TRUE' Then TSB[A].Cave:=True Else TSB[A].Cave:=False;
         End;
         Readln(F);

         Readln(F,St); Val(St,Qtt_TXT,Code);
         For A:=1 to Qtt_TXT do Begin   {*Read Texts Parameters*}
         Readln(F,TXT[A].X1);
         Readln(F,TXT[A].Y1); Inc(TXT[A].Y1,DelY);
         Readln(F,TXT[A].CB);
         Readln(F,TXT[A].CP);
         Readln(F,TXT[A].Cin);
         End;
         Readln(F);

         Readln(F,St); Val(St,Qtt_TBU,Code);
         For A:=1 to Qtt_TBU do Begin   {*Read Buttons Parameters*}
         Readln(F,TBU[A].X1);
         Readln(F,TBU[A].Y1); Inc(TBU[A].Y1,DelY);
         Readln(F,TBU[A].SX);
         Readln(F,TBU[A].SY);
         Readln(F,St); If Upper(St)='TRUE' Then TBU[A].Freeze:=True Else TBU[A].Freeze:=False;
         Readln(F,TBU[A].B.CoB);
         Readln(F,TBU[A].B.CoP);
         Readln(F,St); If Upper(St)='TRUE' Then TBU[A].B.Lock:=True Else TBU[A].B.Lock:=False;
         Readln(F,TBU[A].VanillaKey);
         Readln(F,TBU[A].Action);
         Readln(F,TBU[A].B.TCT[1]);
         End;
         Readln(F);

         Readln(F,St); Val(St,Qtt_TCY,Code);
         For A:=1 to Qtt_TCY do Begin   {*Read Cyclers Parameters*}
         Readln(F,TCY[A].X1);
         Readln(F,TCY[A].Y1); Inc(TCY[A].Y1,DelY);
         Readln(F,TCY[A].SX);
         Readln(F,TCY[A].SY);
         Readln(F,TCY[A].B.CyclVal);
         Readln(F,TCY[A].B.CoB);
         Readln(F,TCY[A].B.CoP);
         Readln(F,St); If Upper(St)='TRUE' Then TCY[A].B.Lock:=True Else TCY[A].B.Lock:=False;
         Readln(F,St); If Upper(St)='TRUE' Then TCY[A].Freeze:=True Else TCY[A].Freeze:=False;
         Readln(F,TCY[A].Cin);
         End;
         Readln(F);

         Readln(F,St); Val(St,Qtt_TRB,Code);
         For A:=1 to Qtt_TRB do Begin   {*Read Radios Parameters*}
         Readln(F,TRB[A].X1);
         Readln(F,TRB[A].Y1); Inc(TRB[A].Y1,DelY);
         Readln(F,TRB[A].R.Style);
         Readln(F,St); If Upper(St)='TRUE' Then TRB[A].R.Status:=True Else TRB[A].R.Status:=False;
         Readln(F,St); If Upper(St)='TRUE' Then TRB[A].Freeze:=True Else TRB[A].Freeze:=False;
         Readln(F,TRB[A].Group);
         End;
         Readln(F);

         Readln(F,St); Val(St,Qtt_TSL,Code);
         For A:=1 to Qtt_TSL do Begin   {*Read Sliders Parameters*}
         Readln(F,TSL[A].X1);
         Readln(F,TSL[A].Y1); Inc(TSL[A].Y1,DelY);
         Readln(F,TSL[A].X2);
         Readln(F,TSL[A].Y2); Inc(TSL[A].Y2,DelY);
         Readln(F,TSL[A].S.Qtt);
         Readln(F,TSL[A].S.Aff);
         Readln(F,TSL[A].S.Psl);
         Readln(F,TSL[A].S.Typ);
         Readln(F,St); If Upper(St)='TRUE' Then TSL[A].S.GDep:=True Else TSL[A].S.GDep:=False;
         End;
         Readln(F);

         Readln(F,St); Val(St,Qtt_TCO,Code);
         For A:=1 to Qtt_TCO do Begin   {*Read Commands Parameters*}
         Readln(F,TCO[A].X1);
         Readln(F,TCO[A].Y1); Inc(TCO[A].Y1,DelY);
         Readln(F,TCO[A].T.Siz);
         Readln(F,TCO[A].T.Len);
         Readln(F,TCO[A].T.CoB);
         Readln(F,TCO[A].T.Co2);
         Readln(F,TCO[A].T.Sty);
         Readln(F,St); If Upper(St)='TRUE' Then TCO[A].Freeze:=True Else TCO[A].Freeze:=False;
         Readln(F,TCO[A].Cin);
         End;
         Readln(F);

         {============================================================}

         Readln(F,Proc_Name);           {*Lecture Nom Proc  Appeller*}
         Readln(F);

         Readln(F,RFileV.X1);           {*Read File Requester Values*}
         Readln(F,RFileV.Y1);
         Readln(F,RFileV.Sv);
         Readln(F,RFileV.Name);
         Readln(F,RFileV.OkBut);
         Readln(F,RFileV.Mask);
         Readln(F,RFileV.Style);
         Readln(F,RFileV.FPath);
         Readln(F,RFileV.FName);
         Readln(F,RFileV.FSize);
         Readln(F,St); If Upper(St)='TRUE' Then RFileV.SendToCom:=True Else RFileV.SendToCom:=False;
         Readln(F);

         Readln(F,RPalV.X1);            {*Read Palette Requester Values*}
         Readln(F,RPalV.Y1);
         Readln(F,RPalV.Name);
         Readln(F,RPalV.ColSel);
         Readln(F);

         Readln(F,RMemV.X1);            {*Read Memory Requester Values*}
         Readln(F,RMemV.Y1);
         Readln(F,RMemV.Name);
         Readln(F);

         Readln(F,RHardV.X1);           {*Read Hardware Requester Values*}
         Readln(F,RHardV.Y1);
         Readln(F,RHardV.Name);
         Readln(F);

         Readln(F,St); If Upper(St)='TRUE' Then RSysV.SMosIni:=True Else RSysV.SMosIni:=False;
         Readln(F,RSysV.X1);            {*Read System Requester Values*}
         Readln(F,RSysV.Y1);
         Readln(F,RSysV.Name);
         Readln(F);

         Readln(F,REzV.Title);          {*Read EZ Requester*}
         Readln(F,REzV.Phrase);
         Readln(F,REzV.Gadget);
         Readln(F,St); If Upper(St)='TRUE' Then REzV.TestRes:=True Else REzV.TestRes:=False;
         Readln(F,St); If Upper(St)='TRUE' Then REzV.BCenter:=True Else REzV.BCenter:=False;
         Readln(F);

         Readln(F,RFntV.X1);            {*Read Font Requester*}
         Readln(F,RFntV.Y1);
         Readln(F,RFntV.Name);
         Readln(F,RFntV.Font_Sel);
         Readln(F,RFntV.Size_Sel);
         Readln(F);

         Readln(F,RAttrV.X1);           {*Read Attrib Requester*}
         Readln(F,RAttrV.Y1);
         Readln(F,RAttrV.Name);
         Readln(F);

         Readln(F,RStV.Name);           {*Read String Requester*}
         Readln(F,RStV.Txt);
         Readln(F,RStV.Gad);
         Readln(F,RStV.Str);
         Readln(F,RStV.NbChar);
         Readln(F,RStV.Size);
         Readln(F,St); If Upper(St)='TRUE' Then RStV.TestRes:=True Else RStV.TestRes:=False;
         Readln(F,St); If Upper(St)='TRUE' Then RStV.BCenter:=True Else RStV.BCenter:=False;
         Readln(F);

         Readln(F,RVaV.Name);           {*Read Value Requester*}
         Readln(F,RVaV.Txt);
         Readln(F,RVaV.Gad);
         Readln(F,RVaV.BMin);
         Readln(F,RVaV.BMax);
         Readln(F,RVaV.Vai);
         Readln(F,St); If Upper(St)='TRUE' Then RVaV.TestRes:=True Else RVaV.TestRes:=False;
         Readln(F,St); If Upper(St)='TRUE' Then RVaV.BCenter:=True Else RVaV.BCenter:=False;
         Readln(F);

         Readln(F,RProV.Name);          {*Read Progress Requester*}
         Readln(F,RProV.Explain);
         Readln(F,RProV.Cob);
         Readln(F);

         For A:=1 to Max_TSL do Readln(F,RSldV[A].ComNum);
         Readln(F);                     {*Read Command to Slider*}

         {============================================================}

                                        {*Lecture des Paramtres du Menu*}
         Readln(F,St); If Upper(St)='TRUE' Then Gen_Menu:=True Else Gen_Menu:=False;
         Readln(F,Qtt_Menu);            {*Read Qtt Menus*}
         For A:=1 to Qtt_Menu do Readln(F,Qtt_MenuP[A]);{*Read Qtt Menu Labels*}
         Readln(F);

         For A:=1 to Qtt_Menu do
            For B:=1 to Qtt_MenuP[A]+1 do
               Readln(F,Menu.TbMen[A,B]);
         Readln(F);

         {============================================================}

         POS_TO_0;                      {*Rinit Positions Chaque Outils*}

         Has_Changed:=False;            {*Rinit Modifications Potentielles*}
         WSizeX:=W.X2-W.X1; WSizeY:=W.Y2-W.Y1;

         REDRAW_WINDOW;                 {*Raffiche le Contenu de Window*}
         Set_Pointer(P_Current);
         End
         Else EZ_REQUESTG(Loc(461),Loc(475),Loc(476),NUM);
      Close(F);                         {*Ferme le Fichier*}
      End
      Else EZ_REQUESTG(Loc(461),Loc(477),Loc(476),NUM);
   End;
End;

{ͻ
                           PROCEDURE UNDO_ACTION                            
 ͼ}

Procedure UNDO_ACTION;                  {*Undo Action*}
Var Num:Integer;
Begin
Nom_Undo:='MRE.U00';                    {*Nom du Fichier Undo*}
If Not(TEST_FILE_EXIST(Nom_Undo)) Then Begin
   EZ_RequestG(Loc(461),Loc(478),Loc(24),Num);
   Exit; End;
LOAD_PROJECT(1);                        {*Reload Previous Datas*}
End;

{ͻ
                            PROCEDURE SET_GRID                              
 ͼ}

Procedure SET_GRID;
Var W1            :Win;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :ButG;                {*Structure Boutons*}
    Rad1,Rad2     :Rad;                 {*Structure Radios*}
    Com1,Com2     :TCoReq;              {*Structure Commands*}
    Cin1,Cin2     :String;              {*Strings pour Commands*}
    Code          :Integer;             {*Pour Tranformer avec Val*}
    Cancel        :Boolean;             {*Annulation Modifications*}
    X,Y           :Word;                {*Pour Conversion Grid*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);
String_Box(LaF*4,  HaF*2+6, LaF*46,  HaF*10,1,6,False);
String_Box(LaF*12, HaF*1+6, LaF*38,  HaF*3+1,1,3,False);
String_Box(LaF*4+1,HaF*11+2,LaF*45+4,HaF*13+5,1,6,False);
SetColor(15); DispG( LaF*17, HaF*1+8,3,Loc(128));
SetColor(0);
DispG(LaF*12, HaF*4+2,6,Loc(479));
DispG(LaF*12, HaF*6+2,6,Loc(480));
DispG(LaF*12, HaF*8+2,6,Loc(481));
DispG(LaF*12, HaF*11+7,6,Loc(482));

Button( LaF*8, HaF*15+1,LaF*14,0,7,False,But1,'_OK');
Button( LaF*28,HaF*15+1,LaF*14,0,7,False,But2,Loc(13));
Command(LaF*34,HaF*6+2, LaF*6,10,2,1,0,$26,Com1,Cin1);
Command(LaF*34,HaF*8+2, LaF*6,10,2,1,0,$26,Com2,Cin2);
Radio_Box(LaF*34, HaF*4+1,1,Rad1.Status,Rad1);
Radio_Box(LaF*34, HaF*11+6,1,Rad2.Status,Rad2);
Freeze_Radio(On,Rad2);
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Init_Window(120,60,120+LaF*50,60+HaF1+HaF*17+1,$51D9,Loc(483),W1);
Sup_Window(100,50,250,200,59,50,500,250,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Rad1.Status:=My_Grid;                   {*Status Grille*}
Rad2.Status:=Pt_Grid;
Str(Grid_X,Cin1); Str(Grid_Y,Cin2);

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}

Set_Pointer(P_Current);                 {*Pointeur Souris Normal*}
Exit_Flg:=Off; Cancel:=Off;             {*Init Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   If GetMsg_Button(But1,1)=True Then Exit_Flg:=True;
   If GetMsg_Button(But2,1)=True Then Cancel:=On;
   GetMsg_Radio(Rad1,1);
   GetMsg_Radio(Rad2,1);
   GetMsg_Command(Com1,Cin1);
   GetMsg_Command(Com2,Cin2);
   End;

Even:=Active_Window(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Supprime Fentre*}

If Cancel=Off Then Begin                {*Save Values dans Paramtres*}
   CREATE_UNDO;                         {*Cr un Fichier UNDO*}
   My_Grid:=Rad1.Status; Pt_Grid:=Rad2.Status;
   Val(Cin1,Grid_X,Code); Val(Cin2,Grid_Y,Code);
   End;
End;

{ͻ
                         SET/UNSET OLD CADRE ITEMS                          
 ͼ}

Procedure TOGGLE_CADRE_ITEM;
Begin
SELECT_TBU_ITEM(Pos_TBU);                  {*Set/UnSet Old Cadres Items*}
SELECT_TCY_ITEM(Pos_TCY);
SELECT_TRB_ITEM(Pos_TRB);
SELECT_TSL_ITEM(Pos_TSL);
SELECT_TCO_ITEM(Pos_TCO);
SELECT_TBB_ITEM(Pos_TBB);
SELECT_TSB_ITEM(Pos_TSB);
SELECT_TXT_ITEM(Pos_TXT);
End;

{ͻ
                        EDIT IDCMP DE FENETRE DE BASE                       
 ͼ}

Procedure EDIT_IDCMP;
Var But1                     :ButG;           {*Type pour Gadgets Prdfinit*}
    TRad                     :Array [1..16] of Rad;{*Les Boutons Radios*}
    W1                       :Win;            {*Structure Window*}
    ExitFlg                  :Boolean;        {*Flag Sortie Programme*}
    ES,ES1,ES2               :String;         {*String Tout Usages*}
    Declick,OneTime          :Boolean;        {*Bouton Souris Appuy ou pas*}
    IDCMP                    :Word;           {*IDCMP Fentre*}
    NUM                      :Word;           {*Numro Gadets Cliqu*}
    Even                     :Byte;           {*Evenements pour Fentres*}
    Cancel                   :Boolean;        {*Annulation Modifications*}
    A                        :Integer;        {*Loop*}

{************************** AFFICHAGE DU WORD IDCMP *************************}

Procedure DISP_IDCMP;
Begin
ES:=Word_To_String(IDCMP);
String_Box(W1.X1+120,W1.Y1+330,W1.X1+208,W1.Y1+342,1,12,Off);
SetColor(Col[0]);
OutTextXY(W1.X1+126,W1.Y1+330,'IDCMP = $'+ES);
End;

Procedure CALC_IDCMP;
Begin
If OneTime=False Then
   Begin
   If IDCMP And NUM=NUM
      Then IDCMP:=IDCMP And ($FFFF-NUM)
      Else IDCMP:=IDCMP Or NUM;

   DISP_IDCMP;
   OneTime:=True;
   End;
End;

{********************* INITIALISATION WINDOW DE BASE ************************}

Procedure REDRAW_FRAME;
Var A,T,I:Integer;
Begin
Clip_Window(On,W1);
Button(40,HaF*31,59,0,7,False,But1,' _OK ');     {*Initialise les Boutons*}

For A:=1 to 16 do Begin
   Radio_Box(190,2+A*18,1,TRad[A].Status,TRad[A]);{*Initialise les Boutons Radio*}
   DispG(20,2+A*18,Col[7],Loc(483+A));             {*Affiche le Texte*}
   End;
Clip_Window(Off,W1);

Declick:=False; OneTime:=False;

T:=1; I:=0;                                   {*Affichage IDCMP Numros*}
ES2:='0000';
For A:=1 to 16 do Begin
   ES:='$0000';
   Str(T,ES1);
   ES:=Copy(ES,1,5-I-Length(ES1))+ES1+Copy(ES2,1,I);
   DispG(W1.X1+140,W1.Y1+A*18+3+HaF1,Col[7],ES);
   T:=T*2;
   If T>8 Then Begin T:=1; Inc(I); End;
   End;
DISP_IDCMP;
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
TOGGLE_CADRE_ITEM;                              {*Clear Old Cadres Items*}
INIT_WINDOW(180,0,420,349,$51D9,Loc(500),W1);
SUP_WINDOW(0,0,0,0,0,0,0,0,0,Col[5],$0000,W1);
IDCMP:=W.IDCMP;                                 {*Transmet IDCMP*}
DRAW_WINDOW(W1);

For A:=1 to 17 do                               {*Init All Radios*}
   If W.IDCMP And PUISS(2,A-1)=PUISS(2,A-1)
      Then TRad[A].Status:=On
      Else TRad[A].Status:=Off;

REDRAW_FRAME;                                 {*Affiche Gadgets*}

DISP_IDCMP;                                   {*Affiche IDCMP*}
ExitFlg:=Off; Cancel:=Off;                    {*Don't Forget !!!*}

Repeat
Main_Task;                                    {*Gestion du Systme*}

Even:=Active_Window(W1);
If Even=1 Then Cancel:=True;            {*Window Closed*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}

For A:=1 to 16 do
   If TRad[A].Fl1=True Then Begin NUM:=PUISS(2,A-1); CALC_IDCMP; End;

If Click_Mouse(1)=False Then OneTime:=False;

If Window_Ready(W1) Then Begin
   If GETMSG_BUTTON(But1,1)=True Then ExitFlg:=True;{*Sortie du Programme*}
   For A:=1 to 16 do GetMsg_Radio(TRad[A],1); {*Active et Teste Boutons*}
   End;

Until (ExitFlg=On) Or (Cancel=On);            {*Sortie du Programme*}

If Cancel=Off Then Begin
   CREATE_UNDO;                               {*Cr un Fichier UNDO*}
   Has_Changed:=True;                         {*Une Modification a t Faite*}
   Kill_Window(W1);                           {*Kill Requester*}
   IDCMP_Window(IDCMP,W);                     {*Change IDCMP Fentre*}
   REDRAW_WINDOW;                             {*Raffiche le Contenu de Window*}
   End;
TOGGLE_CADRE_ITEM;                            {*Display Old Cadres Items*}
End;

{ͻ
                        EDIT IDRES DE FENETRE DE BASE                       
 ͼ}

Procedure EDIT_IDRES;
Var But1                     :ButG;           {*Type pour Gadgets Prdfinit*}
    TRad                     :Array [1..16] of Rad;{*Les Boutons Radios*}
    W1                       :Win;            {*Structure Window*}
    ExitFlg                  :Boolean;        {*Flag Sortie Programme*}
    ES,ES1,ES2               :String;         {*String Tout Usages*}
    Declick,OneTime          :Boolean;        {*Bouton Souris Appuy ou pas*}
    IDRES                    :Word;           {*IDRES Fentre*}
    NUM                      :Word;           {*Numro Gadets Cliqu*}
    Even                     :Byte;           {*Evenements pour Fentres*}
    Cancel                   :Boolean;        {*Annulation Modifications*}
    A                        :Integer;        {*Loop*}

{************************** AFFICHAGE DU WORD IDRES **************************}

Procedure DISP_IDRES;
Begin
ES:=WORD_TO_STRING(IDRES);
String_Box(W1.X1+120,W1.Y2-19,W1.X1+208,W1.Y2-7,1,12,Off);
SetColor(Col[0]);
OutTextXY(W1.X1+126,W1.Y2-19,'IDRES = $'+ES);
End;

Procedure CALC_IDRES;
Begin
If OneTime=False Then
   Begin
   If IDRES And NUM=NUM
      Then IDRES:=IDRES And ($FFFF-NUM)
      Else IDRES:=IDRES Or NUM;

   DISP_IDRES;
   OneTime:=True;
   End;
End;

{********************* INITIALISATION WINDOW DE BASE ************************}

Procedure REDRAW_FRAME;
Var A,T,I:Integer;
Begin
Clip_Window(On,W1);
Button(40,HaF*16,59,0,7,False,But1,' _OK ');      {*Initialise les Boutons*}

For A:=1 to 7 do Begin
   Radio_Box(190,2+A*18,1,TRad[A].Status,TRad[A]);{*Initialise les Boutons Radio*}
   DispG(20,2+A*18,Col[7],Loc(500+A));              {*Affiche le Texte*}
   End;
Clip_Window(Off,W1);

Declick:=False; OneTime:=False;

T:=1; I:=0;                                   {*Affichage IDCMP Numros*}
ES2:='0000';
For A:=1 to 7 do Begin
   ES:='$0000';
   Str(T,ES1);
   ES:=Copy(ES,1,5-I-Length(ES1))+ES1+Copy(ES2,1,I);
   DispG(W1.X1+140,W1.Y1+A*18+3+HaF1,Col[7],ES);
   T:=T*2;
   If T>8 Then Begin T:=1; Inc(I); End;
End;
DISP_IDRES;
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
TOGGLE_CADRE_ITEM;                              {*Clear Old Cadres Items*}
Init_Window(180,60,420,240+HaF1,$51D9,Loc(508),W1);
Sup_Window(0,0,0,0,0,0,0,0,0,Col[5],$0000,W1);
IDRES:=W.IDRES;                                 {*Transmet IDRES*}
Draw_Window(W1);

For A:=1 to 8 do                              {*Init All Radios*}
   If W.IDRES And PUISS(2,A-1)=PUISS(2,A-1)
      Then TRad[A].Status:=On
      Else TRad[A].Status:=Off;

REDRAW_FRAME;                                 {*Affiche Gadgets*}

DISP_IDRES;                                   {*Affiche IDRES*}
ExitFlg:=Off; Cancel:=Off;                    {*Don't Forget !!!*}

Repeat
Main_Task;                                    {*Gestion du Systme*}

Even:=Active_Window(W1);
If Even=1 Then Cancel:=True;            {*Window Closed*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}

For A:=1 to 7 do
   If TRad[A].Fl1=True Then Begin NUM:=PUISS(2,A-1); CALC_IDRES; End;

If Click_Mouse(1)=False Then OneTime:=False;

If Window_Ready(W1) Then Begin
   If GETMSG_BUTTON(But1,1)=True Then ExitFlg:=True;{*Sortie du Programme*}
   For A:=1 to 7 do GetMsg_Radio(TRad[A],1);  {*Active et Teste Boutons*}
   End;

Until (ExitFlg=On) Or (Cancel=On);            {*Sortie du Programme*}

If Cancel=Off Then Begin
   CREATE_UNDO;                               {*Cr un Fichier UNDO*}
   Has_Changed:=True;                         {*Une Modification a t Faite*}
   Kill_Window(W1);                           {*Kill Requester*}
   IDRES_Window(IDRES,W);                     {*Change IDRES Fentre*}
   REDRAW_WINDOW;                             {*Raffiche le Contenu de Window*}
   End;
TOGGLE_CADRE_ITEM;                            {*Display Old Cadres Items*}
End;

{ͻ
                       EDIT MISCELLANEOUS INFO FENETRE                      
 ͼ}

Procedure EDIT_MISCELLANEOUS;
Var Exit_Flg    :Boolean;               {*Flag de Sortie*}
    Even        :Byte;                  {*Rception Evnements de la Fentre*}
    W1          :Win;                   {*Structure Fentre*}
    But0,But1,But2:ButG;                {*Structure Boutons*}
    Rad1,Rad2,Rad3,Rad4:Rad;            {*Radio Buttons Sructure*}
    Co1,Co2,Co3,Co4,                    {*String Command*}
    Co5,Co6,Co7,Co8,
    Co9,CoA,CoB,CoC,
    CoD,CoE     :TCoReq;
    Cin1,Cin2,Cin3,Cin4,                {*String Rcupre*}
    Cin5,Cin6,Cin7,Cin8,
    Cin9,CinA,CinB,CinC,
    CinD,CinE   :String;
    St          :String;                {*Pour Conversion*}
    Code        :Integer;
    Cancel      :Boolean;               {*Annulation Modifications*}
    IDRES       :Word;                  {*Stocke pour Restitution Ultrieure*}

{************************** AFFICHE WINDOW CONTENU **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);
Bevel(200,74,390,148,1,6,False,True);

SetColor(Col[0]);
DispG(324,36,7,Loc(509));
DispG(34, 56,7,Loc(510));
DispG(324,17,7,Loc(511));
DispG(220,83,7,Loc(512));
DispG(220,98,7,Loc(513));
DispG(220,113,7,Loc(514));
DispG(220,128,7,Loc(515));

Button(LaF*18, 160,LaF*16,0,7,False,But0,'_OK');
Button(LaF*50, 160,LaF*16,0,7,False,But1,Loc(13));
Button(LaF*40, HaF*3+5,LaF*12,0,7,False,But2,Loc(516));

COMMAND(20, 16,295,60,13,12,1,$27,CoD,CinD);
COMMAND(285,35,30,4,W.Coul,13,1,$26,CoE,CinE);

COMMAND(20,74,50,4,12,13,1,$26,Co1,Cin1);
COMMAND(20,94,50,4,12,13,1,$26,Co2,Cin2);
COMMAND(20,114,50,4,12,13,1,$26,Co3,Cin3);
COMMAND(20,134,50,4,12,13,1,$26,Co4,Cin4);

COMMAND(80,74,50,4,12,13,1,$26,Co5,Cin5);
COMMAND(80,94,50,4,12,13,1,$26,Co6,Cin6);
COMMAND(80,114,50,4,12,13,1,$26,Co7,Cin7);
COMMAND(80,134,50,4,12,13,1,$26,Co8,Cin8);

COMMAND(140,74,50,4,12,13,1,$26,Co9,Cin9);
COMMAND(140,94,50,4,12,13,1,$26,CoA,CinA);
COMMAND(140,114,50,4,12,13,1,$26,CoB,CinB);
COMMAND(140,134,50,4,12,13,1,$26,CoC,CinC);

RADIO_BOX(355,82,2,Rad1.Status,Rad1);
RADIO_BOX(355,97,2,Rad2.Status,Rad2);
RADIO_BOX(355,112,2,Rad3.Status,Rad3);
RADIO_BOX(355,127,2,Rad4.Status,Rad4);
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
TOGGLE_CADRE_ITEM;                      {*Clear Old Cadres Items*}
Init_Window(120,140,530,320+HaF1,$51D9,Loc(517),W1);
Sup_Window(0,0,0,0,0,0,0,0,0,5,$0000,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Str(W.X1,Cin1); Str(W.Y1,Cin2);         {*Init Values*}
Str(W.X2,Cin3); Str(W.Y2,Cin4);
Str(W.Xu,Cin5); Str(W.Yu,Cin6);
Str(W.Xv,Cin7); Str(W.Yv,Cin8);
Str(W.XMin,Cin9); Str(W.YMin,CinA);
Str(W.XMax,CinB); Str(W.YMax,CinC);

IDRES:=W.IDRES;                         {*Stocke pour Eviter la Perte*}
CinD:=W.Name;
Str(W.Coul,CinE);
If W.BarSld=0 Then Rad1.Status:=On Else Rad1.Status:=Off;
If (W.BarSld And $1=$1) And (W.BarSld And $2<>$2) Then Rad2.Status:=On Else Rad2.Status:=Off;
If (W.BarSld And $2=$2) And (W.BarSld And $1<>$1) Then Rad3.Status:=On Else Rad3.Status:=Off;
If W.BarSld And $3=$3 Then Rad4.Status:=On Else Rad4.Status:=Off;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   Clip_Window(On,W1);
   If GETMSG_BUTTON(But0,1) Then Exit_Flg:=True;{*Ok*}
   If GETMSG_BUTTON(But1,1) Then Cancel:=True;  {*Cancel*}
   If GETMSG_BUTTON(But2,1) Then Begin          {*Color*}
      Palette_RequestG(200,150,Loc(518),1,W.Coul);
      Clip_Window(On,W1);
      Str(W.Coul,CinE);
      Command(285,35,30,4,W.Coul,13,1,$26+$40,CoE,CinE);
      End;

   GETMSG_COMMAND(Co1,Cin1);            {*Test Gadgets Strings*}
   GETMSG_COMMAND(Co2,Cin2);
   GETMSG_COMMAND(Co3,Cin3);
   GETMSG_COMMAND(Co4,Cin4);
   GETMSG_COMMAND(Co5,Cin5);
   GETMSG_COMMAND(Co6,Cin6);
   GETMSG_COMMAND(Co7,Cin7);
   GETMSG_COMMAND(Co8,Cin8);
   GETMSG_COMMAND(Co9,Cin9);
   GETMSG_COMMAND(CoA,CinA);
   GETMSG_COMMAND(CoB,CinB);
   GETMSG_COMMAND(CoC,CinC);

   GETMSG_COMMAND(CoD,CinD);            {*Nom Window*}
   If GETMSG_COMMAND(CoE,CinE)=True Then{*Couleur Fond Window*}
      Begin
      Val(CinE,W.Coul,Code);            {*Display Exemple Color*}
      Command(285,35,30,4,W.Coul,13,1,$26+$40,CoE,CinE);
      End;

   GetMsg_Radio(Rad1,1);                {*Messages Radio Box*}
   GetMsg_Radio(Rad2,1);
   GetMsg_Radio(Rad3,1);
   GetMsg_Radio(Rad4,1);
   Clip_Window(Off,W1);
   End;

Even:=Active_Window(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Suprime Fentre*}

If Cancel=Off Then Begin
   CREATE_UNDO;                         {*Cr un Fichier UNDO*}
   W.Name:=CinD;                        {*Save Parameters in Structure*}
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   Kill_Window(W);                      {*Sucre Fentre Actuelle*}

   Val(Cin1,W.X1,Code); Val(Cin2,W.Y1,Code);{*Define Window Size*}
   Val(Cin3,W.X2,Code); Val(Cin4,W.Y2,Code);
   Init_Window(W.X1,W.Y1,W.X2,W.Y2,W.IDCMP,W.NAME,W);

   Val(Cin5,W.Xu,Code); Val(Cin6,W.Yu,Code);{*Define Sup Values*}
   Val(Cin7,W.Xv,Code); Val(Cin8,W.Yv,Code);
   Val(Cin9,W.XMin,Code); Val(CinA,W.YMin,Code);
   Val(CinB,W.XMax,Code); Val(CinC,W.YMax,Code);

   Val(CinE,W.Coul,Code);               {*Define Color and BarSld*}
   If Rad1.Status=On Then W.BarSld:=0;
   If Rad2.Status=On Then W.BarSld:=1;
   If Rad3.Status=On Then W.BarSld:=2;
   If Rad4.Status=On Then W.BarSld:=3;

   Sup_Window(W.Xu,W.Yu,W.Xv,W.Yv,W.Xmin,W.YMin,W.XMax,W.YMax,W.BarSld,W.Coul,IDRES,W);
   REDRAW_WINDOW;                       {*Raffiche le Contenu de Window*}
   End;

TOGGLE_CADRE_ITEM;                      {*Display Old Cadres Items*}
End;

{ͻ
                          PROCEDURE DELETE_ITEMS                            
 ͼ}

Procedure DELETE_ITEMS;
Var W1            :Win;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    Cancel        :Boolean;             {*Annulation Modifications*}
    But0,But1,But2:ButG;                {*Structure Boutons*}
    TRad:Array[1..8] of Rad;            {*Tableau de Radio Boxes*}
    Rad9,RadB     :Rad;                 {*Structure Radios*}
    A             :Integer;

{************************* AFFICHE BOUTONS RADIOS ***************************}

Procedure REDRAW_RADIO_BOXES;
Var A:Integer;
Begin
For A:=1 to 8 do
   Radio_Box(180,5+A*15,1,TRad[A].Status,TRad[A]);   {*Can Be Modified*}
End;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var A:Integer;
Begin
Clip_Window(On,W1);
Bevel(30,145,210,205,1,6,False,True);
SetColor(0);
For A:=1 to 8 do                        {*Display Labels*}
   DispG(30,5+A*15,7,Loc(518+A));

DispG(60, 153,6,Loc(527));
DispG(60, 168,6,Loc(528));

Button(45, 185,150,0,7,False,But2,Loc(529));
Button(LaF*6, 220,LaF*14,0,7,False,But1,'_OK');
Button(LaF*28,220,LaF*14,0,7,False,But0,Loc(13));

REDRAW_RADIO_BOXES;                     {*Raffiche Radio_Boxes*}
Radio_Box(160,152,2,Rad9.Status,Rad9);  {*Musn't Be Modified*}
Radio_Box(160,+167,2,RadB.Status,RadB);
Clip_Window(Off,W1);
End;


{*************************** TOGGLE ITEMS LIST ******************************}

Procedure TOGGLE_ITEMS;
Var A:Integer;
Begin
For A:=1 to 8 do
   TRad[A].Status:=Not(TRad[A].Status); {*Toggle Check Boxes*}
REDRAW_RADIO_BOXES;                     {*Raffiche Radio_Boxes*}
End;

{*********************** SELECT ITEMS TO BE CLEARED OR NO *******************}

Procedure SELECT_ITEMS;
Var A:Integer;
Begin
If Radio2_IDCMP And $1=$1 Then Exit;    {*Bit Extrude Mis => Pas Termin*}

If Rad9.Status=True Then
   For A:=1 to 8 do TRad[A].Status:=On; {*Set On Check Boxes*}
If RadB.Status=True Then
   For A:=1 to 8 do TRad[A].Status:=Off;{*Set Off Check Boxes*}

REDRAW_RADIO_BOXES;                     {*Raffiche Radio_Boxes*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Init_Window(170,25,410,265+HaF1,$51D9,Loc(530),W1);
Sup_Window(100,50,250,200,59,50,400,300,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

For A:=1 to 8 do TRad[A].Status:=On;    {*Init Check Boxes*}
Rad9.Status:=On; RadB.Status:=Off;      {*Init Radio Boxes*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   Clip_Window(On,W1);
   If GetMsg_Button(But1,1)=True Then Exit_Flg:=True;
   If GetMsg_Button(But0,1)=True Then Cancel:=True;
   For A:=1 to 8 do GetMsg_Radio(TRad[A],1);{*Test Main Radios*}

   If GetMsg_Radio(Rad9,1) Then SELECT_ITEMS;{*Modifie Flags*}
   If GetMsg_Radio(RadB,1) Then SELECT_ITEMS;
   If GetMsg_Button(But2,1) Then TOGGLE_ITEMS;{*Toggle Flags*}
   Clip_Window(Off,W1);
   End;

Even:=Active_Window(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Suprime Fentre*}

If Cancel=Off Then Begin                {*Modification Confirme*}
   CREATE_UNDO;                         {*Cr un Fichier UNDO*}
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   If TRad[1].Status=On Then QTT_TBU:=0;   {*Clear Specificaly Items*}
   If TRad[2].Status=On Then QTT_TCY:=0;
   If TRad[3].Status=On Then QTT_TRB:=0;
   If TRad[4].Status=On Then QTT_TSL:=0;
   If TRad[5].Status=On Then QTT_TCO:=0;
   If TRad[6].Status=On Then QTT_TBB:=0;
   If TRad[7].Status=On Then QTT_TSB:=0;
   If TRad[8].Status=On Then QTT_TXT:=0;
   REDRAW_WINDOW;                       {*Raffiche Fentre de Test*}
   If Item<>11 Then TOGGLE_CADRE_ITEM;  {*Efface Toggle si il y en as un*}
   End;
End;

{ͻ
                         PROCEDURE GET_ITEMS_INFO                           
 ͼ}

Procedure GET_ITEMS_INFO;
Var W1            :Win;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1          :ButG;                {*Structure Boutons*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var S:String[6];
    Lp            :Integer;             {*Loop*}
Begin
Clip_Window(On,W1);
String_Box(30,35,210,165,1,6,False);
SetColor(0);
DispG(30,20,7,Loc(531));
For Lp:=1 to 8 do DispG(40,25+Lp*15,7,Loc(531+Lp));

Str(Qtt_TBU,S); DispG(145,40,7,S);
Str(Qtt_TCY,S); DispG(145,55,7,S);
Str(Qtt_TRB,S); DispG(145,70,7,S);
Str(Qtt_TSL,S); DispG(145,85,7,S);
Str(Qtt_TCO,S); DispG(145,100,7,S);
Str(Qtt_TBB,S); DispG(145,115,7,S);
Str(Qtt_TSB,S); DispG(145,130,7,S);
Str(Qtt_TXT,S); DispG(145,145,7,S);
Button(80,180,80,0,7,False,But1,'   _OK   ');
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
INIT_WINDOW(190,40,430,240+HaF1,$51F9,Loc(540),W1);
SUP_WINDOW(100,50,250,200,59,50,400,300,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
DRAW_WINDOW(W1);                        {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}

Exit_Flg:=False;                        {*Flag de Sortie*}

Repeat;
MAIN_TASK;                              {*Gre Systme*}
If WINDOW_READY(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If GetMsg_Button(But1,1)=True Then Exit_Flg:=True;
   End;

Even:=ACTIVE_WINDOW(W1);
If Even=1 Then Exit_Flg:=True;          {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until Exit_Flg=True;                    {*Flag de Sortie*}

Kill_Window(W1);                        {*Supprime Fentre*}
End;

{ͻ
                             DEFINE MAIN PREFS                              
 ͼ}

Procedure DEFINE_MAIN_PREFS;            {*Pas de Main Prefs*}
Var W1            :Win;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Cancel        :Boolean;             {*Annulation Modifications*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But0,But1     :ButG;                {*Structure Boutons*}
    TRad          :Array[1..4] of Rad;  {*Structure Radios*}
    Lp            :Integer;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var Lp:Integer;
Begin
Clip_Window(On,W1);
String_Box(30,20,260,110,1,6,False);
SetColor(0);
For Lp:=1 to 4 do Begin
   DispG(40,11+Lp*20,7,Loc(540+Lp));
   Radio_Box(220, 10+Lp*20,1,TRad[Lp].Status,TRad[Lp]);
   End;

Button( LaF*8, 125,LaF*16,0,7,False,But1,'_OK');
Button( LaF*34,125,LaF*16,0,7,False,But0,Loc(13));
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Init_Window(170,60,460,205+HaF1,$51D9,Loc(545),W1);
Sup_Window(100,50,250,200,59,50,400,250,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

TRad[1].Status:=Disp_Beep;              {*En Fonction Etat Boolean*}
TRad[2].Status:=Full_Simul;
TRad[3].Status:=Show_Mcoo;
TRad[4].Status:=Show_Report;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If GetMsg_Button(But1,1)=Yes Then Exit_Flg:=True;
   If GetMsg_Button(But0,1)=Yes Then Cancel:=True;
   For Lp:=1 to 4 do GetMsg_Radio(TRad[Lp],1);
   End;

Even:=Active_Window(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Suprime Fentre*}

If Cancel=Off Then Begin                {*Modifications Acceptes*}
   Disp_Beep:=TRad[1].Status;           {*Rcupre Etats Booleans*}
   Full_Simul:=TRad[2].Status;
   Show_MCoo:=TRad[3].Status;
   Show_Report:=TRad[4].Status;
   Rename_Window(W.Name,W);             {*Raffiche Window Title*}
   End;
End;

{ͻ
                            DEFINE SOURCE PREFS                             
 ͼ}

Procedure DEFINE_SOURCE_PREFS;
Var W1          :Win;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evnements Fentre*}
    Cancel      :Boolean;               {*Annulation Modifications*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    Co1,Co2     :TCoReq;                {*Structure pour Command*}
    Cin1,Cin2   :String;                {*String Rcupre*}
    TRad        :Array[1..4] of Rad;    {*Structure pour Radios*}
    But0,But1   :ButG;                  {*Structure Boutons*}
    Lp          :Integer;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var Lp:Integer;
Begin
Clip_Window(On,W1);
String_Box(60,60,290,145,1,6,Off);
Button(LaF*10+1, 158,LaF*16,0,7,False,But1,'_OK');
Button(LaF*43+1, 158,LaF*16,0,7,False,But0,Loc(13));

Command(120,17,200,30,12,13,1,$26,Co1,Cin1); {*Init Commands*}
Command(120,37,200,30,12,13,1,$26,Co2,Cin2);

For Lp:=1 to 4 do Begin
   DispG(90,48+Lp*19,7,Loc(547+Lp));
   Radio_Box(240,47+Lp*19,1,TRad[Lp].Status,TRad[Lp]);{*Initialise Radios*}
   End;
SetColor(Col[0]);
DispG(30,18,7,Loc(546));
DispG(30,38,7,Loc(547));

If TRad[1].Status=True Then Freeze_Command(Off,Co1)   {*Freeze Eventually*}
                       Else Freeze_Command(On,Co1);
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Init_Window(80,55,433,233+HaF1,$51D9,Loc(652),W1);
Sup_Window(100,50,347,218,59,50,400,250,0,5,$0,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Cin1:=Name_Prog;                        {*Init Right Values*}
Cin2:=Name_Proc;
TRad[1].Status:=Gen_Prog;
TRad[2].Status:=Gen_Rem;
TRad[3].Status:=Gen_Menu;
TRad[4].Status:=Opt_Source;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If GetMsg_Button(But1,1) Then Exit_Flg:=True;
   If GetMsg_Button(But0,1) Then Cancel:=True;
   GetMsg_Command(Co1,Cin1);            {*Test Gadgets Strings*}
   GetMsg_Command(Co2,Cin2);
   For Lp:=2 to 4 do GetMsg_Radio(TRad[Lp],1);
   If GetMsg_Radio(TRad[1],1) Then      {*Test Radio Boxes*}
      If TRad[1].Status=True Then Freeze_Command(Off,Co1)
                             Else Freeze_Command(On,Co1);
   End;

Even:=Active_Window(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Suprime Fentre*}

If Cancel=Off Then Begin
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   Name_Prog:=Cin1;                     {*Define New Values*}
   Name_Proc:=Cin2;
   Gen_Prog:=TRad[1].Status;
   Gen_Rem:=TRad[2].Status;
   Gen_Menu:=TRad[3].Status;
   Opt_Source:=TRad[4].Status;
   End;
End;

{ͻ
                           TESTE ITEMS ET WINDOW                            
 ͼ}

Procedure TEST_ITEMS_WINDOW;
Var Even,A,CPro:Integer;
    BMsg:Char;                            {*Display Msg Beep or No*}
    NUM:Integer;
    DirSel,FilSel:String;
    Size:Longint;
    P:TProgress;                          {*Pour le Progress Requester*}

Begin
If Gad_Exist=No Then Exit;                {*Pas de Gadgets  Tester*}
Grid:=My_Grid;                            {*Utilise Grille si Existe*}
Even:=Active_Window(W);                   {*Rceptionne Evnements*}
If Even=1 Then Begin                      {*Close Window*}
   CREATE_UNDO;                           {*Sauve les Paramtres de la fentre*}
   UNDO_ACTION;                           {*Restaure la Fentre comme elle tait*}
(*   Win_Exist:=False;
   Gad_Exist:=False;                      {*Gadgets N'existent pas*}
   Set_ID_Menu(M,4,1,$01);                {*Passe en Gris Options Menu*}
   Set_ID_Menu(M,4,2,$01);
   Set_ID_Menu(M,4,3,$01);
   Set_ID_Menu(M,4,5,$01);
   Set_ID_Menu(M,4,6,$00);
   Set_ID_Menu(M,4,7,$11);
   Set_ID_Menu(M,2,8,$00);                  {*Extrude et Put Into*}
   Set_ID_Menu(M,2,9,$11);*)
   End;
If (Even=3) Or (Even=4) Or (Even=9) Then    {*Extend, Resize,Dplace*}
   Begin Has_Changed:=True; REDRAW_WINDOW; End;{*Fentre Extend*}
Grid:=Off;                                {*Plus de Grille Gnerale*}

If (Window_Ready(W) And (Win_Exist=True)) Or (Win_Exist=False) Then Begin

{====================== TEST ET ACTIONS DES BOUTONS =========================}

   Clip_Window(On,W);                     {*Clipping pour Test des Gadgets*}
   For A:=1 to QTT_TBU do                 {*Teste Boutons*}
      If GetMsg_Button(TBU[A].B,1)=True Then
         If Full_Simul=On Then            {*Simulation Appel Requesters*}
            Case TBU[A].Action of
               1 : EZ_RequestG(Loc(461),Loc(552),'   _OK   ',NUM);
               2 : EZ_RequestG(Loc(461),Loc(553)+Proc_Name,'   _OK   ',NUM);
               3 : Begin                  {*EZ Requester*}
                   If REzV.BCenter=On Then DirSel:='#0' Else DirSel:='';
                   EZ_RequestG(REzV.Title,DirSel+REzV.Phrase,REzV.Gadget,NUM);
                   End;
               4 : Begin                  {*Font Requester*}
                   Font_RequestG(RFntV.X1,RFntV.Y1,RFntV.Name,RFntV.Font_Sel,RFntV.Size_Sel);
                   End;
               5 : Begin                  {*String Requester*}
                   If RStV.BCenter=On Then DirSel:='#0' Else DirSel:='';
                   String_RequestG(RStV.Name,DirSel+RStV.Txt,RStV.Gad,RStV.NbChar,RStV.Size,RStV.Str,NUM );
                   End;
               6 : Begin                  {*Value Requester*}
                   If RVaV.BCenter=On Then DirSel:='#0' Else DirSel:='';
                   Value_RequestG(RVaV.Name,DirSel+RVaV.Txt,RVaV.Gad,RVaV.BMin,RVaV.BMax,RVaV.Vai,NUM );
                   End;
               7 : Begin                  {*Palette Requester*}
                   Palette_RequestG(RPalV.X1,RPalV.Y1,RPalV.Name,0,NUM);
                   End;
               8 : Begin                  {*Memory Requester*}
                   Memory_RequestG(RMemV.X1,RMemV.Y1,RMemV.Name);
                   End;
               9 : Begin                  {*Hardware Requester*}
                   Hardware_RequestG(RHardV.X1,RHardV.Y1,RHardV.Name);
                   End;
               10: Begin                  {*Progress Requester*}
                   CPro:=0;
                      Repeat
                      MAIN_TASK; Str(CPro,DirSel);
                      Progress_RequestG(RProV.Name,RProV.Explain+' '+DirSel,CPro,RProV.Cob,P);
                      Delay(15); Inc(CPro);
                      Until (P.Abort=True) Or (CPro>100);
                   End;
               11: Begin DirSel:='';      {*File Requester*}
                   Get_FileDir(RFileV.X1,RFileV.Y1,RFileV.Sv,RFileV.Name,
                   RFileV.OkBut,RFileV.Mask,RFileV.Style,DirSel,FilSel,Size);
                   If RFileV.SendToCom=True Then Begin
                      TCO[RFileV.FPath].Cin:=''; TCO[RFileV.FName].Cin:='';
                      If RFileV.FPath>0 Then TCO[RFileV.FPath].Cin:=TCO[RFileV.FPath].Cin+DirSel;
                      If RFileV.FName>0 Then TCO[RFileV.FName].Cin:=TCO[RFileV.FName].Cin+FilSel;
                      If RFileV.FSize>0 Then Str(Size,TCO[RFileV.FSize].Cin);
                      REDRAW_WINDOW;
                      End;
                   End;                   {*System Requester*}
               12: Get_Attrib_Bits(RAttrV.X1,RAttrV.Y1,RAttrV.Name);
               13: System_RequestG(RSysV.X1,RSysV.Y1,RSysV.Name);
               14: Register_RequestG;     {*Register Requester*}
               End;
   For A:=1 to QTT_TCY do                 {*Teste Cyclers*}
      GetMsg_Button(TCY[A].B,1);
   For A:=1 to QTT_TRB do                 {*Teste Radios*}
      GetMsg_Radio(TRB[A].R,1);
   For A:=1 to QTT_TCO do                 {*Teste Commands*}
      GetMsg_Command(TCO[A].T,TCO[A].Cin);

{====================== TEST ET ACTIONS DES SLIDERS =========================}

   For A:=1 to QTT_TSL do                 {*Teste Sliders*}
      If GetMsg_Slider(TSL[A].S,1)=True Then Begin
         CPro:=RSldV[A].ComNum;{*Numro du Command  Toucher*}
         If (CPro>0) And (CPro<=QTT_TCO) Then Begin
            Str(TSL[A].S.Psl,TCO[CPro].Cin);{*Transmet Rsult to Command*}
            Command(W.X1+TCO[CPro].X1, W.Y1+TCO[CPro].Y1, TCO[CPro].T.Siz, TCO[CPro].T.Len,
                         TCO[CPro].T.CoB, TCO[CPro].T.Co2, TCO[CPro].T.Sty, $0, TCO[CPRo].T ,TCO[CPro].Cin);
            If TCO[CPro].Freeze=On Then Freeze_Command(On,TCO[CPro].T);
            End;
         End;
   Clip_Window(Off,W);                    {*Fin de Clipping pour Test Gadgets*}
   End;
End;

{ͻ
                        SUPPRESSION FENETRE DE BASE                         
 ͼ}

Procedure KILL_WIN;
Var NUM:Integer;
Begin
EZ_REQUESTG(Loc(461),Loc(554),Loc(555),NUM);
If (NUM=0) Or (NUM=4) Then Exit;        {*Cancel*}

Show_Screen;                            {*Raffiche le fond de l'cran*}

CREATE_UNDO;                            {*Cr un Fichier UNDO*}
If NUM=3 Then Begin
   DELETE_ITEMS;                        {*Sucre Certain Items + Window*}
   QTT_TO_0;                            {*Quantit de Chaque Outils  0*}
   Has_Changed:=False;                  {*Crate Undo*}
   End;
If NUM<4 Then Begin
   Win_Exist:=False;
   Set_ID_Menu(M,4,1,$01);              {*Passe en Grise Options Menu*}
   Set_ID_Menu(M,4,2,$01);
   Set_ID_Menu(M,4,3,$01);
   Set_ID_Menu(M,4,5,$01);
   Set_ID_Menu(M,4,6,$00);
   Set_ID_Menu(M,4,7,$11);
   Set_ID_Menu(M,2,8,$00);              {*Extrude et Put Into*}
   Set_ID_Menu(M,2,9,$11);
   End;
If NUM=1 Then Kill_Window(W);           {*Kill Window*}
If NUM=2 Then Begin
   Kill_Window(W);                      {*Kill All = Window + Items*}
   QTT_TO_0;                            {*Quantit de Chaque Outils  0*}
   Has_Changed:=False;                  {*Crate Undo*}
   Gad_Exist:=False;                    {*Gadgets N'existent pas*}
   End;
End;

{ͻ
                        SAVING PROJECT BEFORE QUIT                          
 ͼ}

Function ASKTOSAVE_CURRENT_PROJECT:Boolean;
Var NUM:Integer;
Begin
If Has_Changed=True Then EZ_REQUESTG(Loc(461),Loc(556),Loc(557),NUM);
If NUM=1 Then SAVE_PROJECT(0);          {*Sauvegarde Project Before*}
If (NUM=3) Or (NUM=0) Then ASKTOSAVE_CURRENT_PROJECT:=True
         Else ASKTOSAVE_CURRENT_PROJECT:=False;
End;

{ͻ
                       INITIALISATION FENETRE DE BASE                       
 ͼ}

Procedure INIT_WINDOW0;
Begin
W0.X1:=140; W0.Y1:=90; W0.X2:=500; W0.Y2:=250;
W0.Name:=Loc(558);
W0.IDCMP:=$51DF;
W0.Xu:=100; W0.Yu:=50; W0.Xv:=250; W0.Yv:=200;
W0.XMin:=59; W0.YMin:=50;
W0.XMax:=GetMaxX; W0.YMax:=GetMaxY;
W0.IDRES:=0;
W0.BarSld:=0;
W0.Coul:=5;
WSizeX:=W0.X2-W0.X1; WSizeY:=W0.Y2-W0.Y1;
End;

{ͻ
                         REINIT ALL POUR NEW WINDOW                         
 ͼ}

Procedure REINIT_ALL_WINDOW;
Begin
Has_Changed:=False;                     {*Rinit Changements*}
Gad_Exist:=True;                        {*Gadgets Existent*}
Show_Screen;                            {*Raffiche le fond de l'cran*}
Init_Window(W0.X1,W0.Y1,W0.X2,W0.Y2,W0.IDCMP,W0.NAME,W);
Sup_Window(W0.Xu,W0.Yu,W0.Xv,W0.Yv,W0.Xmin,W0.YMin,W0.XMax,W0.YMax,W0.BarSld,W0.Coul,W0.IDRES,W);
Win_Exist:=True;                        {*Fentre Existe*}
REDRAW_WINDOW;                          {*Raffiche le Contenu de Window*}
Set_ID_Menu(M,4,1,$00);                 {*Active Options Menu*}
Set_ID_Menu(M,4,2,$00);
Set_ID_Menu(M,4,3,$00);
Set_ID_Menu(M,4,5,$00);
Set_ID_Menu(M,4,6,$01);
Set_ID_Menu(M,4,7,$10);
Set_ID_Menu(M,2,8,$01);                 {*Extrude et Put Into*}
Set_ID_Menu(M,2,9,$10);

POS_TO_0;                               {*Rinit Positions for Cycles  0*}

M.TbMen[7,1]:='Project: ''''';          {*Name Cleared*}
Save_FileName:='';
End;

{ͻ
                           PROCEDURE PRINCIPALE                             
 ͼ}

Procedure MAIN;
Const ESP='                 ';                   {*Pour Complment*}
Var ExitFlg                  :Boolean;           {*Flag Sortie Programme*}
    MS,PS,SS                 :Byte;              {*Menu, Point Slectionns*}
    NUM,Font,Size            :Integer;           {*For Reponse Gadgets*}
    A                        :Integer;           {*Pour Boucles*}
    X,Y,XOld,YOld            :Word;              {*Pour Status Souris*}
    Ga,Mi,Dr                 :Boolean;
    St,St1,St2               :String[20];        {*Conversion Aff Values*}

{************************** CODE PROCEDURE PRINCIPALE ***********************}

Begin
INIT_WINDOW0;                                    {*Init Valeurs Window for Init*}
Init_Window(W0.X1,W0.Y1,W0.X2,W0.Y2,W0.IDCMP,W0.NAME,W);
Sup_Window(W0.Xu,W0.Yu,W0.Xv,W0.Yv,W0.Xmin,W0.YMin,W0.XMax,W0.YMax,W0.BarSld,W0.Coul,W0.IDRES,W);

REDRAW_WINDOW;                                   {*Raffiche le Contenu de Window*}
INIT_TABLEAUX_MENU;                              {*Va Remplir le Tableau Menu*}
LOAD_MRE_CONFIG;                                 {*Load and Init MRE Constants*}

Win_Exist:=True;                                 {*Fentre Existe de Base*}
ExitFlg:=False;                                  {*Flag de Sortie*}

Repeat
Main_Task;                                       {*Gre Systme*}
If (LightB_Status=False) And (Win_Size=False)
   And (Win_Move=False) Then
   TEST_MENU(M,Col[1],Col[15],MS,PS,SS);             {*Gre le Menu*}

Case MS of
   1: Case PS of
      1: If ASKTOSAVE_CURRENT_PROJECT=False Then {*Current Project is-it saved ?*}
         Begin
         Kill_Window(W);                         {*Sucre Fentre courante*}
         QTT_TO_0;                               {*Quantit de Chaque Outils  0*}
         REINIT_ALL_WINDOW;                      {*Rinit All*}
         End;
      3: LOAD_PROJECT(0);                        {*Chargement Boulot*}
      4: SAVE_PROJECT(0);                        {*Sauvegarde Boulot*}
      5: SAVE_PROJECT(1);                        {*Sauvegarde Automatique Boulot*}
      6: GENERATE_SOURCE;                        {*Genre la Source*}
      11: ABOUT;                                 {*About MRE v2.4*}
      12: REGISTER_REQUESTG;                     {*How to Register*}
      13: DOS_Shell;                             {*DOS Shell*}
      14: If ASKTOSAVE_CURRENT_PROJECT=False     {*Current Project is-it saved ?*}
          Then ExitFlg:=True;
      End;

   2: Case PS of
      1: If Test_Check_Point(M,1,9) Then HELP(3);
      2: If Test_Check_Point(M,1,9) Then HELP(4);
      3: If Test_Check_Point(M,1,9) Then HELP(5);
      5: DELETE_ITEMS;                           {*Sucre Certains Items*}
      6: GET_ITEMS_INFO;                         {*Affiche Infos Items*}
      7: UNDO_ACTION;                            {*Undo Action*}
      End;

   3: Begin
      Item:=PS;                                  {*Define Gadgets Type*}
      TOGGLE_CADRE_ITEM;                         {*Clear Old Cadres Items*}
      POS_TO_0;                                  {*Rinit Positions for Cycles*}
      If (PS<>14) And (Test_Check_Point(M,1,9)) Then HELP(1);
      If (PS=14) And (Test_Check_Point(M,1,9)) Then HELP(2);
      End;

   4: Case PS of
      1: EDIT_IDCMP;                             {*Edit IDCMP Window*}
      2: EDIT_IDRES;                             {*Edit IDRES Window*}
      3: EDIT_MISCELLANEOUS;                     {*Edit Misc  Window*}
      5: SET_GRID;                               {*Dfinit Grille Fentre*}
      6: If Win_Exist=False Then Begin           {*Init Fentre*}
         If (Qtt_TBB>0) Or (Qtt_TSB>0) Or (Qtt_TXT>0)
         Or (Qtt_TBU>0) Or (Qtt_TCY>0) Or (Qtt_TRB>0)
         Or (Qtt_TSL>0) Or (Qtt_TCO>0)
         Then Begin                              {*Objets dja Existants*}
            CREATE_UNDO;                         {*Cr un Fichier UNDO*}
            EZ_RequestG(Loc(461),Loc(559),Loc(560),NUM);
            If NUM=2 Then QTT_TO_0;              {*Quantit de Chaque Outils  0*}
            End;
         REINIT_ALL_WINDOW;                      {*Rinit All for Window*}
         End;
      7: If Win_Exist=True Then KILL_WIN;        {*Sucre Window de Base*}
      End;

   5: Case PS of                                 {*Menu "Menu"*}
      1: Begin CREATE_UNDO; DEFINE_MENU; Has_Changed:=Yes;End;{*Cration des Menus*}
      3: TEST_MRE_MENU;                          {*Test du Menu Cr*}
      End;

   6: Case PS of
      1: Begin System_RequestG(53,26,'MRE.INI');
         Create_Undo;
         Kill_Window(W);
         Undo_Action;
         End;
      3: Memory_RequestG(80,60,Loc(561));
      5: DEFINE_MAIN_PREFS;                      {*No Main Prfrences*}
      6: DEFINE_SOURCE_PREFS;                    {*Prfrences de la Source*}
      8: Begin TOGGLE_CADRE_ITEM;                {*Clear Old Cadres Items*}
         Show_Screen;                            {*Raffiche le fond de l'cran*}
         REDRAW_WINDOW;
         TOGGLE_CADRE_ITEM; End;                 {*Clear Old Cadres Items*}
      10: SAVE_MRECONFIG;                        {*Sauvegarde Config MRE*}
      End;
   End;

Case Item of                                     {*Appel Procdure en Fonction des Gadgets*}
   1: GERE_BUTTONS;
   2: GERE_CYCLERS;
   3: GERE_RADIOS;
   4: GERE_SLIDERS;
   5: GERE_COMMANDS;
   7: GERE_BEVEL_BOXES;
   8: GERE_STRING_BOXES;
   9: GERE_TEXTS;
   14: TEST_ITEMS_WINDOW;                        {*Teste Rsultats Items + Win*}
   End;

If Pt_Grid=On Then Begin                         {*Grille sur Pointeur*}
   Get_Grid_Coord(X,Y);
{   PutMouseG(X,Y);}
   End;

If (Show_MCoo) And (Window_Ready(W)) Then Begin  {*Display Mouse Coordonnes*}
   GetMouseG(X,Y,Ga,Mi,Dr);
   Str(X,St1); Str(Y,St2); St:='X='+St1+' Y='+St2;
   St:=St+Copy(ESP,1,11-Length(St));
   A:=43+TextWidth(St); If W.X2-A<W.X1+21 Then A:=W.X2-W.X1-21;
   If (XOld<>X) Or (YOld<>Y) Then
      If A>=41 Then Begin
      SetColor(Col[0]);
      SetViewPort(W.X2-A,W.Y1+1,W.X2-41,W.Y1+HaF1+3,ClipOn);
      SetFillStyle(1,3); HideMouse; Bar(0,0,100,HaF1+4);
      OutTextXY(0,1,St); ShowMouse;              {*Show Coordonnes*}
      SetViewPort(0,0,GetMaxX,GetMaxY,ClipOff);  {*Restore Normal ViewPort*}
      XOld:=X; YOld:=Y;                          {*Stocke Coordonnes Mouse*}
      End;
   End;

Until ExitFlg=True;                              {*Sortie du Programme*}

Kill_Window(W);                                  {*Sucre Fentre de Base*}
KILL_UNDO;                                       {*Vire le fichier UNDO Restant*}
End;

{ͻ
                             PROGRAMME PRINCIPAL                            
 ͼ}

Begin
{DirectVideo:=False;}
INIT_ASM;                               {*Initialise All for Asm*}
{INIT_SOUND;                             {*Initialise All for Sound*}
INIT_MOUSE;                             {*Initialise All for Mouse*}
INIT_SCREEN;                            {*Initialise All for Screen*}

Oldexit:=ExitProc;
SetJump(MyAddr);                        {*Always Before ExitProc...*}
ExitProc:=@ENTRY_INT24;                 {*Set new Adr for Int $24*}

INIT_MRE;                               {*Initialise MRE Constants*}

MAIN;                                   {*Excute le Programme Principal*}

DONE_SCREEN;                            {*Restore All for Screen*}
DONE_MOUSE;                             {*Restore All for Mouse*}
{DONE_SOUND;                             {*Restore All for Sound*}
DONE_ASM;                               {*Restore All for Asm*}
End.
