{ͻ
                      M.R.E (MOS RESOURCE EDITOR) v2.4                      
 ͹
                         UNITE DE GESTION DES ITEMS                         
 ͹
  Coded by Zuul as BouFFtou as Cheveau Frdric.                            
  Programm  Toulouse COG (Gendarmerie) sur Turbo Pascal v7.00.            
  Contact us on 36.15 RTEL1 - Bal "BouFFtou" or Bal "ICF".                  
 ͼ}

Unit MRE_ITEMS;                          {*Nom du l'Unit*}

Interface

Uses MOS_BAS,
     MOS_MSE,                            {*Gestion de la Souris*}
     MOS_TOO,                            {*Gestion des Tools et Box*}
     MOS_GAD,                            {*Gestion des Gadgets*}
     MOS_REQ,                            {*Gestion des Requesters*}
     MOS_MEN,                            {*Gestion des Menus*}
     MOS_WIN,                            {*Gestion des Fentres*}
     MOS_DIR,                            {*Gestion du Directory*}
     MRE_ACTS,                           {*Gestion Action des Boutons*}
     Crt,
     Graph;
                                         {*Espaces pour Strings*}
Procedure HELP(P:Integer);               {*Gestion de l'Aide*}
Procedure ERROR_01;                      {*Gestion des Erreurs*}
Procedure ABOUT;
Procedure REDRAW_WINDOW;                 {*Raffiche le Contenu de Window*}

Procedure GERE_BUTTONS;                  {*Gestion des Items*}
Procedure GERE_CYCLERS;
Procedure GERE_RADIOS;
Procedure GERE_SLIDERS;
Procedure GERE_COMMANDS;
Procedure GERE_BEVEL_BOXES;
Procedure GERE_STRING_BOXES;
Procedure GERE_TEXTS;

Procedure SELECT_TBU_ITEM(P:Byte);       {*Affichage des Cadres*}
Procedure SELECT_TCY_ITEM(P:Byte);
Procedure SELECT_TRB_ITEM(P:Byte);
Procedure SELECT_TSL_ITEM(P:Byte);
Procedure SELECT_TCO_ITEM(P:Byte);
Procedure SELECT_TBB_ITEM(P:Byte);
Procedure SELECT_TSB_ITEM(P:Byte);
Procedure SELECT_TXT_ITEM(P:Byte);

Procedure SAVE_MRECONFIG;
Procedure LOAD_MRE_CONFIG;              {*Load And Init MRE Constants*}
Procedure QTT_TO_0;                     {*POS et QTT to 0...*}
Procedure POS_TO_0;

Implementation

{ͻ
                         GESTION DE L'AIDE DANS MRE                         
 ͼ}

Procedure HELP(P:Integer);
Var NUM:Integer;
    St:String;
Begin
St:='';
Case P of
   1: St:=Loc(582);
   2: St:=Loc(583);
   3: St:=Loc(584);
   4: St:=Loc(585);
   5: St:=Loc(586);
   6: St:=Loc(587);
   End;
Ez_RequestG(Loc(588),St,'  _OK  |',NUM);{*Display Help*}
End;

{ͻ
                           ERREURS INTERNES A MRE                           
 ͼ}

Procedure ERROR_01;
Var NUM:Integer;
Begin
EZ_REQUESTG(Loc(461),Loc(589),Loc(469),NUM);
End;

{ͻ
                         ABOUT AND REGISTERING INFO                         
 ͼ}

Procedure ABOUT;
Var NUM:Integer;
Begin
EZ_REQUESTG(Loc(590),Loc(591),Loc(469),NUM);
End;

{ͻ
                               SET POS TO 0                                 
 ͼ}

Procedure POS_TO_0;
Begin
Pos_TBB:=0; Pos_TSB:=0;                 {*Positions de Chaque Outils*}
Pos_TXT:=0; Pos_TBU:=0;
Pos_TCY:=0; Pos_TRB:=0;
Pos_TSL:=0; Pos_TCO:=0;
End;

{ͻ
                               SET QTT TO 0                                 
 ͼ}

Procedure QTT_TO_0;
Begin
Qtt_TBB:=0; Qtt_TSB:=0;                 {*Quantit de Chaque Outils*}
Qtt_TXT:=0; Qtt_TBU:=0;
Qtt_TCY:=0; Qtt_TRB:=0;
Qtt_TSL:=0; Qtt_TCO:=0;
End;

{ͻ
               JUSTIFY A DROITE ET EN BAS LES ITEMS DE LA FENETRE           
 ͼ}

Procedure LEFT_JUSTIFY;                 {*Garde Proportions par Rapport Window*}
Var A:Byte;                             {*For Loop*}
    OffX,OffY:Integer;                  {*Variation  Corriger*}
Begin
If Test_Check_Point(M,2,3)=Off Then Exit;{*Pas de Justifications*}
If Win_Exist=False Then Exit;           {*Pas de Fentre*}

OffX:=(W.X2-W.X1)-WSizeX;               {*Calcule Variations*}
OffY:=(W.Y2-W.Y1)-WSizeY;

WSizeX:=W.X2-W.X1;                      {*Stocke Nouvelle Taille*}
WSizeY:=W.Y2-W.Y1;

For A:=1 to Qtt_TBB do Begin            {*Rajuste Bevels*}
   Inc(TBB[A].X2,OffX); Inc(TBB[A].Y2,OffY); End;
For A:=1 to Qtt_TSB do Begin            {*Rajuste String Boxes*}
   Inc(TSB[A].X2,OffX); Inc(TSB[A].Y2,OffY); End;
For A:=1 to Qtt_TXT do Begin            {*Rajuste Textes*}
   Inc(TXT[A].X1,OffX); Inc(TXT[A].Y1,OffY); End;
For A:=1 to Qtt_TBU do Begin            {*Rajuste Boutons*}
   Inc(TBU[A].X1,(OffX Div 2));         {*Bouton Centr en X et Ajust en Y*}
   Inc(TBU[A].Y1,OffY) ;End;
For A:=1 to Qtt_TCY do Begin            {*Rajuste Cyclers*}
   Inc(TCY[A].X1,(OffX Div 2));         {*Bouton Centr en X et Ajust en Y*}
   Inc(TCY[A].Y1,OffY) ;End;
For A:=1 to Qtt_TSL do Begin            {*Rajuste Sliders*}
   Inc(TSL[A].X1,(OffX Div 2));         {*Bouton Centr en X et Ajust en Y*}
   Inc(TSL[A].Y1,OffY);
   Inc(TSL[A].X2,(OffX Div 2));
   Inc(TSL[A].Y2,OffY) ;End;
For A:=1 to Qtt_TCY do                  {*Rajuste Commands*}
   Inc(TCO[A].T.Siz,OffX);
End;

{ͻ
                      REAFFICHE CONTENU FENETRE DE BASE                     
 ͼ}

Procedure REDRAW_WINDOW;                {*Raffiche le Contenu de Window*}
Var A:Byte;                             {*For Loop*}
    OldHaF:Byte;                        {*Old Hauteur Fonte*}
Begin
If Win_Exist=No Then Begin              {*Pas de Fentre => Coord=NULL*}
   W.X1:=0; W.Y1:=0; End;
If Gad_Exist=No Then Exit;              {*Pas de Gadgets  Afficher*}

Draw_Window(W);                         {*Affiche Fentre Test*}
If (W.X2-W.X1<>WSizeX) Or (W.Y2-W.Y1<>WSizeY) Then LEFT_JUSTIFY;{*Justify Dte*}

Clip_Window(On,W);                      {*Clipping des Gadgets*}
For A:=1 to Qtt_TSB do                  {*Draw String Boxes*}
   String_Box(TSB[A].X1, TSB[A].Y1-HaF1, TSB[A].X2,
   TSB[A].Y2-HaF1, TSB[A].Style,TSB[A].Co,TSB[A].Cave);
For A:=1 to Qtt_TBB do                  {*Draw Bevels*}
   Bevel(TBB[A].X1, TBB[A].Y1-HaF1, TBB[A].X2,
   TBB[A].Y2-HaF1, TBB[A].Style,TBB[A].Co,TBB[A].Cave,TBB[A].Fill);
For A:=1 to Qtt_TXT do Begin            {*Draw Texts*}
   SetColor(TXT[A].CP); DispG(TXT[A].X1, TXT[A].Y1-HaF1, TXT[A].CB,TXT[A].Cin); End;
For A:=1 to Qtt_TBU do Begin            {*Draw Buttons*}
   OldHaF:=HaF;
   If TBU[A].SY<>HaF+4 Then HaF:=TBU[A].SY-4;
   If TBU[A].VanillaKey<>0 Then Insert('_',TBU[A].B.TCT[1],TBU[A].VanillaKey);
   Button(TBU[A].X1, TBU[A].Y1-HaF1, TBU[A].SX, TBU[A].B.CoP,
   TBU[A].B.CoB,TBU[A].B.Lock, TBU[A].B ,TBU[A].B.TCT[1]);
   If TBU[A].Freeze=On Then Freeze_Button(On,TBU[A].B);
   HaF:=OldHaF; End;
For A:=1 to Qtt_TCY do Begin            {*Draw Cyclers*}
   OldHaF:=HaF;
   If TCY[A].SY<>HaF+4 Then HaF:=TCY[A].SY-5;
   If TCY[A].VanillaKey<>0 Then Insert('_',TCY[A].Cin,TCY[A].VanillaKey);
   Cycler(TCY[A].X1, TCY[A].Y1-HaF1, TCY[A].SX, TCY[A].B.CyclVal,
   TCY[A].B.CoP,TCY[A].B.CoB, TCY[A].B ,TCY[A].Cin);
   If TCY[A].Freeze=On Then Freeze_Button(On,TCY[A].B);
   HaF:=OldHaF; End;
For A:=1 to Qtt_TRB do Begin            {*Draw Radios*}
   Radio_Box(TRB[A].X1, TRB[A].Y1-HaF1, TRB[A].R.Style, TRB[A].R.Status,TRB[A].R);
   If TRB[A].Freeze=On Then Freeze_Radio(On,TRB[A].R); End;
For A:=1 to Qtt_TSL do Begin            {*Draw Sliders*}
   Slider(TSL[A].X1, TSL[A].Y1-HaF1, TSL[A].X2, TSL[A].Y2-HaF1,
   TSL[A].S.Qtt, TSL[A].S.Aff, TSL[A].S.Typ, TSL[A].S.GDep, TSL[A].S ,TSL[A].S.Psl);
   End;
For A:=1 to Qtt_TCO do Begin            {*Draw Commands*}
   Command(TCO[A].X1, TCO[A].Y1-HaF1, TCO[A].T.Siz, TCO[A].T.Len,
   TCO[A].T.CoB, TCO[A].T.Co2, TCO[A].T.Sty, $26, TCO[A].T ,TCO[A].Cin);
   If TCO[A].Freeze=On Then Freeze_Command(On,TCO[A].T); End;
Clip_Window(Off,W);                     {*Retour au Clipping Normal*}
End;

{ͻ
                       PROCEDURE  SAVE_MRECONFIG                            
 ͼ}

Procedure SAVE_MRECONFIG;
Var NUM:Integer;
    R,G,B:Byte;
    Fil1:Text;                          {*Fichier de Configuration*}

Begin
Assign(Fil1,'MRE.CFG');                 {*Ouvre la Configuration*}
{$I-}
Rewrite(Fil1);
{$I+}
If IOResult=0 Then Begin                {*Pas d'Erreurs ?*}
   Writeln(Fil1,Loc(592));
   Writeln(Fil1,Loc(593));
   Writeln(Fil1,Loc(594));
   Writeln(Fil1,Loc(595));
   Writeln(Fil1);

   Writeln(Fil1,Gen_Prog);              {*Save Booleans and Various Datas*}
   Writeln(Fil1,Gen_Rem);
   Writeln(Fil1,Gen_Menu);
   Writeln(Fil1,Name_Prog);
   Writeln(Fil1,Name_Proc);
   Writeln(Fil1,My_Grid);
   Writeln(Fil1,Pt_Grid);
   Writeln(Fil1,Grid_X);
   Writeln(Fil1,Grid_Y);
   Writeln(Fil1,Disp_Beep);
   Writeln(Fil1,Show_MCoo);
   Writeln(Fil1,Test_Check_Point(M,1,8));
   Writeln(Fil1,Test_Check_Point(M,6,7));
   Writeln(Fil1,Test_Check_Point(M,2,1));
   Writeln(Fil1,Test_Check_Point(M,2,2));
   Writeln(Fil1,Test_Check_Point(M,2,3));
   Close(Fil1);
   EZ_REQUESTG(Loc(461),Loc(596),' _OK |',NUM);
   End
   Else
   EZ_REQUESTG(Loc(461),Loc(597),' _OK |',NUM);
End;

{ͻ
                        PROCEDURE INIT_MRE_CONFIG                           
 ͼ}

Procedure LOAD_MRE_CONFIG;              {*Load And Init MRE Constants*}
Var Col,NUM,E,Code:Integer;
    R,G,B:Byte;
    St:String;
    Fil1:Text;                          {*Fichier de Configuration*}

Begin
Assign(Fil1,'MRE.CFG');                 {*Ouvre la Configuration*}
{$I-}
Reset(Fil1);
{$I+}
If IOResult=0 Then Begin                {*Pas d'Erreurs ?*}
   For E:=1 to 5 do Readln(Fil1);       {*Read Entte*}

   Readln(Fil1,St); If Upper(St)='TRUE' Then Gen_Prog:=True Else Gen_Prog:=False;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Gen_Rem:=True Else Gen_Rem:=False;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Gen_Menu:=True Else Gen_Menu:=False;
   Readln(Fil1,Name_Prog);
   Readln(Fil1,Name_Proc);
   Readln(Fil1,St); If Upper(St)='TRUE' Then My_Grid:=True Else My_Grid:=False;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Pt_Grid:=True Else Pt_Grid:=False;
   Readln(Fil1,Grid_X);
   Readln(Fil1,Grid_Y);
   Readln(Fil1,St); If Upper(St)='TRUE' Then Disp_Beep:=Yes Else Disp_Beep:=No;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Show_MCoo:=Yes Else Show_MCoo:=No;
   Readln(Fil1,St); If Upper(St)='TRUE' Then SET_ID_MENU(M,1,9,$0C) Else SET_ID_MENU(M,1,9,$04);
   Readln(Fil1,St); {If Upper(St)='TRUE' Then SET_ID_MENU(6,8,$0C) Else SET_ID_MENU(6,8,$04);}
   Readln(Fil1,St); If Upper(St)='TRUE' Then SET_ID_MENU(M,2,1,$0C) Else SET_ID_MENU(M,2,1,$04);
   Readln(Fil1,St); If Upper(St)='TRUE' Then SET_ID_MENU(M,2,2,$0C) Else SET_ID_MENU(M,2,2,$04);
   Readln(Fil1,St); If Upper(St)='TRUE' Then SET_ID_MENU(M,2,3,$0C) Else SET_ID_MENU(M,2,3,$04);

   Close(Fil1);
   EZ_REQUESTG(Loc(598),Loc(599),'   _OK   |',NUM);
   End;
End;

{ͻ
                          PROCEDURE DEFINE_BUTTONS                          
 ͼ}

Procedure DEFINE_BUTTONS(Pos:Byte);
Var W1          :Win;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1,But2,
    But3,But4   :ButG;                  {*Bouton Classique*}
    Co1,Co2,Co3,Co4,Co5,Co6,Co7:TCoReq; {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,Cin4,
    Cin5,Cin6,Cin7:String;              {*String Rcupre*}
    Rad1,Rad2,Rad3:Rad;                 {*Pour Radio Evidement*}
    Code,Trans,I:Integer;
    Cancel      :Boolean;               {*Annulation Modifications*}
    X,Y         :Word;                  {*For Grid Parameters*}
    V1,V2       :Integer;               {*Couleurs TC/BGC*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);
String_Box(125,20,320,127,1,6,Off);
Button(LaF*12, 162,LaF*16,0,7,False,But0,'_OK');
Button(LaF*42, 162,LaF*16,0,7,False,But2,Loc(13));
Button(20, 115,85,11,9,False,But1,Loc(600));

Button(140,28,110,11,9,False,But3,Loc(601));
Button(140,47,110,11,9,False,But4,Loc(602));

SetColor(Col[0]);
DispG(60,16,7,Loc(603));
DispG(22,35,7,Loc(604));
DispG(22,55,7,Loc(605));
DispG(22,75,7,Loc(606));
DispG(22,95,7,Loc(607));
DispG(22,136,7,Loc(608));

DispG(140,68,7,Loc(609));
DispG(140,87,7,Loc(610));
DispG(140,106,7,Loc(611));

Radio_Box(279,67,1,Rad1.Status,Rad1);
Radio_Box(279,86,1,Rad2.Status,Rad2);
Radio_Box(279,105,1,Rad3.Status,Rad3);

Command(75,34,30,3,12,13,1,$26,Co1,Cin1);
Command(75,54,30,3,12,13,1,$26,Co2,Cin2);
Command(75,74,30,3,12,13,1,$26,Co3,Cin3);
Command(75,94,30,3,7,13,1,$26,Co4,Cin4);
Command(279,28,30,3,V1,13,1,$26,Co5,Cin5);
Command(279,47,30,3,V2,13,1,$26,Co6,Cin6);
Command(60,135,259,37,12,13,1,$27,Co7,Cin7);

If Rad3.Status=True Then Freeze_Command(On,Co4)    {*Gadget Autoris or No*}
                    Else Freeze_Command(Off,Co4);
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Button Number*}
Init_Window(30,140,376,322+HaF1,$51D9,Loc(612)+Cin1,W1);
Sup_Window(100,50,347,218,59,50,400,250,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Grid:=My_Grid;                          {*Grille Si elle Existe*}
If Test_Check_Point(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
   X:=TBU[Pos].X1; Y:=TBU[Pos].Y1;      {*Calcul New Coordonnes With Steps*}
   Get_Grid_Coord(X,Y);
   TBU[Pos].X1:=X; TBU[Pos].Y1:=Y;
   X:=TBU[Pos].SX;
   Get_Grid_Coord(X,Y);
   TBU[Pos].SX:=X;
End;
Grid:=Off;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TBU[Pos].X1,Cin1); Str(TBU[Pos].Y1,Cin2);{*Init Values*}
Str(TBU[Pos].SX,Cin3); Str(TBU[Pos].SY,Cin4);
Str(TBU[Pos].B.CoB,Cin5); Str(TBU[Pos].B.CoP,Cin6);
Cin7:=TBU[Pos].B.TCT[1];
Rad1.Status:=TBU[Pos].Freeze;           {*Init Radios*}
Rad2.Status:=TBU[Pos].B.Lock;
If TBU[Pos].SY<>HaF+4 Then Rad3.Status:=Off Else Rad3.Status:=On;
If TBU[Pos].VanillaKey<>0 Then          {*Remet Caractre Soulign*}
   Insert('_',Cin7,TBU[Pos].VanillaKey);

V1:=TBU[Pos].B.CoB; V2:=TBU[Pos].B.CoP; {*Couleurs Gadgets*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If GetMsg_Button(But0,1) Then Exit_Flg:=True;
   If GetMsg_Button(But2,1) Then Cancel:=True;
   If GetMsg_Button(But1,1) Then BUTTON_ACTION(Pos);
   If GetMsg_Button(But3,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V1);
      Str(V1,Cin5); REDRAW_FRAME
      End;
   If GetMsg_Button(But4,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V2);
      Str(V2,Cin6); REDRAW_FRAME;
      End;
   GetMsg_Command(Co1,Cin1); GetMsg_Command(Co2,Cin2);
   GetMsg_Command(Co3,Cin3); GetMsg_Command(Co4,Cin4);
   GetMsg_Command(Co5,Cin5); GetMsg_Command(Co6,Cin6);{*Fill Colors And Background*}
   GetMsg_Command(Co7,Cin7);
   GetMsg_Radio(Rad1,1);
   GetMsg_Radio(Rad2,1);
   If GetMsg_Radio(Rad3,1)= True Then
      If Rad3.Status=True
         Then Freeze_Command(On,Co4)    {*Gadget Autoris*}
         Else Freeze_Command(Off,Co4);
   End;

Even:=ACTIVE_WINDOW(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Supprime Fentre*}

If Cancel=Off Then Begin
   TBU[Pos].VanillaKey:=0;              {*De Base si il n'y en a pas*}
   For I:=1 to Length(Cin7) do
      If Copy(Cin7,I,1)='_' Then Begin
         TBU[Pos].VanillaKey:=I;
         End;
   If TBU[Pos].VanillaKey<>0 Then
      Cin7:=Copy(Cin7,1,TBU[Pos].VanillaKey-1)+Copy(Cin7,TBU[Pos].VanillaKey+1,Length(Cin7)-TBU[Pos].VanillaKey);

   Val(Cin1,TBU[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TBU[Pos].Y1,Code);
   Val(Cin3,TBU[Pos].SX,Code);
   Val(Cin4,TBU[Pos].SY,Code);
   TBU[Pos].B.CoB:=V1;
   TBU[Pos].B.CoP:=V2;
   TBU[Pos].B.TCT[1]:=Cin7;
   TBU[Pos].Freeze:=Rad1.Status;
   TBU[Pos].B.Lock:=Rad2.Status;
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   End;

REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
End;

{************************ SELECTION D'UN ITEM BUTTON ************************}

Procedure SELECT_TBU_ITEM(P:Byte);      {*Numro Item*}
Begin
If P<1 Then Exit;                       {*Pas de Box  Effacer*}
SetLineStyle(0,0,3);                    {*Ligne Grosse*}
SetWriteMode(XorPut);
SetColor(7);
HideMouse;
Rectangle(W.X1+TBU[P].X1, W.Y1+TBU[P].Y1, W.X1+TBU[P].X1+TBU[P].SX, W.Y1+TBU[P].Y1+TBU[P].SY);
ShowMouse;
SetWriteMode(NormalPut);
SetLineStyle(0,0,1);                    {*Ligne Fine*}
End;

{ͻ
                            GESTION DES BOUTONS                             
 ͼ}

Procedure GERE_BUTTONS;
Var Ac,Sc:Byte;
    NUM,A:Integer;
    TT:TBevel;                                   {*Pour Transfert Donnes*}
    Lb:LightB;                                   {*Pour Move Light Box*}
    Ga,Mi,Dr:Boolean;                            {*Param Souris*}
    Xm,Ym:Word;                                  {*Position actuelle souris*}
    Exit_Box:Boolean;

Begin
If (GetChar(Ac,Sc)=True) And (Qtt_TBU>0) Then    {*Rotate Selected Gadget*}
   Begin
   If (Sc=80) Or (Sc=77) Or (Upper(Chr(Ac))='+') {*Touche '+' = Bas/Droite*}
   Then Begin
   If Pos_TBU<>0 Then
      SELECT_TBU_ITEM(Pos_TBU);                  {*Efface Ancien Cadre Item*}
   Inc(Pos_TBU);                                 {*Next Item vers le Haut*}
   If Pos_TBU>Qtt_TBU Then Pos_TBU:=1;           {*Last Item Atteint => ROT*}
   SELECT_TBU_ITEM(Pos_TBU);                     {*Entoure New Item*}
   End;

   If (Sc=72) Or (Sc=75) Or (Upper(Chr(Ac))='-') {*Touche '-' = Haut/Gauche*}
   Then Begin
   If Pos_TBU<>0 Then
      SELECT_TBU_ITEM(Pos_TBU);                  {*Efface Ancien Cadre Item*}
   Dec(Pos_TBU);                                 {*Next Item vers le Bas*}
   If Pos_TBU<1 Then Pos_TBU:=Qtt_TBU;           {*Last Item Atteint => ROT*}
   SELECT_TBU_ITEM(Pos_TBU);                     {*Entoure New Item*}
   End;

   If (Ac=13) And (Pos_TBU>0) Then Begin         {*Touche ENTER Presse*}
      CREATE_UNDO;                               {*Cr un Fichier UNDO*}
      SELECT_TBU_ITEM(Pos_TBU);                  {*Dslect Item*}
      DEFINE_BUTTONS(Pos_TBU);                   {*Demande Modification Paramtres*}
      SELECT_TBU_ITEM(Pos_TBU);                  {*Entoure  Nouveau Item*}
      End;

   If (Sc=83) And (Pos_TBU>0) Then Begin         {*Delete Item - Touche Suppr*}
      EZ_REQUESTG(Loc(461),Loc(613),Loc(614),NUM);
      If NUM=1 Then Begin                        {*Go to Delete*}
         SELECT_TBU_ITEM(Pos_TBU);               {*Dslect Item*}
         For A:=Pos_TBU+1 to Qtt_TBU do
            TBU[A-1]:=TBU[A];                    {*Transfre Structure*}
         Dec(Qtt_TBU);                           {*Dcrmente Compteurs*}
         Dec(Pos_TBU);
         If (Qtt_TBU>0) And (Pos_TBU<1) Then Pos_TBU:=1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TBU_ITEM(Pos_TBU);               {*Entoure  Nouveau Item*}
         Has_Changed:=True;                      {*Une Modification a t Faite*}
         End;
      End;
   End;

If (Pos_TBU>0) And                               {*Move Item*}
   ((Special_Key(0)) Or (Special_Key(1))) Then   {*SHIFT to Actionner*}
   Begin
   Lb.X1:=W.X1+TBU[Pos_TBU].X1;                  {*Transmet Coord of Item*}
   Lb.Y1:=W.Y1+TBU[Pos_TBU].Y1;
   Lb.X2:=W.X1+TBU[Pos_TBU].X1+TBU[Pos_TBU].SX;
   Lb.Y2:=W.Y1+TBU[Pos_TBU].Y1+TBU[Pos_TBU].SY;
   Grid:=My_Grid;                                {*Grille Si elle Existe*}
      Repeat
      Exit_Box:=False;
      If Move_Box(Lb,1)=True Then Begin          {*Move Box*}
         SELECT_TBU_ITEM(Pos_TBU);               {*Desentoure l'Item*}
         CREATE_UNDO;                            {*Cr un Fichier UNDO*}
         TBU[Pos_TBU].X1:=Lb.X1-W.X1;            {*Modif Parameters*}
         TBU[Pos_TBU].Y1:=Lb.Y1-W.Y1;
         TBU[Pos_TBU].SX:=Lb.X2-W.X1-TBU[Pos_TBU].X1;
         TBU[Pos_TBU].SY:=Lb.Y2-W.Y1-TBU[Pos_TBU].Y1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TBU_ITEM(Pos_TBU);               {*Entoure  Nouveau Item*}
         Exit_Box:=True;
         End;
      Until (Exit_Box=True) Or (LightB_Status=False);
   Grid:=Off;                                    {*Sucre Grille*}
   End;
                     {*SELECT ITEM BY MOUSE*}
GetMouseG(Xm,Ym,Ga,Mi,Dr);                       {*Rcupre Coord Souris*}
A:=Qtt_TBU;
If ((Xold<>Xm) Or (Yold<>Ym)) And (LightB_Status=False) Then Begin
   While (BoxMouseG(TBU[A].X1+W.X1,TBU[A].Y1+W.Y1, TBU[A].X1+TBU[A].Sx+W.X1,TBU[A].Y1+TBU[A].Sy+W.Y1,10)=False)
      And (A>0) Do Dec(A);
      If (A<>Pos_TBU) and (A<>0) Then Begin
         SELECT_TBU_ITEM(Pos_TBU);                  {*Dsentoure Old Item*}
         Pos_TBU:=A; TIC;
         SELECT_TBU_ITEM(Pos_TBU);                  {*Entoure Nouvel Item*}
         Xold:=Xm; Yold:=Ym;
      End;
   End;
                     {*EDIT ITEM BY DOUBLE CLICK*}
If (BoxMouseG(TBU[Pos_TBU].X1+W.X1,TBU[Pos_TBU].Y1+W.Y1, TBU[Pos_TBU].X1+TBU[Pos_TBU].Sx+W.X1,
   TBU[Pos_TBU].Y1+TBU[Pos_TBU].Sy+W.Y1,10)=True)
   And (Double_Click) Then Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   SELECT_TBU_ITEM(Pos_TBU);                     {*Dsentoure Old Item*}
   DEFINE_BUTTONS(Pos_TBU);
   SELECT_TBU_ITEM(Pos_TBU);                     {*Entoure Nouvel Item*}
   End;

Grid:=My_Grid;                                   {*Utilise Grille si Existe*}
If (Light_Box(Lb1,1)=True) And
   (Lb1.X2-Lb1.X1<>0) Then                       {*Gestion Light_Box*}
   If Qtt_TBU=Max_TBU Then ERROR_01              {*Tableau is Full !!!*}
   Else Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   Inc(Qtt_TBU);                                 {*1 Bevel de plus*}
   SELECT_TBU_ITEM(Pos_TBU);                     {*Efface Old Cadre Item*}
   Pos_TBU:=Qtt_TBU;                             {*Edition du Dernier*}
   TBU[Qtt_TBU].X1:=Lb1.X1-W.X1;                 {*Stocke Coord Relatives*}
   TBU[Qtt_TBU].Y1:=Lb1.Y1-W.Y1;
   TBU[Qtt_TBU].SX:=Lb1.X2-Lb1.X1;

   If (Test_Check_Point(M,2,1)=True) And (Qtt_TBU>1){*Clone Gadgets*}
      Then Begin
      TBU[Qtt_TBU].SY:=TBU[Qtt_TBU-1].SY;
      TBU[Pos_TBU].B.CoB:=TBU[Pos_TBU-1].B.CoB;  {*Set Previous Items Values*}
      TBU[Pos_TBU].B.CoP:=TBU[Pos_TBU-1].B.CoP;
      TBU[Pos_TBU].Freeze:=TBU[Pos_TBU-1].Freeze;
      TBU[Pos_TBU].B.Lock:=TBU[Pos_TBU-1].B.Lock;
      TBU[Pos_TBU].B.TCT[1]:=TBU[Pos_TBU-1].B.TCT[1];
      TBU[Pos_TBU].VanillaKey:=TBU[Pos_TBU-1].VanillaKey;
      End
   Else Begin
      TBU[Qtt_TBU].SY:=HaF+4;
      TBU[Pos_TBU].B.CoB:=7;                     {*Set Defaut Values*}
      TBU[Pos_TBU].B.CoP:=0;
      TBU[Pos_TBU].Freeze:=Off;
      TBU[Pos_TBU].B.Lock:=Off;
      TBU[Pos_TBU].B.TCT[1]:=Loc(615);
      TBU[Pos_TBU].VanillaKey:=1;
      End;

   DEFINE_BUTTONS(Pos_TBU);                      {*Pour Completter Paramtres*}
   SELECT_TBU_ITEM(Pos_TBU);                     {*Affiche New Cadre Item*}
   End;
Grid:=Off;                                       {*Plus de Grille Gnrale*}
End;

{ͻ
                          PROCEDURE DEFINE_CYCLER                           
 ͼ}

Procedure DEFINE_CYCLERS(Pos:Byte);
Var W1          :Win;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1,
    But2,But3   :ButG;                  {*Bouton Classique*}
    Co1,Co2,Co3,Co4,
    Co5,Co6,Co7,Co8:TCoReq;             {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,Cin4,
    Cin5,Cin6,Cin7,Cin8:String;         {*String Rcupre*}
    Rad1,Rad2   :Rad;                   {*Pour Radio Evidement*}
    Code,Trans,I:Integer;
    Cancel      :Boolean;               {*Annulation Modifications*}
    X,Y         :Word;                  {*For Grid Parameters*}
    V1,V2       :Integer;               {*Couleurs TC/BGC*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);
String_Box(125,20,320,127,1,6,Off);
Button(LaF*12, 162,LaF*16,0,7,False,But0,'_OK');
Button(LaF*42, 162,LaF*16,0,7,False,But1,Loc(13));
Button(140,28,110,11,9,False,But2,Loc(601));
Button(140,47,110,11,9,False,But3,Loc(602));

SetColor(Col[0]);
DispG(60,16,7,Loc(603));
DispG(22,35,7,Loc(604));
DispG(22,55,7,Loc(605));
DispG(22,75,7,Loc(606));
DispG(22,95,7,Loc(607));
DispG(22,136,7,Loc(608));
DispG(140,68,7,Loc(616));
DispG(140,87,7,Loc(617));
DispG(140,107,7,Loc(618));

Radio_Box(279,86,1,Rad2.Status,Rad2);
Radio_Box(279,106,1,Rad1.Status,Rad1);

Command(75, 34,30,3,12,13,1,$26,Co1,Cin1);
Command(75, 54,30,3,12,13,1,$26,Co2,Cin2);
Command(75, 74,30,3,12,13,1,$26,Co3,Cin3);
Command(75, 94,30,3,7,13,1,$26,Co4,Cin4);
Command(279,67,30,3,12,13,1,$26,Co8,Cin8);
Command(279,28,30,3,V1,13,1,$26,Co5,Cin5);
Command(279,47,30,3,V2,13,1,$26,Co6,Cin6);
Command(60, 135,259,255,12,13,1,$27,Co7,Cin7);

If Rad2.Status=True Then Freeze_Command(On,Co4)    {*Gadget Autoris or No*}
                    Else Freeze_Command(Off,Co4);
Freeze_Radio(On,Rad2);
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
Init_Window(30,140,376,322+HaF1,$51D9,Loc(619)+Cin1,W1);
Sup_Window(100,50,347,218,59,50,400,250,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Grid:=My_Grid;                          {*Grille Si elle Existe*}
If Test_Check_Point(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
   X:=TCY[Pos].X1; Y:=TCY[Pos].Y1;      {*Calcul New Coordonnes With Steps*}
   Get_Grid_Coord(X,Y);
   TCY[Pos].X1:=X; TCY[Pos].Y1:=Y;
   X:=TCY[Pos].SX; Y:=TCY[Pos].SY;
   Get_Grid_Coord(X,Y);
   TCY[Pos].SX:=X; TCY[Pos].SY:=Y;
End;
Grid:=Off;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TCY[Pos].X1,Cin1); Str(TCY[Pos].Y1,Cin2);{*Init Values*}
Str(TCY[Pos].SX,Cin3); Str(TCY[Pos].SY,Cin4);
Str(TCY[Pos].B.CoB,Cin5); Str(TCY[Pos].B.CoP,Cin6);
Cin7:=TCY[Pos].Cin;
Str(TCY[Pos].B.CyclVal,Cin8);
Rad1.Status:=TCY[Pos].Freeze;
Rad2.Status:=On;                        {*Init Radio*}
If TCY[Pos].VanillaKey<>0 Then          {*Remet Caractre Soulign*}
   Insert('_',Cin7,TCY[Pos].VanillaKey);

V1:=TCY[Pos].B.CoB; V2:=TCY[Pos].B.CoP; {*Couleurs Gadget*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If GetMsg_Button(But0,1)=True Then Exit_Flg:=True;
   If GetMsg_Button(But1,1)=True Then Cancel:=True;
   If GetMsg_Button(But2,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V1);
      Str(V1,Cin5); REDRAW_FRAME;
      End;
   If GetMsg_Button(But3,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V2);
      Str(V2,Cin6); REDRAW_FRAME;
      End;
   GetMsg_Command(Co7,Cin7);
   GetMsg_Command(Co1,Cin1); GetMsg_Command(Co2,Cin2);
   GetMsg_Command(Co3,Cin3); GetMsg_Command(Co4,Cin4);
   GetMsg_Command(Co5,Cin5); GetMsg_Command(Co6,Cin6);{*Fill Colors And Background*}
   GetMsg_Command(Co8,Cin8);
   GetMsg_Radio(Rad1,1);
   If GetMsg_Radio(Rad2,1)= True Then
      If Rad2.Status=True
         Then Freeze_Command(On,Co4)    {*Gadget Autoris*}
         Else Freeze_Command(Off,Co4);
   End;

Even:=Active_Window(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Supprime Fentre*}

If Cancel=Off Then Begin                {*Modification Confirme*}
   TCY[Pos].VanillaKey:=0;              {*De Base si il n'y en a pas*}
   For I:=1 to Length(Cin7) do
      If Copy(Cin7,I,1)='_' Then Begin
         TCY[Pos].VanillaKey:=I;
         End;
   If TCY[Pos].VanillaKey<>0 Then
      Cin7:=Copy(Cin7,1,TCY[Pos].VanillaKey-1)+Copy(Cin7,TCY[Pos].VanillaKey+1,Length(Cin7)-TCY[Pos].VanillaKey);

   Val(Cin1,TCY[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TCY[Pos].Y1,Code);
   Val(Cin3,TCY[Pos].SX,Code);
   Val(Cin4,TCY[Pos].SY,Code);
   TCY[Pos].B.CoB:=V1;
   TCY[Pos].B.CoP:=V2;
   Val(Cin8,TCY[Pos].B.CyclVal,Code);
   TCY[Pos].Cin:=Cin7;
   TCY[Pos].B.Lock:=Rad2.Status;
   TCY[Pos].Freeze:=Rad1.Status;
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   End;

REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
End;

{************************ SELECTION D'UN ITEM CYCLER ************************}

Procedure SELECT_TCY_ITEM(P:Byte);      {*Numro Item*}
Begin
If P<1 Then Exit;                       {*Pas de Box  Effacer*}
SetLineStyle(0,0,3);                    {*Ligne Grosse*}
SetWriteMode(XorPut);
SetColor(7);
HideMouse;
Rectangle(W.X1+TCY[P].X1, W.Y1+TCY[P].Y1, W.X1+TCY[P].X1+TCY[P].SX+18, W.Y1+TCY[P].Y1+TCY[P].SY);
ShowMouse;
SetWriteMode(NormalPut);
SetLineStyle(0,0,1);                    {*Ligne Fine*}
End;

{ͻ
                            GESTION DES CYCLERS                             
 ͼ}

Procedure GERE_CYCLERS;
Var Ac,Sc:Byte;
    NUM,A:Integer;
    TT:TBevel;                                   {*Pour Transfert Donnes*}
    Lb:LightB;                                   {*Pour Move Light Box*}
    Ga,Mi,Dr:Boolean;                            {*Param Souris*}
    Xm,Ym:Word;                                  {*Position actuelle souris*}
    Exit_Box:Boolean;                            {*Sortie du Move_Box*}

Begin
If (GetChar(Ac,Sc)=True) And (Qtt_TCY>0) Then    {*Rotate Selected Gadget*}
   Begin
   If (Sc=80) Or (Sc=77) Or (Upper(Chr(Ac))='+') {*Touche '+' = Bas/Droite*}
   Then Begin
   If Pos_TCY<>0 Then
      SELECT_TCY_ITEM(Pos_TCY);                  {*Efface Ancien Cadre Item*}
   Inc(Pos_TCY);                                 {*Next Item vers le Haut*}
   If Pos_TCY>Qtt_TCY Then Pos_TCY:=1;           {*Last Item Atteint => ROT*}
   SELECT_TCY_ITEM(Pos_TCY);                     {*Entoure New Item*}
   End;

   If (Sc=72) Or (Sc=75) Or (Upper(Chr(Ac))='-') {*Touche '-' = Haut/Gauche*}
   Then Begin
   If Pos_TCY<>0 Then
      SELECT_TCY_ITEM(Pos_TCY);                  {*Efface Ancien Cadre Item*}
   Dec(Pos_TCY);                                 {*Next Item vers le Bas*}
   If Pos_TCY<1 Then Pos_TCY:=Qtt_TCY;           {*Last Item Atteint => ROT*}
   SELECT_TCY_ITEM(Pos_TCY);                     {*Entoure New Item*}
   End;

   If (Ac=13) And (Pos_TCY>0) Then Begin         {*Touche ENTER Presse*}
      CREATE_UNDO;                               {*Cr un Fichier UNDO*}
      SELECT_TCY_ITEM(Pos_TCY);                  {*Dslect Item*}
      DEFINE_CYCLERS(Pos_TCY);                   {*Demande Modification Paramtres*}
      SELECT_TCY_ITEM(Pos_TCY);                  {*Entoure  Nouveau Item*}
      End;

   If (Sc=83) And (Pos_TCY>0) Then Begin         {*Delete Item - Touche Suppr*}
      EZ_RequestG(Loc(461),Loc(613),Loc(614),NUM);
      If NUM=1 Then Begin                        {*Go to Delete*}
         SELECT_TCY_ITEM(Pos_TCY);               {*Dslect Item*}
         For A:=Pos_TCY+1 to Qtt_TCY do
            TCY[A-1]:=TCY[A];                    {*Transfre Structure*}
         Dec(Qtt_TCY);                           {*Dcrmente Compteurs*}
         Dec(Pos_TCY);
         If (Qtt_TCY>0) And (Pos_TCY<1) Then Pos_TCY:=1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TCY_ITEM(Pos_TCY);               {*Entoure  Nouveau Item*}
         Has_Changed:=True;                      {*Une Modification a t Faite*}
         End;
      End;
   End;

If (Pos_TCY>0) And                               {*Move Item*}
   ((Special_Key(0)) Or (Special_Key(1))) Then   {*SHIFT to Actionner*}
   Begin
   Lb.X1:=W.X1+TCY[Pos_TCY].X1;                  {*Transmet Coord of Item*}
   Lb.Y1:=W.Y1+TCY[Pos_TCY].Y1;
   Lb.X2:=W.X1+TCY[Pos_TCY].X1+TCY[Pos_TCY].SX+18;
   Lb.Y2:=W.Y1+TCY[Pos_TCY].Y1+TCY[Pos_TCY].SY;
   Grid:=My_Grid;                                {*Grille Si elle Existe*}
      Repeat
      Exit_Box:=False;
      If Move_Box(Lb,1)=True Then Begin          {*Move Box*}
         SELECT_TCY_ITEM(Pos_TCY);               {*Dsentoure l'Item*}
         CREATE_UNDO;                            {*Cr un Fichier UNDO*}
         TCY[Pos_TCY].X1:=Lb.X1-W.X1;            {*Modif Parameters*}
         TCY[Pos_TCY].Y1:=Lb.Y1-W.Y1;
         TCY[Pos_TCY].SX:=Lb.X2-W.X1-TCY[Pos_TCY].X1-18;
         TCY[Pos_TCY].SY:=Lb.Y2-W.Y1-TCY[Pos_TCY].Y1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TCY_ITEM(Pos_TCY);               {*Entoure  Nouveau Item*}
         Exit_Box:=True;
         End;
      Until (Exit_Box=True) Or (LightB_Status=False);
   Grid:=Off;                                    {*Sucre Grille*}
   End;
                     {*SELECT ITEM BY MOUSE*}
GetMouseG(Xm,Ym,Ga,Mi,Dr);                       {*Rcupre Coord Souris*}
A:=Qtt_TCY;
If ((Xold<>Xm) Or (Yold<>Ym)) And (LightB_Status=False) Then Begin
   While (BoxMouseG(TCY[A].X1+W.X1,TCY[A].Y1+W.Y1, TCY[A].X1+TCY[A].Sx+18+W.X1,TCY[A].Y1+TCY[A].Sy+W.Y1,10)=False)
      And (A>0) Do Dec(A);
      If (A<>Pos_TCY) And (A<>0) Then Begin
         SELECT_TCY_ITEM(Pos_TCY);                  {*Dsentoure Old Item*}
         Pos_TCY:=A; TIC;
         SELECT_TCY_ITEM(Pos_TCY);                  {*Entoure Nouvel Item*}
         Xold:=Xm; Yold:=Ym;
      End;
   End;
                     {*EDIT ITEM BY DOUBLE CLICK*}
If (BoxMouseG(TCY[Pos_TCY].X1+W.X1,TCY[Pos_TCY].Y1+W.Y1, TCY[Pos_TCY].X1+TCY[Pos_TCY].Sx+18+W.X1,
   TCY[Pos_TCY].Y1+TCY[Pos_TCY].Sy+W.Y1,10)=True)
   And (Double_Click) Then Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   SELECT_TCY_ITEM(Pos_TCY);                     {*Dsentoure Old Item*}
   DEFINE_CYCLERS(Pos_TCY);
   SELECT_TCY_ITEM(Pos_TCY);                     {*Entoure Nouvel Item*}
   End;

Grid:=My_Grid;                                   {*Utilise Grille si Existe*}
If (Light_Box(Lb1,1)=True) And
   (Lb1.X2-Lb1.X1<>0) Then                       {*Gestion Light_Box*}
   If Qtt_TCY=Max_TCY Then ERROR_01              {*Tableau is Full !!!*}
   Else Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   Inc(Qtt_TCY);                                 {*1 Bevel de plus*}
   SELECT_TCY_ITEM(Pos_TCY);                     {*Efface Old Cadre Item*}
   Pos_TCY:=Qtt_TCY;                             {*Edition du Dernier*}
   TCY[Qtt_TCY].X1:=Lb1.X1-W.X1;                 {*Stocke Coord Relatives*}
   TCY[Qtt_TCY].Y1:=Lb1.Y1-W.Y1;
   TCY[Qtt_TCY].SX:=Lb1.X2-Lb1.X1-18;            {*Size Less 18 for Image "Cycle"*}

   If (Test_Check_Point(M,2,1)=True) And (Qtt_TCY>1){*Clone Gadgets*}
      Then Begin
      TCY[Qtt_TCY].SY:=TCY[Qtt_TCY-1].SY;
      TCY[Pos_TCY].B.CoB:=TCY[Pos_TCY-1].B.CoB;  {*Set Previous Items Values*}
      TCY[Pos_TCY].B.CoP:=TCY[Pos_TCY-1].B.CoP;
      TCY[Pos_TCY].B.Lock:=TCY[Pos_TCY-1].B.Lock;
      TCY[Pos_TCY].Freeze:=TCY[Pos_TCY-1].Freeze;
      TCY[Pos_TCY].B.CyclVal:=TCY[Pos_TCY-1].B.CyclVal;
      TCY[Pos_TCY].Cin:=TCY[Pos_TCY-1].Cin;
      End
   Else Begin
      TCY[Qtt_TCY].SY:=HaF+4;
      TCY[Pos_TCY].B.CoB:=7;                     {*Set Defaut Values*}
      TCY[Pos_TCY].B.CoP:=0;
      TCY[Pos_TCY].B.Lock:=Off;
      TCY[Pos_TCY].Freeze:=Off;
      TCY[Pos_TCY].B.CyclVal:=1;
      TCY[Pos_TCY].Cin:='LABEL 1|LABEL 2';
      End;

   DEFINE_CYCLERS(Pos_TCY);                      {*Pour Completter Paramtres*}
   SELECT_TCY_ITEM(Pos_TCY);                     {*Affiche New Cadre Item*}
   End;
Grid:=Off;                                       {*Plus de Grille Gnrale*}
End;

{ͻ
                           PROCEDURE DEFINE_RADIO                           
 ͼ}

Procedure DEFINE_RADIOS(Pos:Byte);
Var W1          :Win;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1   :ButG;                  {*Bouton Classique*}
    Cyc0,Cyc1   :ButG;                  {*Bouton Cycler*}
    Co1,Co2,Co4 :TCoReq;                {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin4:String;              {*String Rcupre*}
    Rad2        :Rad;                   {*Pour Radio Evidement*}
    Code,Trans,I:Integer;
    Cancel      :Boolean;               {*Annulation Modifications*}
    X,Y         :Word;                  {*For Grid Parameters*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);
String_Box(125,20,325,107,1,6,Off);
Button(LaF*12, 122,LaF*16,0,7,False,But0,'_OK');
Button(LaF*42, 122,LaF*16,0,7,False,But1,Loc(13));
DispG(60, 16,7,Loc(603));
DispG(22, 35,7,Loc(604));
DispG(22, 55,7,Loc(605));
DispG(140,29,7,Loc(620));
DispG(140,48,7,Loc(621));
DispG(140,67,7,Loc(622));
DispG(140,86,7,Loc(623));

Radio_Box(230,66,1,Rad2.Status,Rad2);

Command(75, 34,30,3,12,13,1,$27,Co1,Cin1);
Command(75, 54,30,3,12,13,1,$26,Co2,Cin2);
Command(230,84,30,3,12,13,1,$26,Co4,Cin4);
Cycler(230, 28,70,Cyc0.CyclVal,0,7,Cyc0,Loc(624));
Cycler(230, 47,70,Cyc1.CyclVal,0,7,Cyc1,Loc(625));

If Cyc0.CyclVal=3 Then Freeze_Command(Off,Co4) Else Freeze_Command(On,Co4);
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
Init_Window(30,180,376,322+HaF1,$51D9,Loc(626)+Cin1,W1);
Sup_Window(100,50,347,218,59,50,400,250,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Grid:=My_Grid;                          {*Grille Si elle Existe*}
If Test_Check_Point(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TRB[Pos].X1; Y:=TRB[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Get_Grid_Coord(X,Y);
TRB[Pos].X1:=X; TRB[Pos].Y1:=Y;
End;
Grid:=Off;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TRB[Pos].X1,Cin1); Str(TRB[Pos].Y1,Cin2);{*Init Values*}
Str(TRB[Pos].Group,Cin4);
Rad2.Status:=TRB[Pos].Freeze;           {*Init Radios*}
Cyc0.CyclVal:=TRB[Pos].R.Style+1;
If TRB[Pos].R.Status=On Then Cyc1.CyclVal:=1 Else Cyc1.CyclVal:=2;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If GetMsg_Button(But0,1)=True Then Exit_Flg:=True;
   If GetMsg_Button(But1,1)=True Then Cancel:=True;
   GetMsg_Command(Co1,Cin1);
   GetMsg_Command(Co2,Cin2);
   GetMsg_Command(Co4,Cin4);
   If GetMsg_Button(Cyc0,1)=True Then
     If Cyc0.CyclVal=3 Then Freeze_Command(Off,Co4)
                       Else Freeze_Command(On,Co4);
   GetMsg_Button(Cyc1,1);
   GetMsg_Radio(Rad2,1);
   End;

Even:=ACTIVE_WINDOW(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Supprime Fentre*}

If Cancel=Off Then Begin
   Val(Cin1,TRB[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TRB[Pos].Y1,Code);
   Val(Cin4,TRB[Pos].Group,Code);
   TRB[Pos].R.Style:=Cyc0.CyclVal-1;
   If Cyc1.CyclVal=1 Then TRB[Pos].R.Status:=On Else TRB[Pos].R.Status:=Off;
   TRB[Pos].Freeze:=Rad2.Status;
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   End;

REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
End;

{************************* SELECTION D'UN ITEM RADIO ************************}

Procedure SELECT_TRB_ITEM(P:Byte);      {*Numro Item*}
Begin
If P<1 Then Exit;                       {*Pas de Box  Effacer*}
SetLineStyle(0,0,3);                    {*Ligne Grosse*}
SetWriteMode(XorPut);
SetColor(7);
HideMouse;
Rectangle(W.X1+TRB[P].X1, W.Y1+TRB[P].Y1, W.X1+TRB[P].X1+19, W.Y1+TRB[P].Y1+4+HaF);
ShowMouse;
SetWriteMode(NormalPut);
SetLineStyle(0,0,1);                    {*Ligne Fine*}
End;

{ͻ
                             GESTION DES RADIOS                             
 ͼ}

Procedure GERE_RADIOS;
Var Ac,Sc:Byte;
    NUM,A:Integer;
    TT:TBevel;                                   {*Pour Transfert Donnes*}
    Lb:LightB;                                   {*Pour Move Light Box*}
    Ga,Mi,Dr:Boolean;                            {*Param Souris*}
    Xm,Ym:Word;                                  {*Position actuelle souris*}
    Exit_Box:Boolean;                            {*Sortie du Move_Box*}

Begin
If (GetChar(Ac,Sc)=True) And (Qtt_TRB>0) Then    {*Rotate Selected Gadget*}
   Begin
   If (Sc=80) Or (Sc=77) Or (Upper(Chr(Ac))='+') {*Touche '+' = Bas/Droite*}
   Then Begin
   If Pos_TRB<>0 Then
      SELECT_TRB_ITEM(Pos_TRB);                  {*Efface Ancien Cadre Item*}
   Inc(Pos_TRB);                                 {*Next Item vers le Haut*}
   If Pos_TRB>Qtt_TRB Then Pos_TRB:=1;           {*Last Item Atteint => ROT*}
   SELECT_TRB_ITEM(Pos_TRB);                     {*Entoure New Item*}
   End;

   If (Sc=72) Or (Sc=75) Or (Upper(Chr(Ac))='-') {*Touche '-' = Haut/Gauche*}
   Then Begin
   If Pos_TRB<>0 Then
      SELECT_TRB_ITEM(Pos_TRB);                  {*Efface Ancien Cadre Item*}
   Dec(Pos_TRB);                                 {*Next Item vers le Bas*}
   If Pos_TRB<1 Then Pos_TRB:=Qtt_TRB;           {*Last Item Atteint => ROT*}
   SELECT_TRB_ITEM(Pos_TRB);                     {*Entoure New Item*}
   End;

   If (Ac=13) And (Pos_TRB>0) Then Begin         {*Touche ENTER Presse*}
      CREATE_UNDO;                               {*Cr un Fichier UNDO*}
      SELECT_TRB_ITEM(Pos_TRB);                  {*Dslect Item*}
      DEFINE_RADIOS(Pos_TRB);                    {*Demande Modification Paramtres*}
      SELECT_TRB_ITEM(Pos_TRB);                  {*Entoure  Nouveau Item*}
      End;

   If (Sc=83) And (Pos_TRB>0) Then Begin         {*Delete Item - Touche Suppr*}
      EZ_REQUESTG(Loc(461),Loc(613),Loc(614),NUM);
      If NUM=1 Then Begin                        {*Go to Delete*}
         SELECT_TRB_ITEM(Pos_TRB);               {*Dslect Item*}
         For A:=Pos_TRB+1 to Qtt_TRB do
            TRB[A-1]:=TRB[A];                    {*Transfre Structure*}
         Dec(Qtt_TRB);                           {*Dcrmente Compteurs*}
         Dec(Pos_TRB);
         If (Qtt_TRB>0) And (Pos_TRB<1) Then Pos_TRB:=1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TRB_ITEM(Pos_TRB);               {*Entoure  Nouveau Item*}
         Has_Changed:=True;                      {*Une Modification a t Faite*}
         End;
      End;
   End;

If (Pos_TRB>0) And                               {*Move Item*}
   ((Special_Key(0)) Or (Special_Key(1))) Then   {*SHIFT to Actionner*}
   Begin
   Lb.X1:=W.X1+TRB[Pos_TRB].X1;                  {*Transmet Coord of Item*}
   Lb.Y1:=W.Y1+TRB[Pos_TRB].Y1;
   Lb.X2:=W.X1+TRB[Pos_TRB].X1+20;
   Lb.Y2:=W.Y1+TRB[Pos_TRB].Y1+HaF+4;
   Grid:=My_Grid;                                {*Grille Si elle Existe*}
      Repeat
      Exit_Box:=False;
      If Move_Box(Lb,1)=True Then Begin          {*Move Box*}
         SELECT_TRB_ITEM(Pos_TRB);               {*Dsentoure l'Item*}
         CREATE_UNDO;                            {*Cr un Fichier UNDO*}
         TRB[Pos_TRB].X1:=Lb.X1-W.X1;            {*Modif Parameters*}
         TRB[Pos_TRB].Y1:=Lb.Y1-W.Y1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TRB_ITEM(Pos_TRB);               {*Entoure  Nouveau Item*}
         Exit_Box:=True;
         End;
      Until (Exit_Box=True) Or (LightB_Status=False);
   Grid:=Off;                                    {*Sucre Grille*}
   End;
                     {*SELECT ITEM BY MOUSE*}
GetMouseG(Xm,Ym,Ga,Mi,Dr);                       {*Rcupre Coord Souris*}
A:=Qtt_TRB;
If ((Xold<>Xm) Or (Yold<>Ym)) And (LightB_Status=False) Then Begin
   While (BoxMouseG(TRB[A].X1+W.X1,TRB[A].Y1+W.Y1, TRB[A].X1+19+W.X1,TRB[A].Y1+4+HaF+W.Y1,10)=False)
      And (A>0) Do Dec(A);
      If (A<>Pos_TRB) and (A<>0) Then Begin
         SELECT_TRB_ITEM(Pos_TRB);               {*Dsentoure Old Item*}
         Pos_TRB:=A; TIC;
         SELECT_TRB_ITEM(Pos_TRB);               {*Entoure Nouvel Item*}
         Xold:=Xm; Yold:=Ym;
      End;
   End;
                     {*EDIT ITEM BY DOUBLE CLICK*}
If (BoxMouseG(TRB[Pos_TRB].X1+W.X1,TRB[Pos_TRB].Y1+W.Y1, TRB[Pos_TRB].X1+19+W.X1,
   TRB[Pos_TRB].Y1+4+HaF+W.Y1,10)=True)
   And (Double_Click) Then Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   SELECT_TRB_ITEM(Pos_TRB);                     {*Dsentoure Old Item*}
   DEFINE_RADIOS(Pos_TRB);
   SELECT_TRB_ITEM(Pos_TRB);                     {*Entoure Nouvel Item*}
   End;

Grid:=My_Grid;                                   {*Utilise Grille si Existe*}
If (Light_Box(Lb1,1)=True) And
   (Lb1.X2-Lb1.X1<>0) Then                       {*Gestion Light_Box*}
   If Qtt_TRB=Max_TRB Then ERROR_01              {*Tableau is Full !!!*}
   Else Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   Inc(Qtt_TRB);                                 {*1 Bevel de plus*}
   SELECT_TRB_ITEM(Pos_TRB);                     {*Efface Old Cadre Item*}
   Pos_TRB:=Qtt_TRB;                             {*Edition du Dernier*}
   TRB[Qtt_TRB].X1:=Lb1.X1-W.X1;                 {*Stocke Coord Relatives*}
   TRB[Qtt_TRB].Y1:=Lb1.Y1-W.Y1;

   If (Test_Check_Point(M,2,1)=True) And (Qtt_TRB>1){*Clone Gadgets*}
      Then Begin
      TRB[Pos_TRB].R.Style:=TRB[Pos_TRB-1].R.Style;{*Set Previous Items Values*}
      TRB[Pos_TRB].R.Status:=TRB[Pos_TRB-1].R.Status;
      TRB[Pos_TRB].Freeze:=TRB[Pos_TRB-1].Freeze;
      TRB[Pos_TRB].Group:=TRB[Pos_TRB-1].Group;
      End
   Else Begin
      TRB[Pos_TRB].R.Style:=1;                   {*Set Defaut Values*}
      TRB[Pos_TRB].R.Status:=On;
      TRB[Pos_TRB].Freeze:=Off;
      TRB[Pos_TRB].Group:=1;
      End;

   DEFINE_RADIOS(Pos_TRB);                       {*Pour Completter Paramtres*}
   SELECT_TRB_ITEM(Pos_TRB);                     {*Affiche New Cadre Item*}
   End;
Grid:=Off;                                       {*Plus de Grille Gnrale*}
End;

{ͻ
                          PROCEDURE DEFINE_SLIDERS                          
 ͼ}

Procedure DEFINE_SLIDERS(Pos:Byte);
Var W1            :Win;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evenements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But0,But1,But2:ButG;                {*Bouton Classique*}
    Cyc0          :ButG;                {*Bouton Cycler*}
    Co1,Co2,Co3,Co4,
    Co5,Co6,Co7   :TCoReq;              {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,Cin4,
    Cin5,Cin6,Cin7:String;              {*String Rcupre*}
    Rad2          :Rad;                 {*Pour Radio Evidement*}
    Code,Trans,I  :Integer;
    Cancel        :Boolean;             {*Annulation Modifications*}
    X,Y           :Word;                {*For Grid Parameters*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);
String_Box(125,20,325,127,1,6,Off);
Button(LaF*12, 142,LaF*16,0,7,False,But0,'_OK');
Button(LaF*42, 142,LaF*16,0,7,False,But1,Loc(13));
Button(20, 115,85,11,9,False,But2,Loc(600));

SetColor(Col[0]);
DispG(60, 16,7,Loc(603));
DispG(22, 35,7,Loc(604));
DispG(22, 55,7,Loc(605));
DispG(22, 75,7,Loc(627));
DispG(22, 95,7,Loc(628));
DispG(140,28,7,Loc(629));
DispG(140,47,7,Loc(630));
DispG(140,68,7,Loc(631));
DispG(140,87,7,Loc(632));
DispG(140,107,7,Loc(633));

Radio_Box(230,106,1,Rad2.Status,Rad2);

Command(75, 34,30,3,12,13,1,$27,Co1,Cin1);
Command(75, 54,30,3,12,13,1,$26,Co2,Cin2);
Command(75, 74,30,3,12,13,1,$26,Co3,Cin3);
Command(75, 94,30,3,12,13,1,$26,Co4,Cin4);
Command(230,28,30,3,12,13,1,$26,Co5,Cin5);
Command(230,47,30,3,12,13,1,$26,Co6,Cin6);
Command(230,68,30,3,12,13,1,$26,Co7,Cin7);
Cycler( 230,87,70,Cyc0.CyclVal,0,7,Cyc0,Loc(634));
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
Init_Window(30,160,376,322+HaF1,$51D9,Loc(635)+Cin1,W1);
Sup_Window(100,50,347,218,59,50,400,250,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Grid:=My_Grid;                          {*Grille Si elle Existe*}
If Test_Check_Point(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TSL[Pos].X1; Y:=TSL[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Get_Grid_Coord(X,Y);
TSL[Pos].X1:=X; TSL[Pos].Y1:=Y;
X:=TSL[Pos].X2; Y:=TSL[Pos].Y2;
Get_Grid_Coord(X,Y);
TSL[Pos].X2:=X; TSL[Pos].Y2:=Y;
End;
Grid:=Off;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TSL[Pos].X1,Cin1); Str(TSL[Pos].Y1,Cin2);{*Init Values*}
Str(TSL[Pos].X2,Cin3); Str(TSL[Pos].Y2,Cin4);
Str(TSL[Pos].S.Qtt,Cin5); Str(TSL[Pos].S.Aff,Cin6);
Str(TSL[Pos].S.Psl,Cin7);
Rad2.Status:=TSL[Pos].S.GDep;           {*Init Radios*}
Cyc0.CyclVal:=TSL[Pos].S.Typ+1;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If GetMsg_Button(But0,1)=True Then Exit_Flg:=True;
   If GetMsg_Button(But1,1)=True Then Cancel:=True;
   If GetMsg_Button(But2,1)=True Then ASK_SLIDER_TO_COMMAND(Pos);
   GetMsg_Command(Co1,Cin1);
   GetMsg_Command(Co2,Cin2);
   GetMsg_Command(Co3,Cin3);
   GetMsg_Command(Co4,Cin4);
   GetMsg_Command(Co5,Cin5);            {*Prefs Fill Colors And Background*}
   GetMsg_Command(Co6,Cin6);
   GetMsg_Command(Co7,Cin7);
   GetMsg_Button(Cyc0,1);
   GetMsg_Radio(Rad2,1);
   End;

Even:=ACTIVE_WINDOW(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Supprime Fentre*}

If Cancel=Off Then Begin
   Val(Cin1,TSL[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TSL[Pos].Y1,Code);
   Val(Cin3,TSL[Pos].X2,Code);
   Val(Cin4,TSL[Pos].Y2,Code);
   Val(Cin5,TSL[Pos].S.Qtt,Code);
   Val(Cin6,TSL[Pos].S.Aff,Code);
   Val(Cin7,TSL[Pos].S.Psl,Code);
   TSL[Pos].S.Typ:=Cyc0.CyclVal-1;
   TSL[Pos].S.GDep:=Rad2.Status;
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   End;

REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
End;

{************************ SELECTION D'UN ITEM SLIDER ************************}

Procedure SELECT_TSL_ITEM(P:Byte);      {*Numro Item*}
Var OffX,OffY:Integer;                  {*Dcalage Box for Buttons*}
Begin
If P<1 Then Exit;                       {*Pas de Box  Effacer*}
SetLineStyle(0,0,3);                    {*Ligne Grosse*}
SetWriteMode(XorPut);
SetColor(7); OffX:=0; OffY:=0;          {*Init Offsets to 0 de Base*}
If TSL[P].S.GDep=On Then                {*Size+40 car Size des Boutons Move*}
   If TSL[P].S.Typ=0 Then OffX:=41 Else OffY:=30;
HideMouse;
Rectangle(W.X1+TSL[P].X1, W.Y1+TSL[P].Y1, W.X1+TSL[P].X2+OffX, W.Y1+TSL[P].Y2+OffY);
ShowMouse;
SetWriteMode(NormalPut);
SetLineStyle(0,0,1);                    {*Ligne Fine*}
End;

{ͻ
                             GESTION DES SLIDERS                            
 ͼ}

Procedure GERE_SLIDERS;
Var Ac,Sc:Byte;
    NUM,A:Integer;
    TT:TBevel;                                   {*Pour Transfert Donnes*}
    OffX,OffY:Integer;                           {*Dcalage Box for Buttons*}
    Lb:LightB;                                   {*Pour Move Light Box*}
    Ga,Mi,Dr:Boolean;                            {*Param Souris*}
    Xm,Ym:Word;                                  {*Position actuelle souris*}
    Exit_Box:Boolean;                            {*Sortie du Move_Box*}

Begin
If (GetChar(Ac,Sc)=True) And (Qtt_TSL>0) Then    {*Rotate Selected Gadget*}
   Begin
   If (Sc=80) Or (Sc=77) Or (Upper(Chr(Ac))='+') {*Touche '+' = Bas/Droite*}
   Then Begin
   If Pos_TSL<>0 Then
      SELECT_TSL_ITEM(Pos_TSL);                  {*Efface Ancien Cadre Item*}
   Inc(Pos_TSL);                                 {*Next Item vers le Haut*}
   If Pos_TSL>Qtt_TSL Then Pos_TSL:=1;           {*Last Item Atteint => ROT*}
   SELECT_TSL_ITEM(Pos_TSL);                     {*Entoure New Item*}
   End;

   If (Sc=72) Or (Sc=75) Or (Upper(Chr(Ac))='-') {*Touche '-' = Haut/Gauche*}
   Then Begin
   If Pos_TSL<>0 Then
      SELECT_TSL_ITEM(Pos_TSL);                  {*Efface Ancien Cadre Item*}
   Dec(Pos_TSL);                                 {*Next Item vers le Bas*}
   If Pos_TSL<1 Then Pos_TSL:=Qtt_TSL;           {*Last Item Atteint => ROT*}
   SELECT_TSL_ITEM(Pos_TSL);                     {*Entoure New Item*}
   End;

   If (Ac=13) And (Pos_TSL>0) Then Begin         {*Touche ENTER Presse*}
      CREATE_UNDO;                               {*Cr un Fichier UNDO*}
      SELECT_TSL_ITEM(Pos_TSL);                  {*Dslect Item*}
      DEFINE_SLIDERS(Pos_TSL);                   {*Demande Modification Paramtres*}
      SELECT_TSL_ITEM(Pos_TSL);                  {*Entoure  Nouveau Item*}
      End;

   If (Sc=83) And (Pos_TSL>0) Then Begin         {*Delete Item - Touche Suppr*}
      EZ_REQUESTG(Loc(461),Loc(613),Loc(614),NUM);
      If NUM=1 Then Begin                        {*Go to Delete*}
         SELECT_TSL_ITEM(Pos_TSL);               {*Dslect Item*}
         For A:=Pos_TSL+1 to Qtt_TSL do
            TSL[A-1]:=TSL[A];                    {*Transfre Structure*}
         Dec(Qtt_TSL);                           {*Dcrmente Compteurs*}
         Dec(Pos_TSL);
         If (Qtt_TSL>0) And (Pos_TSL<1) Then Pos_TSL:=1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TSL_ITEM(Pos_TSL);               {*Entoure  Nouveau Item*}
         Has_Changed:=True;                      {*Une Modification a t Faite*}
         End;
      End;
   End;

OffX:=0; OffY:=0;                                {*Init Offsets to 0 de Base*}
If TSL[Pos_TSL].S.GDep=On Then                   {*Size+40 car Size des Boutons Move*}
   If TSL[Pos_TSL].S.Typ=0 Then OffX:=41 Else OffY:=30;

If (Pos_TSL>0) And                               {*Move Item*}
   ((Special_Key(0)) Or (Special_Key(1))) Then   {*SHIFT to Actionner*}
   Begin
   Lb.X1:=W.X1+TSL[Pos_TSL].X1;                  {*Transmet Coord of Item*}
   Lb.Y1:=W.Y1+TSL[Pos_TSL].Y1;
   Lb.X2:=W.X1+TSL[Pos_TSL].X2+OffX;
   Lb.Y2:=W.Y1+TSL[Pos_TSL].Y2+OffY;
   Grid:=My_Grid;                                {*Grille Si elle Existe*}
      Repeat
      Exit_Box:=False;
      If Move_Box(Lb,1)=True Then Begin          {*Move Box*}
         SELECT_TSL_ITEM(Pos_TSL);               {*Dsentoure l'Item*}
         CREATE_UNDO;                            {*Cr un Fichier UNDO*}
         TSL[Pos_TSL].X1:=Lb.X1-W.X1;            {*Modif Parameters*}
         TSL[Pos_TSL].Y1:=Lb.Y1-W.Y1;
         TSL[Pos_TSL].X2:=Lb.X2-W.X1-OffX;
         TSL[Pos_TSL].Y2:=Lb.Y2-W.Y1-OffY;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TSL_ITEM(Pos_TSL);               {*Entoure  Nouveau Item*}
         Exit_Box:=True;
         End;
      Until (Exit_Box=True) Or (LightB_Status=False);
   Grid:=Off;                                    {*Sucre Grille*}
   End;
                     {*SELECT ITEM BY MOUSE*}
GetMouseG(Xm,Ym,Ga,Mi,Dr);                       {*Rcupre Coord Souris*}
A:=Qtt_TSL;
If ((Xold<>Xm) Or (Yold<>Ym)) And (LightB_Status=False) Then Begin
   While (BoxMouseG(TSL[A].X1+W.X1, TSL[A].Y1+W.Y1, TSL[A].X2+W.X1, TSL[A].Y2+W.Y1,10)=False)
      And (A>0) Do Dec(A);
      If (A<>Pos_TSL) and (A<>0) Then Begin
         SELECT_TSL_ITEM(Pos_TSL);                  {*Dsentoure Old Item*}
         Pos_TSL:=A; TIC;
         SELECT_TSL_ITEM(Pos_TSL);                  {*Entoure Nouvel Item*}
         Xold:=Xm; Yold:=Ym;
      End;
   End;
                     {*EDIT ITEM BY DOUBLE CLICK*}
If (BoxMouseG(TSL[Pos_TSL].X1+W.X1, TSL[Pos_TSL].Y1+W.Y1, TSL[Pos_TSL].X2+W.X1+OffX, TSL[Pos_TSL].Y2+W.Y1+OffY,10)=True)
   And (Double_Click) Then Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   SELECT_TSL_ITEM(Pos_TSL);                     {*Dsentoure Old Item*}
   DEFINE_SLIDERS(Pos_TSL);
   SELECT_TSL_ITEM(Pos_TSL);                     {*Entoure Nouvel Item*}
   End;

Grid:=My_Grid;                                   {*Utilise Grille si Existe*}
If (Light_Box(Lb1,1)=True) And
   (Lb1.X2-Lb1.X1<>0) Then                       {*Gestion Light_Box*}
   If Qtt_TSL=Max_TSL Then ERROR_01              {*Tableau is Full !!!*}
   Else Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   Inc(Qtt_TSL);                                 {*1 Bevel de plus*}
   SELECT_TSL_ITEM(Pos_TSL);                     {*Efface Old Cadre Item*}
   Pos_TSL:=Qtt_TSL;                             {*Edition du Dernier*}
   TSL[Qtt_TSL].X1:=Lb1.X1-W.X1;                 {*Stocke Coord Relatives*}
   TSL[Qtt_TSL].Y1:=Lb1.Y1-W.Y1;
   TSL[Qtt_TSL].X2:=Lb1.X2-W.X1-1;               {*Correct for Good YSize*}
   TSL[Qtt_TSL].Y2:=Lb1.Y2-W.Y1-1;
   If Lb1.X2-Lb1.X1>Lb1.Y2-Lb1.Y1 Then TSL[Pos_TSL].S.Typ:=0 Else TSL[Pos_TSL].S.Typ:=1;

   If (Test_Check_Point(M,2,1)=True) And (Qtt_TSL>1){*Clone Gadgets*}
      Then Begin
      TSL[Pos_TSL].S.Qtt:=TSL[Pos_TSL-1].S.Qtt;  {*Set Previous Items Values*}
      TSL[Pos_TSL].S.Aff:=TSL[Pos_TSL-1].S.Aff;
      TSL[Pos_TSL].S.Psl:=TSL[Pos_TSL-1].S.Psl;
      TSL[Pos_TSL].S.GDep:=TSL[Pos_TSL-1].S.GDep;
      End
   Else Begin
      TSL[Pos_TSL].S.Qtt:=100;                   {*Set Defaut Values*}
      TSL[Pos_TSL].S.Aff:=10;
      TSL[Pos_TSL].S.Psl:=0;
      TSL[Pos_TSL].S.GDep:=On;
      End;

   DEFINE_SLIDERS(Pos_TSL);                      {*Pour Completter Paramtres*}
   SELECT_TSL_ITEM(Pos_TSL);                     {*Affiche New Cadre Item*}
   End;
Grid:=Off;                                       {*Plus de Grille Gnrale*}
End;

{ͻ
                          PROCEDURE DEFINE_COMMANDS                         
 ͼ}

Procedure DEFINE_COMMANDS(Pos:Byte);
Var W1          :Win;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1,
    But2,But3   :ButG;                  {*Bouton Classique*}
    Co1,Co2,Co3,Co4,Co5,Co6,Co7,Co8:TCoReq;{*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,Cin4,
    Cin5,Cin6,Cin7,Cin8:String;         {*String Rcupre*}
    Rad2        :Rad;                   {*Pour Radio Evidement*}
    Code,Trans,I:Integer;
    Cancel      :Boolean;               {*Annulation Modifications*}
    X,Y         :Word;                  {*For Grid Parameters*}
    V1,V2       :Integer;               {*Couleurs TC/BGC*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);
String_Box(125,20,325,125,1,6,Off);
Button(LaF*12, 162,LaF*16,0,7,False,But0,'_OK');
Button(LaF*42, 162,LaF*16,0,7,False,But1,Loc(13));
Button(140,28,110,11,9,False,But2,Loc(636));
Button(140,47,110,11,9,False,But3,Loc(637));

SetColor(Col[0]);
DispG(60, 16,7,Loc(603));
DispG(22, 35,7,Loc(604));
DispG(22, 55,7,Loc(605));
DispG(22, 75,7,Loc(606));
DispG(22, 135,7,Loc(608));
DispG(140,68,7,Loc(638));
DispG(140,87,7,Loc(639));
DispG(140,106,7,Loc(640));

Radio_Box(270,105,1,Rad2.Status,Rad2);

Command(75, 34,30,3,12,13,1,$26,Co1,Cin1);
Command(75, 54,30,3,12,13,1,$26,Co2,Cin2);
Command(75, 74,30,3,12,13,1,$26,Co3,Cin3);
Command(270,28,30,3,V1,13,1,$26,Co5,Cin5);
Command(270,47,30,3,V2,13,1,$26,Co6,Cin6);
Command(270,66,30,3,12,13,1,$26,Co4,Cin4);
Command(270,86,30,3,12,13,1,$26,Co8,Cin8);
Command(60, 135,264,255,12,13,1,$27,Co7,Cin7);
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
Init_Window(30,140,376,322+HaF1,$51D9,Loc(641)+Cin1,W1);
Sup_Window(100,50,347,218,59,50,400,250,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Grid:=My_Grid;                          {*Grille Si elle Existe*}
If Test_Check_Point(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TCO[Pos].X1; Y:=TCO[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Get_Grid_Coord(X,Y);
TCO[Pos].X1:=X; TCO[Pos].Y1:=Y;
X:=TCO[Pos].T.Siz;
Get_Grid_Coord(X,Y);
TCO[Pos].T.Siz:=X;
End;
Grid:=Off;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TCO[Pos].X1,Cin1); Str(TCO[Pos].Y1,Cin2);{*Init Values*}
Str(TCO[Pos].T.Siz,Cin3); Str(TCO[Pos].T.Len,Cin4);
Str(TCO[Pos].T.CoB,Cin5); Str(TCO[Pos].T.Co2,Cin6);
Str(TCO[Pos].T.Sty,Cin8);

Cin7:=TCO[Pos].Cin;
Rad2.Status:=TCO[Pos].Freeze;           {*Init Radios*}

V1:=TCO[Pos].T.CoB; V2:=TCO[Pos].T.Co2; {*Couleurs Gadgets*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If GetMsg_Button(But0,1)=True Then Exit_Flg:=True;
   If GetMsg_Button(But1,1)=True Then Cancel:=True;
   If GetMsg_Button(But2,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V1);
      Str(V1,Cin5); REDRAW_FRAME;
      End;
   If GetMsg_Button(But3,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V2);
      Str(V2,Cin6); REDRAW_FRAME;
      End;
   GetMsg_Command(Co7,Cin7);
   GetMsg_Command(Co1,Cin1); GetMsg_Command(Co2,Cin2);
   GetMsg_Command(Co3,Cin3);
   GetMsg_Command(Co5,Cin5); GetMsg_Command(Co6,Cin6);{*Fill Colors And Background*}
   GetMsg_Command(Co4,Cin4); GetMsg_Command(Co8,Cin8);
   GetMsg_Radio(Rad2,1);
   End;

Even:=ACTIVE_WINDOW(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Supprime Fentre*}

If Cancel=Off Then Begin
   Val(Cin1,TCO[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TCO[Pos].Y1,Code);
   Val(Cin3,TCO[Pos].T.Siz,Code);
   Val(Cin4,TCO[Pos].T.Len,Code);
   TCO[Pos].T.CoB:=V1;
   TCO[Pos].T.Co2:=V2;
   Val(Cin8,TCO[Pos].T.Sty,Code);
   TCO[Pos].Cin:=Cin7;
   TCO[Pos].Freeze:=Rad2.Status;
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   End;

REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
End;

{************************ SELECTION D'UN ITEM COMMAND ***********************}

Procedure SELECT_TCO_ITEM(P:Byte);      {*Numro Item*}
Begin
If P<1 Then Exit;                       {*Pas de Box  Effacer*}
SetLineStyle(0,0,3);                    {*Ligne Grosse*}
SetWriteMode(XorPut);
SetColor(7);
HideMouse;
Rectangle(W.X1+TCO[P].X1, W.Y1+TCO[P].Y1, W.X1+TCO[P].X1+TCO[P].T.Siz, W.Y1+TCO[P].Y1+4+HaF);
ShowMouse;
SetWriteMode(NormalPut);
SetLineStyle(0,0,1);                    {*Ligne Fine*}
End;

{ͻ
                            GESTION DES COMMANDS                            
 ͼ}

Procedure GERE_COMMANDS;
Var Ac,Sc:Byte;
    NUM,A:Integer;
    TT:TBevel;                                   {*Pour Transfert Donnes*}
    Lb:LightB;                                   {*Pour Move Light Box*}
    Ga,Mi,Dr:Boolean;                            {*Param Souris*}
    Xm,Ym:Word;                                  {*Position actuelle souris*}
    Exit_Box:Boolean;                            {*Sortie du Move_Box*}

Begin
If (GetChar(Ac,Sc)=True) And (Qtt_TCO>0) Then    {*Rotate Selected Gadget*}
   Begin
   If (Sc=80) Or (Sc=77) Or (Upper(Chr(Ac))='+') {*Touche '+' = Bas/Droite*}
   Then Begin
   If Pos_TCO<>0 Then
      SELECT_TCO_ITEM(Pos_TCO);                  {*Efface Ancien Cadre Item*}
   Inc(Pos_TCO);                                 {*Next Item vers le Haut*}
   If Pos_TCO>Qtt_TCO Then Pos_TCO:=1;           {*Last Item Atteint => ROT*}
   SELECT_TCO_ITEM(Pos_TCO);                     {*Entoure New Item*}
   End;

   If (Sc=72) Or (Sc=75) Or (Upper(Chr(Ac))='-') {*Touche '-' = Haut/Gauche*}
   Then Begin
   If Pos_TCO<>0 Then
      SELECT_TCO_ITEM(Pos_TCO);                  {*Efface Ancien Cadre Item*}
   Dec(Pos_TCO);                                 {*Next Item vers le Bas*}
   If Pos_TCO<1 Then Pos_TCO:=Qtt_TCO;           {*Last Item Atteint => ROT*}
   SELECT_TCO_ITEM(Pos_TCO);                     {*Entoure New Item*}
   End;

   If (Ac=13) And (Pos_TCO>0) Then Begin         {*Touche ENTER Presse*}
      CREATE_UNDO;                               {*Cr un Fichier UNDO*}
      SELECT_TCO_ITEM(Pos_TCO);                  {*Dslect Item*}
      DEFINE_COMMANDS(Pos_TCO);                  {*Demande Modification Paramtres*}
      SELECT_TCO_ITEM(Pos_TCO);                  {*Entoure  Nouveau Item*}
      End;

   If (Sc=83) And (Pos_TCO>0) Then Begin         {*Delete Item - Touche Suppr*}
      EZ_REQUESTG(Loc(461),Loc(613),Loc(614),NUM);
      If NUM=1 Then Begin                        {*Go to Delete*}
         SELECT_TCO_ITEM(Pos_TCO);               {*Dslect Item*}
         For A:=Pos_TCO+1 to Qtt_TCO do
            TCO[A-1]:=TCO[A];                    {*Transfre Structure*}
         Dec(Qtt_TCO);                           {*Dcrmente Compteurs*}
         Dec(Pos_TCO);
         If (Qtt_TCO>0) And (Pos_TCO<1) Then Pos_TCO:=1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TCO_ITEM(Pos_TCO);               {*Entoure  Nouveau Item*}
         Has_Changed:=True;                      {*Une Modification a t Faite*}
         End;
      End;
   End;

If (Pos_TCO>0) And                               {*Move Item*}
   ((Special_Key(0)) Or (Special_Key(1))) Then   {*SHIFT to Actionner*}
   Begin
   Lb.X1:=W.X1+TCO[Pos_TCO].X1;                  {*Transmet Coord of Item*}
   Lb.Y1:=W.Y1+TCO[Pos_TCO].Y1;
   Lb.X2:=W.X1+TCO[Pos_TCO].X1+TCO[Pos_TCO].T.Siz;
   Lb.Y2:=W.Y1+TCO[Pos_TCO].Y1+HaF+4;
   Grid:=My_Grid;                                {*Grille Si elle Existe*}
      Repeat
      Exit_Box:=False;
      If Move_Box(Lb,1)=True Then Begin          {*Move Box*}
         SELECT_TCO_ITEM(Pos_TCO);               {*Dsentoure l'Item*}
         CREATE_UNDO;                            {*Cr un Fichier UNDO*}
         TCO[Pos_TCO].X1:=Lb.X1-W.X1;            {*Modif Parameters*}
         TCO[Pos_TCO].Y1:=Lb.Y1-W.Y1;
         TCO[Pos_TCO].T.Siz:=Lb.X2-W.X1-TCO[Pos_TCO].X1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TCO_ITEM(Pos_TCO);               {*Entoure  Nouveau Item*}
         Exit_Box:=True;
         End;
      Until (Exit_Box=True) Or (LightB_Status=False);
   Grid:=Off;                                    {*Sucre Grille*}
   End;
                     {*SELECT ITEM BY MOUSE*}
GetMouseG(Xm,Ym,Ga,Mi,Dr);                       {*Rcupre Coord Souris*}
A:=Qtt_TCO;
If ((Xold<>Xm) Or (Yold<>Ym)) And (LightB_Status=False) Then Begin
   While (BoxMouseG(TCO[A].X1+W.X1,TCO[A].Y1+W.Y1, TCO[A].X1+TCO[A].T.Siz+W.X1,TCO[A].Y1+4+HaF+W.Y1,10)=False)
      And (A>0) Do Dec(A);
      If (A<>Pos_TCO) and (A<>0) Then Begin
         SELECT_TCO_ITEM(Pos_TCO);                  {*Dsentoure Old Item*}
         Pos_TCO:=A; TIC;
         SELECT_TCO_ITEM(Pos_TCO);                  {*Entoure Nouvel Item*}
         Xold:=Xm; Yold:=Ym;
      End;
   End;
                     {*EDIT ITEM BY DOUBLE CLICK*}
If (BoxMouseG(TCO[Pos_TCO].X1+W.X1,TCO[Pos_TCO].Y1+W.Y1, TCO[Pos_TCO].X1+TCO[Pos_TCO].T.Siz+W.X1,
   TCO[Pos_TCO].Y1+4+HaF+W.Y1,10)=True)
   And (Double_Click) Then Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   SELECT_TCO_ITEM(Pos_TCO);                     {*Dsentoure Old Item*}
   DEFINE_COMMANDS(Pos_TCO);
   SELECT_TCO_ITEM(Pos_TCO);                     {*Entoure Nouvel Item*}
   End;

Grid:=My_Grid;                                   {*Utilise Grille si Existe*}
If (Light_Box(Lb1,1)=True) And
   (Lb1.X2-Lb1.X1<>0) Then                       {*Gestion Light_Box*}
   If Qtt_TCO=Max_TCO Then ERROR_01              {*Tableau is Full !!!*}
   Else Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   Inc(Qtt_TCO);                                 {*1 Bevel de plus*}
   SELECT_TCO_ITEM(Pos_TCO);                     {*Efface Old Cadre Item*}
   Pos_TCO:=Qtt_TCO;                             {*Edition du Dernier*}
   TCO[Qtt_TCO].X1:=Lb1.X1-W.X1;                 {*Stocke Coord Relatives*}
   TCO[Qtt_TCO].Y1:=Lb1.Y1-W.Y1+1;
   TCO[Qtt_TCO].T.Siz:=Lb1.X2-Lb1.X1;

   If (Test_Check_Point(M,2,1)=True) And (Qtt_TCO>1){*Clone Gadgets*}
      Then Begin
      TCO[Pos_TCO].T.Len:=TCO[Pos_TCO-1].T.Len;  {*Set Previous Items Values*}
      TCO[Pos_TCO].T.CoB:=TCO[Pos_TCO-1].T.CoB;
      TCO[Pos_TCO].T.Co2:=TCO[Pos_TCO-1].T.Co2;
      TCO[Pos_TCO].T.Sty:=TCO[Pos_TCO-1].T.Sty;
      TCO[Pos_TCO].Freeze:=TCO[Pos_TCO-1].Freeze;
      TCO[Pos_TCO].Cin:=TCO[Pos_TCO-1].Cin;
      End
   Else Begin
      TCO[Pos_TCO].T.Len:=100;                   {*Set Defaut Values*}
      TCO[Pos_TCO].T.CoB:=12;
      TCO[Pos_TCO].T.Co2:=13;
      TCO[Pos_TCO].T.Sty:=0;
      TCO[Pos_TCO].Freeze:=Off;
      TCO[Pos_TCO].Cin:=Loc(642);
      End;

   DEFINE_COMMANDS(Pos_TCO);                     {*Pour Completter Paramtres*}
   SELECT_TCO_ITEM(Pos_TCO);                     {*Affiche New Cadre Item*}
   End;
Grid:=Off;                                       {*Plus de Grille Gnrale*}
End;

{ͻ
                         PROCEDURE DEFINE_BEVEL_BOX                         
 ͼ}

Procedure DEFINE_BEVEL_BOX(Pos:Byte);
Var W1          :Win;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1,But2,But3:ButG;           {*Bouton Classique*}
    Co1,Co2,Co3,Co4,Co5,Co6:TCoReq;     {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6:String;              {*String Rcupre*}
    Rad1,Rad2   :Rad;                   {*Pour Radio Evidement*}
    Code        :Integer;
    Cancel      :Boolean;               {*Annulation Modifs*}
    X,Y         :Word;                  {*For Grid Parameters*}
    V1,V2       :Integer;               {*Couleur TC/BGC*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);
String_Box(125,20,325,107,1,6,Off);
Button(LaF*12, 122,LaF*16,0,7,False,But0,'_OK');
Button(LaF*42, 122,LaF*16,0,7,False,But1,Loc(13));
Button(140,28,110,11,9,False,But3,Loc(643));
Button(140,48,110,11,9,False,But2,Loc(601));

SetColor(Col[0]);
DispG(80, 16,7,Loc(644));
DispG(22, 35,7,Loc(604));
DispG(22, 55,7,Loc(605));
DispG(22, 75,7,Loc(627));
DispG(22, 95,7,Loc(628));
DispG(140,68,7,Loc(645));
DispG(140,88,7,Loc(646));

Command(75, 34,30,3,12,13,1,$27,Co1,Cin1);
Command(75, 54,30,3,12,13,1,$26,Co2,Cin2);
Command(75, 74,30,3,12,13,1,$26,Co3,Cin3);
Command(75, 94,30,3,12,13,1,$26,Co4,Cin4);
Command(270,28,30,3,12,13,1,$26,Co5,Cin5);
Command(270,48,30,3,V1,13,1,$26,Co6,Cin6);

Radio_Box(270,68,1,Rad1.Status,Rad1);
Radio_Box(270,88,1,Rad2.Status,Rad2);
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
Init_Window(30,180,376,322+HaF1,$51D9,Loc(647)+Cin1,W1);
Sup_Window(100,50,347,218,59,50,400,250,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Grid:=My_Grid;                          {*Grille Si elle Existe*}
If Test_Check_Point(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TBB[Pos].X1; Y:=TBB[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Get_Grid_Coord(X,Y);
TBB[Pos].X1:=X; TBB[Pos].Y1:=Y;
X:=TBB[Pos].X2; Y:=TBB[Pos].Y2;
Get_Grid_Coord(X,Y);
TBB[Pos].X2:=X; TBB[Pos].Y2:=Y;
End;
Grid:=Off;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TBB[Pos].X1,Cin1); Str(TBB[Pos].Y1,Cin2);{*Init Values*}
Str(TBB[Pos].X2,Cin3); Str(TBB[Pos].Y2,Cin4);
Str(TBB[Pos].Style,Cin5); Str(TBB[Pos].Co,Cin6);
Rad1.Status:=TBB[Pos].Fill;             {*Init Radios*}
Rad2.Status:=TBB[Pos].Cave;

V1:=TBB[Pos].Co; V2:=TBB[Pos].Style;    {*Couleur/Pattern Gadget*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=Off;           {*Flag de Sortie*}

Repeat;
Main_Task;                              {*Gre Systme*}
If Window_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If GetMsg_Button(But0,1)=True Then Exit_Flg:=True;
   If GetMsg_Button(But1,1)=True Then Cancel:=True;
   If GetMsg_Button(But2,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V1);
      Str(V1,Cin6); REDRAW_FRAME;
      End;
   If GetMsg_Button(But3,1) Then Begin
      Pattern_RequestG(80,100,Loc(648),V2);
      Str(V2,Cin5); REDRAW_FRAME;
      End;

   GetMsg_Command(Co1,Cin1); GetMsg_Command(Co2,Cin2);
   GetMsg_Command(Co3,Cin3); GetMsg_Command(Co4,Cin4);
   GetMsg_Command(Co5,Cin5); GetMsg_Command(Co6,Cin6);{*Fill Colors And Background*}
   GetMsg_Radio(Rad1,1); GetMsg_Radio(Rad2,1);
   End;

Even:=ACTIVE_WINDOW(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Suprime Fentre*}

If Cancel=Off Then Begin
   Val(Cin1,TBB[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TBB[Pos].Y1,Code);
   Val(Cin3,TBB[Pos].X2,Code);
   Val(Cin4,TBB[Pos].Y2,Code);
   TBB[Pos].Style:=V2;
   TBB[Pos].Co:=V1;
   TBB[Pos].Fill:=Rad1.Status;
   TBB[Pos].Cave:=Rad2.Status;
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   End;

REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
End;

{********************** SELECTION D'UN ITEM BEVEL BOX ***********************}

Procedure SELECT_TBB_ITEM(P:Byte);      {*Numro Item*}
Begin
If P<1 Then Exit;                       {*Pas de Box  Effacer*}
SetLineStyle(0,0,3);                    {*Ligne Grosse*}
SetWriteMode(XorPut);
SetColor(7);
HideMouse;
Rectangle(W.X1+TBB[P].X1, W.Y1+TBB[P].Y1, W.X1+TBB[P].X2, W.Y1+TBB[P].Y2);
ShowMouse;
SetWriteMode(NormalPut);
SetLineStyle(0,0,1);                    {*Ligne Fine*}
End;

{ͻ
                          GESTION DES BEVELS BOXES                          
 ͼ}

Procedure GERE_BEVEL_BOXES;
Var Ac,Sc:Byte;
    NUM,A:Integer;
    TT:TBevel;                                   {*Pour Transfert Donnes*}
    Lb:LightB;                                   {*Pour Move Light Box*}
    Ga,Mi,Dr:Boolean;                            {*Param Souris*}
    Xm,Ym:Word;                                  {*Position actuelle souris*}
    Exit_Box:Boolean;                            {*Sortie du Move_Box*}

Begin
If (GetChar(Ac,Sc)=True) And (Qtt_TBB>0) Then    {*Rotate Selected Gadget*}
   Begin
   If (Sc=80) Or (Sc=77) Or (Upper(Chr(Ac))='+') {*Touche '+' = Bas/Droite*}
   Then Begin
   If Pos_TBB<>0 Then
      SELECT_TBB_ITEM(Pos_TBB);                  {*Efface Ancien Cadre Item*}
   Inc(Pos_TBB);                                 {*Next Item vers le Haut*}
   If Pos_TBB>Qtt_TBB Then Pos_TBB:=1;           {*Last Item Atteint => ROT*}
   SELECT_TBB_ITEM(Pos_TBB);                     {*Entoure New Item*}
   End;

   If (Sc=72) Or (Sc=75) Or (Upper(Chr(Ac))='-') {*Touche '-' = Haut/Gauche*}
   Then Begin
   If Pos_TBB<>0 Then
      SELECT_TBB_ITEM(Pos_TBB);                  {*Efface Ancien Cadre Item*}
   Dec(Pos_TBB);                                 {*Next Item vers le Bas*}
   If Pos_TBB<1 Then Pos_TBB:=Qtt_TBB;           {*Last Item Atteint => ROT*}
   SELECT_TBB_ITEM(Pos_TBB);                     {*Entoure New Item*}
   End;

   If (Ac=13) And (Pos_TBB>0) Then Begin         {*Touche ENTER Presse*}
      CREATE_UNDO;                               {*Cr un Fichier UNDO*}
      SELECT_TBB_ITEM(Pos_TBB);                  {*Dslect Item*}
      DEFINE_BEVEL_BOX(Pos_TBB);                 {*Demande Modification Paramtres*}
      SELECT_TBB_ITEM(Pos_TBB);                  {*Entoure  Nouveau Item*}
      End;

   If (Sc=83) And (Pos_TBB>0) Then Begin         {*Delete Item - Touche Suppr*}
      EZ_REQUESTG(Loc(461),Loc(613),Loc(614),NUM);
      If NUM=1 Then Begin                        {*Go to Delete*}
         SELECT_TBB_ITEM(Pos_TBB);               {*Dslect Item*}
         For A:=Pos_TBB+1 to Qtt_TBB do
            TBB[A-1]:=TBB[A];                    {*Transfre Structure*}
         Dec(Qtt_TBB);                           {*Dcrmente Compteurs*}
         Dec(Pos_TBB);
         If (Qtt_TBB>0) And (Pos_TBB<1) Then Pos_TBB:=1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TBB_ITEM(Pos_TBB);               {*Entoure  Nouveau Item*}
         Has_Changed:=True;                      {*Une Modification a t Faite*}
         End;
      End;
   End;

If (Pos_TBB>0) And                               {*Move Item*}
   ((Special_Key(0)) Or (Special_Key(1))) Then   {*SHIFT to Actionner*}
   Begin
   Lb.X1:=W.X1+TBB[Pos_TBB].X1;                  {*Transmet Coord of Item*}
   Lb.Y1:=W.Y1+TBB[Pos_TBB].Y1;
   Lb.X2:=W.X1+TBB[Pos_TBB].X2;
   Lb.Y2:=W.Y1+TBB[Pos_TBB].Y2;
   Grid:=My_Grid;                                {*Grille Si elle Existe*}
      Repeat
      Exit_Box:=False;
      If Move_Box(Lb,1)=True Then Begin          {*Move Box*}
         SELECT_TBB_ITEM(Pos_TBB);               {*Dsentoure l'Item*}
         CREATE_UNDO;                            {*Cr un Fichier UNDO*}
         TBB[Pos_TBB].X1:=Lb.X1-W.X1;            {*Modif Parameters*}
         TBB[Pos_TBB].Y1:=Lb.Y1-W.Y1;
         TBB[Pos_TBB].X2:=Lb.X2-W.X1;
         TBB[Pos_TBB].Y2:=Lb.Y2-W.Y1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TBB_ITEM(Pos_TBB);               {*Entoure  Nouveau Item*}
         Exit_Box:=True;
         End;
      Until (Exit_Box=True) Or (LightB_Status=False);
   Grid:=Off;                                    {*Sucre Grille*}
   End;
                     {*SELECT ITEM BY MOUSE*}
GetMouseG(Xm,Ym,Ga,Mi,Dr);                       {*Rcupre Coord Souris*}
A:=Qtt_TBB;
If ((Xold<>Xm) Or (Yold<>Ym)) And (LightB_Status=False) Then Begin
   While (BoxMouseG(TBB[A].X1+W.X1,TBB[A].Y1+W.Y1, TBB[A].X2+W.X1,TBB[A].Y2+W.Y1,10)=False)
      And (A>0) Do Dec(A);
      If (A<>Pos_TBB) and (A<>0) Then Begin
         SELECT_TBB_ITEM(Pos_TBB);                  {*Dsentoure Old Item*}
         Pos_TBB:=A; TIC;
         SELECT_TBB_ITEM(Pos_TBB);                  {*Entoure Nouvel Item*}
         Xold:=Xm; Yold:=Ym;
      End;
   End;
                     {*EDIT ITEM BY DOUBLE CLICK*}
If (BoxMouseG(TBB[Pos_TBB].X1+W.X1,TBB[Pos_TBB].Y1+W.Y1, TBB[Pos_TBB].X2+W.X1,
   TBB[Pos_TBB].Y2+W.Y1,10)=True)
   And (Double_Click) Then Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   SELECT_TBB_ITEM(Pos_TBB);                     {*Dsentoure Old Item*}
   DEFINE_BEVEL_BOX(Pos_TBB);
   SELECT_TBB_ITEM(Pos_TBB);                     {*Entoure Nouvel Item*}
   End;

Grid:=My_Grid;                                   {*Utilise Grille si Existe*}
If (Light_Box(Lb1,1)=True) And
   (Lb1.X2-Lb1.X1<>0) Then                       {*Gestion Light_Box*}
   If Qtt_TBB=Max_TBB Then ERROR_01              {*Tableau is Full !!!*}
   Else Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   Inc(Qtt_TBB);                                 {*1 Bevel de plus*}
   SELECT_TBB_ITEM(Pos_TBB);                     {*Efface Old Cadre Item*}
   Pos_TBB:=Qtt_TBB;                             {*Edition du Dernier*}
   TBB[Qtt_TBB].X1:=Lb1.X1-W.X1;                 {*Stocke Coord Relatives*}
   TBB[Qtt_TBB].Y1:=Lb1.Y1-W.Y1;
   TBB[Qtt_TBB].X2:=Lb1.X2-W.X1;
   TBB[Qtt_TBB].Y2:=Lb1.Y2-W.Y1;

   If (Test_Check_Point(M,2,1)=True) And (Qtt_TBB>1){*Clone Gadgets*}
      Then Begin
      TBB[Pos_TBB].Style:=TBB[Pos_TBB-1].Style;  {*Set Previous Items Values*}
      TBB[Pos_TBB].Co:=TBB[Pos_TBB-1].Co;
      TBB[Pos_TBB].Fill:=TBB[Pos_TBB-1].Fill;
      TBB[Pos_TBB].Cave:=TBB[Pos_TBB-1].Cave;
      End
   Else Begin
      TBB[Pos_TBB].Style:=Bev_Style;             {*Set Defaut Values*}
      TBB[Pos_TBB].Co:=Bev_Coul;
      TBB[Pos_TBB].Fill:=On;
      TBB[Pos_TBB].Cave:=Off;
      End;

   DEFINE_BEVEL_BOX(Pos_TBB);                    {*Pour Completter Paramtres*}
   SELECT_TBB_ITEM(Pos_TBB);                     {*Affiche New Cadre Item*}
   End;
Grid:=Off;                                       {*Plus de Grille Gnrale*}
End;

{ͻ
                        PROCEDURE DEFINE_STRING_BOX                         
 ͼ}

Procedure DEFINE_STRING_BOX(Pos:Byte);
Var W1          :Win;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1,But2,But3:ButG;           {*Bouton Classique*}
    Co1,Co2,Co3,Co4,Co5,Co6:TCoReq;     {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6:String;              {*String Rcupre*}
    Rad1        :Rad;                   {*Pour Radio Evidement*}
    Code        :Integer;
    Cancel      :Boolean;               {*Annulation Modifs*}
    X,Y         :Word;                  {*For Grid Parameters*}
    V1,V2       :Integer;               {*Couleur TC/BGC*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);
String_Box(125,20,325,90,1,6,Off);
Button(LaF*12, 122,LaF*16,0,7,False,But0,'_OK');
Button(LaF*42, 122,LaF*16,0,7,False,But1,Loc(13));
Button(139, 30,115,11,9,False,But3,Loc(643));
Button(139, 50,115,11,9,False,But2,Loc(601));

SetColor(Col[0]);
DispG(80, 16,7,Loc(644));
DispG(22, 35,7,Loc(604));
DispG(22, 55,7,Loc(605));
DispG(22, 75,7,Loc(627));
DispG(22, 95,7,Loc(628));
DispG(140,70,7,Loc(646));

Command(75, 34,30,3,12,13,1,$27,Co1,Cin1);
Command(75, 54,30,3,12,13,1,$26,Co2,Cin2);
Command(75, 74,30,3,12,13,1,$26,Co3,Cin3);
Command(75, 94,30,3,12,13,1,$26,Co4,Cin4);
Command(270,30,30,3,12,13,1,$26,Co5,Cin5);
Command(270,50,30,3,V1,13,1,$26,Co6,Cin6);

Radio_Box(270,70,1,Rad1.Status,Rad1);
Clip_Window(Off,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
Init_Window(30,180,376,322+HaF1,$51D9,Loc(649)+Cin1,W1);
Sup_Window(100,50,347,218,59,50,400,250,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Grid:=My_Grid;                          {*Grille Si elle Existe*}
If Test_Check_Point(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TSB[Pos].X1; Y:=TSB[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Get_Grid_Coord(X,Y);
TSB[Pos].X1:=X; TSB[Pos].Y1:=Y;
X:=TSB[Pos].X2; Y:=TSB[Pos].Y2;
Get_Grid_Coord(X,Y);
TSB[Pos].X2:=X; TSB[Pos].Y2:=Y;
End;
Grid:=Off;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TSB[Pos].X1,Cin1); Str(TSB[Pos].Y1,Cin2);{*Init Values*}
Str(TSB[Pos].X2,Cin3); Str(TSB[Pos].Y2,Cin4);
Str(TSB[Pos].Style,Cin5); Str(TSB[Pos].Co,Cin6);
Rad1.Status:=TSB[Pos].Cave;             {*Init Radios*}

V1:=TSB[Pos].Co; V2:=TSB[Pos].Style;    {*Couleur/Pattern Gadget*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flag de Sortie*}

Repeat;
MAIN_TASK;                              {*Gre Systme*}
If WINDOW_READY(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If GetMsg_Button(But0,1)=True Then Exit_Flg:=True;
   If GetMsg_Button(But1,1)=True Then Cancel:=True;
   If GetMsg_Button(But2,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V1);
      Str(V1,Cin6); REDRAW_FRAME;
      End;
   If GetMsg_Button(But3,1) Then Begin
      Pattern_RequestG(80,100,Loc(648),V2);
      Str(V2,Cin5); REDRAW_FRAME;
      End;

   GetMsg_Command(Co1,Cin1); GetMsg_Command(Co2,Cin2);
   GetMsg_Command(Co3,Cin3); GetMsg_Command(Co4,Cin4);
   GetMsg_Command(Co5,Cin5); GetMsg_Command(Co6,Cin6);
   GetMsg_Radio(Rad1,1);
   End;

Even:=ACTIVE_WINDOW(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Suprime Fentre*}

If Cancel=Off Then Begin
   Val(Cin1,TSB[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TSB[Pos].Y1,Code);
   Val(Cin3,TSB[Pos].X2,Code);
   Val(Cin4,TSB[Pos].Y2,Code);
   TSB[Pos].Style:=V2;
   TSB[Pos].Co:=V1;
   TSB[Pos].Cave:=Rad1.Status;
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   End;

REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
End;

{********************** SELECTION D'UN ITEM STRING BOX **********************}

Procedure SELECT_TSB_ITEM(P:Byte);      {*Numro Item*}
Begin
If P<1 Then Exit;                       {*Pas de Box  Effacer*}
SetLineStyle(0,0,3);                    {*Ligne Grosse*}
SetWriteMode(XorPut);
SetColor(7);
HideMouse;
Rectangle(W.X1+TSB[P].X1, W.Y1+TSB[P].Y1, W.X1+TSB[P].X2, W.Y1+TSB[P].Y2);
ShowMouse;
SetWriteMode(NormalPut);
SetLineStyle(0,0,1);                    {*Ligne Fine*}
End;

{ͻ
                          GESTION DES STRINGS BOXES                         
 ͼ}

Procedure GERE_STRING_BOXES;
Var Ac,Sc:Byte;
    NUM,A:Integer;
    TT:TBevel;                                   {*Pour Transfert Donnes*}
    Lb:LightB;                                   {*Pour Move Light Box*}
    Ga,Mi,Dr:Boolean;                            {*Param Souris*}
    Xm,Ym:Word;                                  {*Position actuelle souris*}
    Exit_Box:Boolean;                            {*Sortie du Move_Box*}

Begin
If (GetChar(Ac,Sc)=True) And (Qtt_TSB>0) Then    {*Rotate Selected Gadget*}
   Begin
   If (Sc=80) Or (Sc=77) Or (Upper(Chr(Ac))='+') {*Touche '+' = Bas/Droite*}
   Then Begin
   If Pos_TSB<>0 Then
      SELECT_TSB_ITEM(Pos_TSB);                  {*Efface Ancien Cadre Item*}
   Inc(Pos_TSB);                                 {*Next Item vers le Haut*}
   If Pos_TSB>Qtt_TSB Then Pos_TSB:=1;           {*Last Item Atteint => ROT*}
   SELECT_TSB_ITEM(Pos_TSB);                     {*Entoure New Item*}
   End;

   If (Sc=72) Or (Sc=75) Or (Upper(Chr(Ac))='-') {*Touche '-' = Haut/Gauche*}
   Then Begin
   If Pos_TSB<>0 Then
      SELECT_TSB_ITEM(Pos_TSB);                  {*Efface Ancien Cadre Item*}
   Dec(Pos_TSB);                                 {*Next Item vers le Bas*}
   If Pos_TSB<1 Then Pos_TSB:=Qtt_TSB;           {*Last Item Atteint => ROT*}
   SELECT_TSB_ITEM(Pos_TSB);                     {*Entoure New Item*}
   End;

   If (Ac=13) And (Pos_TSB>0) Then Begin         {*Touche ENTER Presse*}
      CREATE_UNDO;                               {*Cr un Fichier UNDO*}
      SELECT_TSB_ITEM(Pos_TSB);                  {*Dslect Item*}
      DEFINE_STRING_BOX(Pos_TSB);                {*Demande Modification Paramtres*}
      SELECT_TSB_ITEM(Pos_TSB);                  {*Entoure  Nouveau Item*}
      End;

   If (Sc=83) And (Pos_TSB>0) Then Begin         {*Delete Item - Touche Suppr*}
      EZ_REQUESTG(Loc(461),Loc(613),Loc(614),NUM);
      If NUM=1 Then Begin                        {*Go to Delete*}
         SELECT_TSB_ITEM(Pos_TSB);               {*Dslect Item*}
         For A:=Pos_TSB+1 to Qtt_TSB do
            TSB[A-1]:=TSB[A];                    {*Transfre Structure*}
         Dec(Qtt_TSB);                           {*Dcrmente Compteurs*}
         Dec(Pos_TSB);
         If (Qtt_TSB>0) And (Pos_TSB<1) Then Pos_TSB:=1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TSB_ITEM(Pos_TSB);               {*Entoure  Nouveau Item*}
         Has_Changed:=True;                      {*Une Modification a t Faite*}
         End;
      End;
   End;

If (Pos_TSB>0) And                               {*Move Item*}
   ((Special_Key(0)) Or (Special_Key(1))) Then   {*SHIFT to Actionner*}
   Begin
   Lb.X1:=W.X1+TSB[Pos_TSB].X1;                  {*Transmet Coord of Item*}
   Lb.Y1:=W.Y1+TSB[Pos_TSB].Y1;
   Lb.X2:=W.X1+TSB[Pos_TSB].X2;
   Lb.Y2:=W.Y1+TSB[Pos_TSB].Y2;
   Grid:=My_Grid;                                {*Grille Si elle Existe*}
      Repeat
      Exit_Box:=False;
      If Move_Box(Lb,1)=True Then Begin          {*Move Box*}
         SELECT_TSB_ITEM(Pos_TSB);               {*Dsentoure l'Item*}
         CREATE_UNDO;                            {*Cr un Fichier UNDO*}
         TSB[Pos_TSB].X1:=Lb.X1-W.X1;            {*Modif Parameters*}
         TSB[Pos_TSB].Y1:=Lb.Y1-W.Y1;
         TSB[Pos_TSB].X2:=Lb.X2-W.X1;
         TSB[Pos_TSB].Y2:=Lb.Y2-W.Y1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TSB_ITEM(Pos_TSB);               {*Entoure  Nouveau Item*}
         Exit_Box:=True;
         End;
      Until (Exit_Box=True) Or (LightB_Status=False);
   Grid:=Off;                                    {*Sucre Grille*}
   End;
                     {*SELECT ITEM BY MOUSE*}
GetMouseG(Xm,Ym,Ga,Mi,Dr);                       {*Rcupre Coord Souris*}
A:=Qtt_TSB;
If ((Xold<>Xm) Or (Yold<>Ym)) And (LightB_Status=False) Then Begin
   While (BoxMouseG(TSB[A].X1+W.X1,TSB[A].Y1+W.Y1, TSB[A].X2+W.X1,TSB[A].Y2+W.Y1,10)=False)
      And (A>0) Do Dec(A);
      If (A<>Pos_TSB) and (A<>0) Then Begin
         SELECT_TSB_ITEM(Pos_TSB);                  {*Dsentoure Old Item*}
         Pos_TSB:=A; TIC;
         SELECT_TSB_ITEM(Pos_TSB);                  {*Entoure Nouvel Item*}
         Xold:=Xm; Yold:=Ym;
      End;
   End;
                     {*EDIT ITEM BY DOUBLE CLICK*}
If (BoxMouseG(TSB[Pos_TSB].X1+W.X1,TSB[Pos_TSB].Y1+W.Y1, TSB[Pos_TSB].X2+W.X1,
   TSB[Pos_TSB].Y2+W.Y1,10)=True)
   And (Double_Click) Then Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   SELECT_TSB_ITEM(Pos_TSB);                     {*Dsentoure Old Item*}
   DEFINE_STRING_BOX(Pos_TSB);
   SELECT_TSB_ITEM(Pos_TSB);                     {*Entoure Nouvel Item*}
   End;

Grid:=My_Grid;                                   {*Utilise Grille si Existe*}
If (Light_Box(Lb1,1)=True) And
   (Lb1.X2-Lb1.X1<>0) Then                       {*Gestion Light_Box*}
   If Qtt_TSB=Max_TSB Then ERROR_01              {*Tableau is Full !!!*}
   Else Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   Inc(Qtt_TSB);                                 {*1 Bevel de plus*}
   SELECT_TSB_ITEM(Pos_TSB);                     {*Efface Old Cadre Item*}
   Pos_TSB:=Qtt_TSB;                             {*Edition du Dernier*}
   TSB[Qtt_TSB].X1:=Lb1.X1-W.X1+1;               {*Stocke Coord Relatives*}
   TSB[Qtt_TSB].Y1:=Lb1.Y1-W.Y1+1;
   TSB[Qtt_TSB].X2:=Lb1.X2-W.X1-1;
   TSB[Qtt_TSB].Y2:=Lb1.Y2-W.Y1-1;

   If (Test_Check_Point(M,2,1)=True) And (Qtt_TSB>1){*Clone Gadgets*}
      Then Begin
      TSB[Pos_TSB].Style:=TSB[Pos_TSB-1].Style;  {*Set Previous Items Values*}
      TSB[Pos_TSB].Co:=TSB[Pos_TSB-1].Co;
      TSB[Pos_TSB].Cave:=TSB[Pos_TSB-1].Cave;
      End
   Else Begin
      TSB[Pos_TSB].Style:=Bev_Style;             {*Set Defaut Values*}
      TSB[Pos_TSB].Co:=Bev_Coul;
      TSB[Pos_TSB].Cave:=Off;
      End;

   DEFINE_STRING_BOX(Pos_TSB);                   {*Pour Completter Paramtres*}
   SELECT_TSB_ITEM(Pos_TSB);                     {*Affiche New Cadre Item*}
   End;
Grid:=Off;                                       {*Plus de Grille Gnrale*}
End;

{ͻ
                          PROCEDURE DEFINE_TEXT                             
 ͼ}

Procedure DEFINE_TEXT(Pos:Byte);
Var W1          :Win;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1,But2,
    But3,But4,But5:ButG;                {*Bouton Classique*}
    Com1,Com2,Com3,
    Com4,Com5,Com6,Com7:TCoReq;         {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6,Cin7:String;         {*String Rcupre*}
    Code        :Integer;
    Cancel      :Boolean;               {*Cancel Modifications*}
    X,Y         :Word;                  {*For Grid Parameters*}
    V1,V2       :Integer;               {*Couleurs TC/BGC*}
    FontT,FontS   :Integer;             {*Gestion Requester de Fontes*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Clip_Window(On,W1);                     {*Clipping de la Fentre*}
String_Box( LaF*22+0, HaF*2+1, LaF*63+0, HaF*9+6,1,6,False);
SetColor(0);
DispG( LaF*8, HaF*1+7,7,Loc(650));
DispG( LaF*4, HaF*4+2,7,Loc(604));
DispG( LaF*4, HaF*6+2,7,Loc(605));
DispG( LaF*4, HaF*8+2,7,Loc(644));
DispG( LaF*4, HaF*10+8,7,Loc(642));

Button( LaF*26, HaF*3+1, LaF*24,11,9,False,But1,Loc(601));
Button( LaF*26, HaF*5+1, LaF*24,11,9,False,But2,Loc(602));
Button( LaF*26, HaF*7+1, LaF*24,11,9,False,But3,Loc(719));
Button( LaF*10, HaF*13+6,LaF*16,0,7,False,But4,'_OK');
Button( LaF*40, HaF*13+6,LaF*16,0,7,False,But5,Loc(13));
Command(LaF*14, HaF*4+2, LaF*6,4,12,13,1,$26,Com1,Cin1);
Command(LaF*14, HaF*6+2, LaF*6,4,12,13,1,$26,Com2,Cin2);
Command(LaF*14, HaF*8+2, LaF*6,4,13,13,1,$26,Com3,Cin3);
Command(LaF*11, HaF*10+7,LaF*52,255,12,13,1,$27,Com4,Cin4);
Command(LaF*54, HaF*3+2, LaF*6,3,V1,13,1,$26,Com5,Cin5);
Command(LaF*54, HaF*5+2, LaF*6,3,V2,13,1,$26,Com6,Cin6);
Command(LaF*54, HaF*7+2, LaF*6,5,12,13,1,$26,Com7,Cin7);
Clip_Window(Off,W1);                    {*Restore le Clipping Normal*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
Init_Window(30,180,30+LaF*67+0,180+HaF1+HaF*15+6,$51D9,Loc(651)+Cin1,W1);
Sup_Window(100,50,250,200,59,50,639,479,0,5,$0A00,W1);{*Supplment*}
If NError<>0 Then Exit;                 {*Erreurs Initialisations ?*}
Draw_Window(W1);                        {*Affiche la Fentre*}

Grid:=My_Grid;                          {*Grille Si elle Existe*}
If Test_Check_Point(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TXT[Pos].X1; Y:=TXT[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Get_Grid_Coord(X,Y);
TXT[Pos].X1:=X; TXT[Pos].Y1:=Y;
End;
Grid:=Off;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TXT[Pos].X1,Cin1); Str(TXT[Pos].Y1,Cin2);{*Init Values*}
Cin4:=TXT[Pos].Cin; Str(TextWidth(Cin4),Cin3);
Str(TXT[Pos].CB,Cin5); Str(TXT[Pos].CP,Cin6);
Cin7:='ABC1';
FontT:=2; FontS:=4;                     {*Dfinition Fonte*}

V1:=TXT[Pos].CB; V2:=TXT[Pos].CP;       {*Couleurs Gadgets*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=Off; Cancel:=Off;             {*Flags de Sortie*}

Repeat;
MAIN_TASK;                              {*Gre Systme*}
If WINDOW_READY(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If GetMsg_Button(But4,1)=True Then Exit_Flg:=True;
   If GetMsg_Button(But5,1)=True Then Cancel:=True;
   If GetMsg_Button(But3,1) Then
      Font_RequestG(80,100,Loc(518),FontT,FontS);
   If GetMsg_Button(But1,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V1);
      Str(V1,Cin5); REDRAW_FRAME;
      End;
   If GetMsg_Button(But2,1) Then Begin
      Palette_RequestG(80,100,Loc(518),1,V2);
      Str(V2,Cin6); REDRAW_FRAME;
      End;
   GetMsg_Command(Com1,Cin1); GetMsg_Command(Com2,Cin2);
   GetMsg_Command(Com5,Cin5); GetMsg_Command(Com6,Cin6);
   If GetMsg_Command(Com4,Cin4)=True Then Begin
      Str(TextWidth(Cin4),Cin3);
      Command(W1.X1+LaF*14, W1.Y1+HaF1+HaF*8+2, LaF*6,255,13,13,1,$26+$40,Com3,Cin3);
      End;
   End;

Even:=ACTIVE_WINDOW(W1);
If Even=1 Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=9 Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
Until (Exit_Flg=On) Or (Cancel=On);     {*Flag de Sortie*}

Kill_Window(W1);                        {*Suprime Fentre*}
If Cancel=Off Then Begin
   Val(Cin1,TXT[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TXT[Pos].Y1,Code);
   TXT[Pos].Cin:=Cin4;
   TXT[Pos].CB:=V1;
   TXT[Pos].CP:=V2;
   Has_Changed:=True;                   {*Une Modification a t Faite*}
   End;

REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
End;

{************************ SELECTION D'UN ITEM TEXT **************************}

Procedure SELECT_TXT_ITEM(P:Byte);      {*Numro Item*}
Begin
If P<1 Then Exit;                       {*Pas de Box  Effacer*}
SetLineStyle(0,0,3);                    {*Ligne Grosse*}
SetWriteMode(XorPut);
SetColor(7);
HideMouse;
Rectangle(W.X1+TXT[P].X1-2, W.Y1+TXT[P].Y1, W.X1+TXT[P].X1+TextWidth(TXT[P].Cin)+2, W.Y1+TXT[P].Y1+2+HaF);
ShowMouse;
SetWriteMode(NormalPut);
SetLineStyle(0,0,1);                    {*Ligne Fine*}
End;

{ͻ
                            GESTION DES TEXTES                              
 ͼ}

Procedure GERE_TEXTS;
Var Ac,Sc:Byte;
    NUM,A:Integer;
    TT:TBevel;                                   {*Pour Transfert Donnes*}
    Lb:LightB;                                   {*Pour Move Light Box*}
    Ga,Mi,Dr:Boolean;                            {*Param Souris*}
    Xm,Ym:Word;                                  {*Position actuelle souris*}
    Exit_Box:Boolean;                            {*Sortie du Move_Box*}

Begin
If (GetChar(Ac,Sc)=True) And (Qtt_TXT>0) Then    {*Rotate Selected Gadget*}
   Begin
   If (Sc=80) Or (Sc=77) Or (Upper(Chr(Ac))='+') {*Touche '+' = Bas/Droite*}
   Then Begin
   If Pos_TXT<>0 Then
      SELECT_TXT_ITEM(Pos_TXT);                  {*Efface Ancien Cadre Item*}
   Inc(Pos_TXT);                                 {*Next Item vers le Haut*}
   If Pos_TXT>Qtt_TXT Then Pos_TXT:=1;           {*Last Item Atteint => ROT*}
   SELECT_TXT_ITEM(Pos_TXT);                     {*Entoure New Item*}
   End;

   If (Sc=72) Or (Sc=75) Or (Upper(Chr(Ac))='-') {*Touche '-' = Haut/Gauche*}
   Then Begin
   If Pos_TXT<>0 Then
      SELECT_TXT_ITEM(Pos_TXT);                  {*Efface Ancien Cadre Item*}
   Dec(Pos_TXT);                                 {*Next Item vers le Bas*}
   If Pos_TXT<1 Then Pos_TXT:=Qtt_TXT;           {*Last Item Atteint => ROT*}
   SELECT_TXT_ITEM(Pos_TXT);                     {*Entoure New Item*}
   End;

   If (Ac=13) And (Pos_TXT>0) Then Begin         {*Touche ENTER Presse*}
      CREATE_UNDO;                               {*Cr un Fichier UNDO*}
      SELECT_TXT_ITEM(Pos_TXT);                  {*Dslect Item*}
      DEFINE_TEXT(Pos_TXT);                      {*Demande Modification Paramtres*}
      SELECT_TXT_ITEM(Pos_TXT);                  {*Entoure  Nouveau Item*}
      End;

   If (Sc=83) And (Pos_TXT>0) Then Begin         {*Delete Item - Touche Suppr*}
      EZ_REQUESTG(Loc(461),Loc(613),Loc(614),NUM);
      If NUM=1 Then Begin                        {*Go to Delete*}
         SELECT_TXT_ITEM(Pos_TXT);               {*Dslect Item*}
         For A:=Pos_TXT+1 to Qtt_TXT do
            TXT[A-1]:=TXT[A];                    {*Transfre Structure*}
         Dec(Qtt_TXT);                           {*Dcrmente Compteurs*}
         Dec(Pos_TXT);
         If (Qtt_TXT>0) And (Pos_TXT<1) Then Pos_TXT:=1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TXT_ITEM(Pos_TXT);               {*Entoure  Nouveau Item*}
         Has_Changed:=True;                      {*Une Modification a t Faite*}
         End;
      End;
   End;

If (Pos_TXT>0) And                               {*Move Item*}
   ((Special_Key(0)) Or (Special_Key(1))) Then   {*SHIFT to Actionner*}
   Begin
   Lb.X1:=W.X1+TXT[Pos_TXT].X1-4;                {*Transmet Coord of Item*}
   Lb.Y1:=W.Y1+TXT[Pos_TXT].Y1-1;
   Lb.X2:=W.X1+TXT[Pos_TXT].X1+TextWidth(TXT[Pos_TXT].Cin)+2;
   Lb.Y2:=W.Y1+TXT[Pos_TXT].Y1+HaF+3;
   Grid:=My_Grid;                                {*Grille Si elle Existe*}
      Repeat
      Exit_Box:=False;
      If Move_Box(Lb,1)=True Then Begin          {*Move Box*}
         SELECT_TXT_ITEM(Pos_TXT);               {*Dsentoure l'Item*}
         CREATE_UNDO;                            {*Cr un Fichier UNDO*}
         TXT[Pos_TXT].X1:=Lb.X1-W.X1+4;          {*Modif Parameters*}
         TXT[Pos_TXT].Y1:=Lb.Y1-W.Y1+1;
         REDRAW_WINDOW;                          {*Raffiche All Gadgets in Window*}
         SELECT_TXT_ITEM(Pos_TXT);               {*Entoure  Nouveau Item*}
         Exit_Box:=True;
         End;
      Until (Exit_Box=True) Or (LightB_Status=False);
   Grid:=Off;                                    {*Sucre Grille*}
   End;
                     {*SELECT ITEM BY MOUSE*}
GetMouseG(Xm,Ym,Ga,Mi,Dr);                       {*Rcupre Coord Souris*}
A:=Qtt_TXT;
If ((Xold<>Xm) Or (Yold<>Ym)) And (LightB_Status=False) Then Begin
   While (BoxMouseG(TXT[A].X1+W.X1,TXT[A].Y1+W.Y1, TXT[A].X1+TextWidth(TXT[A].Cin)+2+W.X1,TXT[A].Y1+2+HaF+W.Y1,10)=False)
      And (A>0) Do Dec(A);
      If (A<>Pos_TXT) and (A<>0) Then Begin
         SELECT_TXT_ITEM(Pos_TXT);                  {*Dsentoure Old Item*}
         Pos_TXT:=A; TIC;
         SELECT_TXT_ITEM(Pos_TXT);                  {*Entoure Nouvel Item*}
         Xold:=Xm; Yold:=Ym;
      End;
   End;
                     {*EDIT ITEM BY DOUBLE CLICK*}
If (BoxMouseG(TXT[Pos_TXT].X1+W.X1,TXT[Pos_TXT].Y1+W.Y1, TXT[Pos_TXT].X1+TextWidth(TXT[A].Cin)+2+W.X1,
   TXT[Pos_TXT].Y1+2+HaF+W.Y1,10)=True)
   And (Double_Click) Then Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   SELECT_TXT_ITEM(Pos_TXT);                     {*Dsentoure Old Item*}
   DEFINE_TEXT(Pos_TXT);
   SELECT_TXT_ITEM(Pos_TXT);                     {*Entoure Nouvel Item*}
   End;

Grid:=My_Grid;                                   {*Utilise Grille si Existe*}
If (Light_Box(Lb1,1)=True) And
   (Lb1.X2-Lb1.X1<>0) Then                       {*Gestion Light_Box*}
   If Qtt_TXT=Max_TXT Then ERROR_01              {*Tableau is Full !!!*}
   Else Begin
   CREATE_UNDO;                                  {*Cr un Fichier UNDO*}
   Inc(Qtt_TXT);                                 {*1 Bevel de plus*}
   SELECT_TXT_ITEM(Pos_TXT);                     {*Efface Old Cadre Item*}
   Pos_TXT:=Qtt_TXT;                             {*Edition du Dernier*}
   TXT[Qtt_TXT].X1:=Lb1.X1-W.X1;                 {*Stocke Coord Relatives*}
   TXT[Qtt_TXT].Y1:=Lb1.Y1-W.Y1+1;

   If (Test_Check_Point(M,2,1)=True) And (Qtt_TXT>1){*Clone Gadgets*}
      Then Begin
      TXT[Pos_TXT].CB:=TXT[Pos_TXT-1].CB;        {*Set Color Pen*}
      TXT[Pos_TXT].CP:=TXT[Pos_TXT-1].CP;
      TXT[Pos_TXT].Cin:=TXT[Pos_TXT-1].Cin;
      End
   Else Begin
      TXT[Pos_TXT].CB:=7;                        {*Set Default values*}
      TXT[Pos_TXT].CP:=0;
      TXT[Pos_TXT].Cin:=Loc(642);
      End;

   DEFINE_TEXT(Pos_TXT);                         {*Pour Completter Paramtres*}
   SELECT_TXT_ITEM(Pos_TXT);                     {*Affiche New Cadre Item*}
   End;
Grid:=Off;                                       {*Plus de Grille Gnrale*}
End;

Begin
End.
